
/**
********************************************************************************
* @file       M6678E_CACHE.h
* @brief      CacheֽӿںͼĴ궨塣
* @version    V1.0
* @date       2021.7.20
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef M6678E_CACHE_H_
#define M6678E_CACHE_H_

#include <stdio.h>
#include "stdint.h"
/***************CACHE Ĵ*******************************************************/
#define M6678E_CGEM0_5_REG_BASE_ADDRESS_REGS (0x01840000)

/***************CACHE дС*******************************************************/
#define	L1PCACHE_LINE	32//ֽ
#define	L1DCACHE_LINE	64//ֽ
#define	L2CACHE_LINE	128//ֽ

/**************************************************************************\
* Register Overlay Structure
\**************************************************************************/

typedef enum
{
	CACHE_Inv 				= 0,		/*	CACHE	*/
	CACHE_WriteBack 		= 1,		/*	CACHEд	*/
	CACHE_WriteBack_Inv 	= 2,		/*	CACHEдزЧ	*/
	CACHE_No_Opt			= 3			/*	CACHEά	*/
}CACHE_OPT;

typedef struct  {
    volatile uint32_t L2CFG;		//0X01840000
    volatile uint8_t RSVD21[28];
    volatile uint32_t L1PCFG;		//0X01840020
    volatile uint32_t L1PCC;
    volatile uint8_t RSVD22[24];
    volatile uint32_t L1DCFG;		//0X01840040
    volatile uint32_t L1DCC;
    volatile uint8_t RSVD23[4024];
    volatile uint32_t CPUARBU;		//0X01841000
    volatile uint32_t IDMAARBU;
    volatile uint32_t SDMAARBU;
    volatile uint32_t UCARBU;
    volatile uint32_t MDMAARBU;
    volatile uint8_t RSVD24[44];
    volatile uint32_t CPUARBD;		//0X01841040
    volatile uint32_t IDMAARBD;
    volatile uint32_t SDMAARBD;
    volatile uint32_t UCARBD;
    volatile uint8_t RSVD25[12208];
    volatile uint32_t L2WBAR;		//0X01844000
    volatile uint32_t L2WWC;
    volatile uint8_t RSVD26[8];
    volatile uint32_t L2WIBAR;		//0X01844010
    volatile uint32_t L2WIWC;
    volatile uint32_t L2IBAR;
    volatile uint32_t L2IWC;
    volatile uint32_t L1PIBAR;
    volatile uint32_t L1PIWC;
    volatile uint8_t RSVD27[8];
    volatile uint32_t L1DWIBAR;		//0X01844030
    volatile uint32_t L1DWIWC;
    volatile uint8_t RSVD28[8];
    volatile uint32_t L1DWBAR;		//0X01844040
    volatile uint32_t L1DWWC;
    volatile uint32_t L1DIBAR;
    volatile uint32_t L1DIWC;
    volatile uint8_t RSVD29[4016];
    volatile uint32_t L2WB;			//0X01845000
    volatile uint32_t L2WBINV;
    volatile uint32_t L2INV;
    volatile uint8_t RSVD30[28];
    volatile uint32_t L1PINV;		//0X01845028..
    volatile uint8_t RSVD31[20];
    volatile uint32_t L1DWB;		//0X01845040
    volatile uint32_t L1DWBINV;
    volatile uint32_t L1DINV;
    volatile uint8_t RSVD32[4024];
    volatile uint32_t L2EDSTAT;		//0X01846004
    volatile uint32_t L2EDCMD;
    volatile uint32_t L2EDADDR;
    volatile uint8_t RSVD33[8];
    volatile uint32_t L2EDCPEC;		//0X01846018
    volatile uint32_t L2EDCNEC;
    volatile uint32_t MDMAERR;
    volatile uint32_t MDMAERRCLR;
    volatile uint8_t RSVD34[8];
    volatile uint32_t L2EDCEN;		//0X01846030
    volatile uint8_t RSVD35[976];
    volatile uint32_t L1PEDSTAT;	//0X01846404
    volatile uint32_t L1PEDCMD;
    volatile uint32_t L1PEDADDR;
    volatile uint8_t RSVD36[7152];

    volatile uint32_t MAR[256];			//0X01848000


    volatile uint8_t RSVD37[7168];
    volatile uint32_t L2MPFAR;			//0X0184A400
    volatile uint32_t L2MPFSR;
    volatile uint32_t L2MPFCR;
    volatile uint8_t RSVD38[500];
    volatile uint32_t L2MPPA[32];
    volatile uint8_t RSVD39[384];
    volatile uint32_t L1PMPFAR;
    volatile uint32_t L1PMPFSR;
    volatile uint32_t L1PMPFCR;
    volatile uint8_t RSVD40[564];
    volatile uint32_t L1PMPPA[16];		//0X0184A640
    volatile uint8_t RSVD41[1408];
    volatile uint32_t L1DMPFAR;
    volatile uint32_t L1DMPFSR;
    volatile uint32_t L1DMPFCR;
    volatile uint8_t RSVD42[244];
    volatile uint32_t MPLK[4];
    volatile uint32_t MPLKCMD;
    volatile uint32_t MPLKSTAT;
    volatile uint8_t RSVD43[296];
    volatile uint32_t L1DMPPA[16];
} M6678E_CSL_CgemRegs;


typedef enum {
    /** No Cache    */
    CACHE_L1_0KCACHE  = 0,
    /** 4KB Cache   */
    CACHE_L1_4KCACHE  = 1,
    /** 8KB Cache   */
    CACHE_L1_8KCACHE  = 2,
    /** 16KB Cache  */
    CACHE_L1_16KCACHE = 3,
    /** 32KB Cache  */
    CACHE_L1_32KCACHE = 4
} CACHE_L1Size;


typedef enum {
    /** No Cache     */
    CACHE_0KCACHE   = 0,
    /** 32KB Cache   */
    CACHE_32KCACHE  = 1,
    /** 64KB Cache   */
    CACHE_64KCACHE  = 2,
    /** 128KB Cache  */
    CACHE_128KCACHE = 3,
    /** 256KB Cache  */
    CACHE_256KCACHE = 4,
    /** 512KB Cache  */
    CACHE_512KCACHE = 5
} CACHE_L2Size;

typedef enum
{
    /** No blocking, the call exits after programmation of the
     *  control registers
     */
    CACHE_NOWAIT = 0,

    /** Blocking Call, the call exits after the relevant cache
     *  status registers indicate completion. For block coherence
     *  this waits on the Word count register to be come 0.
     */
    CACHE_WAIT   = 1,

    /** Blocking Call, For block coherence this uses the MFENCE to
     * wait for completion
     */
    CACHE_FENCE_WAIT  = 2
}CACHE_Wait;

extern void CACHE_setL1DSize (CACHE_L1Size newSize);
extern CACHE_L1Size CACHE_getL1DSize();
extern void CACHE_enableCaching(uint8_t mar);
extern void CACHE_disableCaching(uint8_t mar);
extern void CACHE_freezeL1D(void);
extern void CACHE_unfreezeL1D();
extern void CACHE_getMemRegionInfo (uint8_t mar, uint8_t* pcx);
extern void CACHE_setMemRegionInfo (uint8_t mar, uint8_t pcx);
extern uint32_t CACHE_getPrevL1DMode(void);
extern void CACHE_invAllL1dWait (void);
extern void CACHE_invAllL1d (CACHE_Wait wait);
extern void CACHE_wbAllL1dWait (void);
extern void CACHE_wbAllL1d (CACHE_Wait wait);
extern void CACHE_wbInvAllL1dWait (void);
extern void CACHE_wbInvAllL1d (CACHE_Wait wait);
extern void CACHE_invL1dWait (void);
extern void CACHE_invL1d ( void* blockPtr, uint32_t byteCnt, CACHE_Wait wait);
extern void CACHE_wbL1dWait (void);
extern void CACHE_wbL1d (void* blockPtr, uint32_t byteCnt, CACHE_Wait wait);
extern void CACHE_wbInvL1dWait (void);
extern void CACHE_wbInvL1d (void* blockPtr, uint32_t byteCnt, CACHE_Wait wait);
extern void CACHE_setL1PSize (CACHE_L1Size newSize);
extern CACHE_L1Size CACHE_getL1PSize (void);
extern void CACHE_freezeL1P(void);
extern void CACHE_unfreezeL1P(void);
extern uint32_t CACHE_getPrevL1PMode(void);
extern void CACHE_invL1pWait (void);
extern void CACHE_invL1p (void* blockPtr, uint32_t byteCnt,CACHE_Wait  wait);
extern void CACHE_invAllL1pWait (void);
extern void CACHE_invAllL1p (CACHE_Wait wait);
extern void CACHE_setL2Size (CACHE_L2Size newSize);
extern CACHE_L2Size CACHE_getL2Size (void);
extern void CACHE_freezeL2 (void);
extern void CACHE_unfreezeL2 (void);
extern void CACHE_wbL2Wait (void);
extern void CACHE_wbL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait);
extern void CACHE_invL2Wait (void);
extern void CACHE_invL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait);
extern void CACHE_wbInvL2Wait (void);
extern void CACHE_wbInvL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait);
extern void CACHE_wbAllL2Wait (void);
extern void CACHE_wbAllL2 (CACHE_Wait wait);
extern void CACHE_invAllL2Wait (void);
extern void CACHE_invAllL2 (CACHE_Wait wait);
extern void CACHE_wbInvAllL2Wait (void);
extern void CACHE_wbInvAllL2 (CACHE_Wait wait);
#endif /* M6678E_CACHE_H_ */
