/**
********************************************************************************
* @file       M6678E_CrossNet.h
* @brief      M6678E CrossNetԡ
* @version    V1.0
* @date       2020.12.01
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef   _M6678E_CrossNet_H_
#define   _M6678E_CrossNet_H_

#include <c6x.h>


//128bit
#define DMA2TC0     0 
#define DMA3TC0     1 
#define DMA4TC0     2 
#define PCIE        3 
#define H264E       4 
#define XGMAC0      5 
#define XGMAC4      6 
#define DMA2TC1     7 
#define DMA3TC1     8 
#define DMA4TC1     9 
#define USB         10
#define H264D       11
#define XGMAC1      12
#define XGMAC5      13
#define ET          14
#define DMA2TC2     15
#define DMA3TC2     16
#define DMA4TC2     17
#define TCP         18
#define VPIF0       19
#define XGMAC2      20
#define RGMII       21
#define HPI         22
#define DMA2TC3     23
#define DMA3TC3     24
#define DMA4TC3     25
#define VCP         26
#define VPIF1       27
#define XGMAC3      28
#define PCI         29
#define ATA         30
#define UPPI        31
#define UPPQ        32
#define ARM926_0    33
#define ARM926_1    34
#define PNNA	    35

//256bit
#define DSP0        36
#define DSP1        37
#define DSP2        38
#define DSP3        39
#define DSP4        40
#define DSP5        41
#define DSP6        42
#define DSP7        43
#define DMA0TC0     44
#define DMA0TC1     45
#define DMA1TC0     46
#define DMA1TC1     47

//ַչĴ
//128bit
#define CN_DMA2TC0_REGS      0x093000AC  
#define CN_DMA3TC0_REGS      0x093000EC  
#define CN_DMA4TC0_REGS      0x0930012C 
#define CN_PCIE_REGS         0x0930016C 
#define CN_H264E_REGS        0x093001AC 
#define CN_XGMAC0_REGS       0x093001EC 
#define CN_XGMAC4_REGS       0x0930022C 
#define CN_DMA2TC1_REGS      0x0930026C 
#define CN_DMA3TC1_REGS      0x093002AC 
#define CN_DMA4TC1_REGS      0x093002EC 

#define CN_H264D_REGS        0x0930032C
#define CN_XGMAC1_REGS       0x0930036C
#define CN_XGMAC5_REGS       0x093003AC
#define CN_ET_REGS           0x093003EC
#define CN_DMA2TC2_REGS      0x0930042C
#define CN_DMA3TC2_REGS      0x0930046C
#define CN_DMA4TC2_REGS      0x093004AC
#define CN_TCP_REGS          0x093004EC
#define CN_VPIF0_REGS        0x0930052C
#define CN_XGMAC2_REGS       0x0930056C
#define CN_RGMII_REGS        0x093005AC
#define CN_HPI_REGS          0x093005EC
#define CN_DMA2TC3_REGS      0x0930062C
#define CN_DMA3TC3_REGS      0x0930066C
#define CN_DMA4TC3_REGS      0x093006AC

#define CN_VPIF1_REGS        0x093006EC
#define CN_XGMAC3_REGS       0x0930072C
#define CN_PCI_REGS          0x0930076C
#define CN_ATA_REGS          0x093007AC
#define CN_UPPI_REGS         0x093007EC
#define CN_UPPQ_REGS         0x0930082C
#define CN_ARM926_0_REGS     0x0930086C
#define CN_ARM926_1_REGS     0x093008AC
#define CN_PNNA_REGS		 0x093008EC
#define CN_RGMII1_REGS       0x0930092C

//256bit
#define CN_DSP0_REGS         0x09308040
#define CN_DSP1_REGS         0x09308080
#define CN_DSP2_REGS         0x093080C0
#define CN_DSP3_REGS         0x09308100
#define CN_DSP4_REGS         0x09308140
#define CN_DSP5_REGS         0x09308180
#define CN_DSP6_REGS         0x093081C0
#define CN_DSP7_REGS         0x09308200
#define CN_DMA0TC0_REGS      0x09308240
#define CN_DMA0TC1_REGS      0x09308280
#define CN_DMA1TC0_REGS      0x093082C0
#define CN_DMA1TC1_REGS      0x09308300



#define CN_CONFIG_EN         (unsigned int)0x09300000
#define CN_THRESHOLD         (unsigned int)0x09300004


//ȼĴ
#define PRI_BASE             0x09300008


/** @brief This is the definition of CN_XMPAXH */
typedef struct CN_XMPAXH
{
	/*ַ*/
	unsigned int bAddr;

	/*δС */
	unsigned char segSize;
}CN_XMPAXH;

/** @brief This is the definition of CN_XMPAXL */
typedef struct CN_XMPAXL
{
	/*滻ĵַ */
	unsigned int rAddr;
}CN_XMPAXL;

/**************************************************************************\
* Register Overlay Structure for CnXmpaxRegs
\**************************************************************************/
typedef struct  {
    volatile unsigned int XMPAXL;
    volatile unsigned int XMPAXH;
} CnXmpaxRegs;

/**************************************************************************\
* Register Overlay Structure for CnRegs
\**************************************************************************/
typedef struct  {
	CnXmpaxRegs XMPAX[8];//ÿ8Ĵ
} CnRegs;




//ַ
typedef struct  {
    volatile unsigned int MPPA; //
    volatile unsigned int MPSAR;//ʼַ
    volatile unsigned int MPEAR;//ַ
} CN_MEMPROT_MPPARegs;


typedef struct  {
    volatile unsigned int EXADDR;   //쳣ַĴ
    volatile unsigned int EXTYPE;   //쳣ͼĴ
    volatile unsigned int EXTSTATUS;//쳣״̬Ĵ
    volatile unsigned int EXENABLE; //쳣ʹܼĴ
    volatile unsigned int EXCLEAR;  //쳣Ĵ
	CN_MEMPROT_MPPARegs MEMPROT_Host[8];
} CN_MEMPROT_HostRegs;

//256bit磬12
typedef struct  {
	CN_MEMPROT_HostRegs MPPARegs[12];//ַĴ
} CN1MEMPROTRegs;

typedef struct  {
	CN_MEMPROT_HostRegs MPPARegs[36];//ַĴ
} Cn0MEMPROTRegs;


#define hCn0MemprotRegs      ((Cn0MEMPROTRegs *)0x0930096C)
#define hCn1MemprotRegs      ((CN1MEMPROTRegs *)0x093083C0)

//ַ
typedef struct {
	/*Ϊ1ʱΪnon-secureģʽΪ0ʱΪsecureģʽ */
	unsigned int ns;

	/*Ϊ1ʱΪģʽΪ0ʱΪǵģʽ */
	unsigned int emu;

	/*Ϊ1ʱöιԱԶ */
	unsigned int sr;

	/*Ϊ1ʱöιԱд */
	unsigned int sw;

	/*Ϊ1ʱöιԱԶִ*/
	unsigned int sx;

	/*Ϊ1ʱöûԶ */
	unsigned int ur;

	/*Ϊ1ʱöûд */
	unsigned int uw;

	/*Ϊ1ʱöûִ */
	unsigned int ux;
}CN_MEMPROT_MPPA;

typedef struct {
	/*Ϊ1ʱΪnon-secureģʽΪ0ʱΪsecureģʽ */
	unsigned int ns;

	/*Ϊ1ʱΪģʽΪ0ʱΪǵģʽ */
	unsigned int emu;

	/*Ϊ1ʱöιԱԶ */
	unsigned int sr;

	/*Ϊ1ʱöιԱд */
	unsigned int sw;

	/*Ϊ1ʱöιԱԶִ*/
	unsigned int sx;

	/*Ϊ1ʱöûԶ */
	unsigned int ur;

	/*Ϊ1ʱöûд */
	unsigned int uw;

	/*Ϊ1ʱöûִ */
	unsigned int ux;
}MEMPROT_EXTYPE;


/***************CrossNet ӿں***************************************************/
extern void CN_SetXMPAXH(unsigned int host,unsigned int index,CN_XMPAXH* mpaxh);
extern void CN_SetXMPAXL(unsigned int host,unsigned int index,CN_XMPAXL* mpaxl);

extern unsigned int CN_setPriority (unsigned int host,unsigned int priority);
extern void CN_UnLockCrossnet(unsigned int host);
extern void CN_LockCrossnet(unsigned int host);
extern void CN_SetThreshold(unsigned int host,unsigned int Threshold);

extern void MEMPROT_CN_SetProgrammableAddressInfo(unsigned int host,unsigned int index,unsigned int startAddress,unsigned int endAddress,CN_MEMPROT_MPPA * mppa);
extern void MEMPROT_CN_getFaultType(unsigned int host,MEMPROT_EXTYPE * xmcextype);
extern unsigned int MEMPROT_CN_getFaultStatus(unsigned int host);
extern void MEMPROT_CN_clearFault(unsigned int host);
extern unsigned int MEMPROT_CN_getFaultAddress(unsigned int host);
extern void MEMPROT_CN_setExenable(unsigned int host);

		
#endif
