/**
********************************************************************************
* @file       M6678E_DMA.h
* @brief      FT-M6678E DMAֽӿںͼĴ궨塣
* @version    V1.0
* @date       2020.10.26
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef   _M6678E_DMA_H_
#define   _M6678E_DMA_H_

#define DMA0_BASE        0x09100000
/***********************DMA Ĵַ**************************************************/

#define DCHMAP_offset    0x100
#define DMAQNUM_offset   0x240
#define ESR_offset       0x1010
#define EMCR_offset      0x308

#define EESR_offset      0x1030
#define EESHR_offset     0x1034

#define SECR_offset      0x1040
#define OPT_offset       0x4000
#define IESR_offset      0x1060
#define IECR_offset      0x1058
#define IPR_offset       0x1068
#define ICR_offset       0x1070

#define QCHMAP_offset    0x200
#define QDMAQNUM_offset  0x260
#define QEESR_offset     0x108c

//ӰؼĴ
#define DRAE0_offset     0x340
#define DRAEH0_offset    0x344
#define QRAE0_offset     0x380

#define Shadow_IESR_offset      0x60
#define Shadow_IESHR_offset     0x64
#define Shadow_SECR_offset      0x40
#define Shadow_SECHR_offset     0x44
#define Shadow_ESR_offset       0x10
#define Shadow_ESHR_offset      0x14
#define Shadow_IPR_offset       0x68
#define Shadow_IPHR_offset      0x6c
#define Shadow_ICR_offset       0x70
#define Shadow_ICHR_offset      0x74
#define Shadow_QEESR_offset     0x8c
#define ShadowArea0_offset      0x2000

/***********************DMA ӿں**************************************************/
extern void DMA_ParaConfig(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);
extern void DMA_Start(volatile unsigned int DMA_Numb , volatile unsigned int Numb);
extern int  DMA_TransState(volatile unsigned int DMA_Numb , volatile unsigned int Numb);
extern void QDMA_ParaConfig_Start(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);
extern int  QDMA_TransState(volatile unsigned int DMA_Numb , volatile unsigned int Numb);
extern void DMA_LINK_Config(volatile unsigned int DMA_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);
extern void DMA_ShadowArea_Config(volatile unsigned int DMA_Numb,volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);
extern void DMA_ShadowArea_Start(volatile unsigned int DMA_Numb,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb);
extern int  DMA_ShadowArea_TransState(volatile unsigned int DMA_Numb,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb);
extern void QDMA_ShadowArea_ParaConfig_Start(volatile unsigned int DMA_Numb,volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);
extern int  QDMA_ShadowArea_TransState(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb, volatile unsigned int Numb);
extern void DMA_Syn_Event_ParaConfig(volatile unsigned int DMA_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable);

#endif /*_M6678E_DMA_H_*/
