/**
********************************************************************************
* @file       M6678E_GMAC.h
* @brief      M6678E GMACֽӿںͼĴ궨
* @version    V1.0
* @date       2022.04.22
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/

#ifndef GMAC_H_
#define GMAC_H_

#include "stdint.h"
#include "c6x.h"

#define PKT_SIZE_FRAMEBUF   (1664)			/* ݺͽݵbufС	*/
#define TDESCount  32						/* 			*/
#define RDESCount  64						/* 			*/
#define DESCount   (TDESCount+RDESCount)	/* ܸ				*/

/*	ģʽ		*/
typedef enum
{
	Speed10Mbps=0,
	Speed100Mbps=1,
	Speed1000Mbps=2
}SpeedMode;
/*	˫ģʽ		*/
typedef enum
{
	HalfDuplex=0,
	FullDuplex=1
}DuplexMode;
/*	/˫ģʽ	*/
typedef enum
{
	Ether_10MbpsHalfDuplex  =0,
	Ether_10MbpsFullDuplex  =1,
	Ether_100MbpsHalfDuplex =2,
	Ether_100MbpsFullDuplex =3,
	Ether_1000MbpsFullDuplex=4
}Ethernet_Speed_Mode;


/*	GMAC0/GMAC1	*/
typedef struct _GMAC_Desc
{
	volatile uint32_t DES0;
	volatile uint32_t DES1;
	volatile uint32_t DES2;
	volatile uint32_t DES3;
	volatile uint32_t RECV[12];			//ռ䣨DDR,SMC,L2L1D_CACHEʱL1Dcache_line 64bytes
//	volatile uint32_t RECV[28];			///ռ䣨DDRL2 CACHEʱL2cacheline 128bytes
} GMAC_Desc;

/*
 * FT Regs Definitions
 */
/*	GMACڲDMAģ/MACģļĴַ	*/
#define GMAC_DMA_BASE            (0x04201000)
#define GMAC_MAC_BASE            (0x04200000)

/*	GMAC0/GMAC1ڲDMAģĴ	*/
typedef struct
{
	volatile uint32_t DMA0;
	volatile uint32_t DMA1;
	volatile uint32_t DMA2;
	volatile uint32_t DMA3;
	volatile uint32_t DMA4;
	volatile uint32_t DMA5;
	volatile uint32_t DMA6;
	volatile uint32_t DMA7;
	volatile uint32_t DMA8;
	volatile uint32_t DMA9;
	volatile uint32_t DMA10;
	volatile uint32_t DMA11;
	volatile uint8_t  RSVD0[24]; //24=4*(18-11-1)
	volatile uint32_t DMA18;
	volatile uint32_t DMA19;
	volatile uint32_t DMA20;
	volatile uint32_t DMA21;
	volatile uint32_t DMA22;
	volatile uint8_t  RSVD1[212];
	volatile uint32_t DMA76;
	volatile uint8_t  RSVD2[44];
}DMARegs;
/*	GMAC0/GMAC1ڲMACģĴ	*/
typedef struct
{
	volatile uint32_t MAC0;
	volatile uint32_t MAC1;
	volatile uint32_t MAC2;
	volatile uint32_t MAC3;
	volatile uint32_t MAC4;
	volatile uint32_t MAC5;
	volatile uint32_t MAC6;
	volatile uint32_t MAC7;
	volatile uint32_t MAC8;
	volatile uint32_t MAC9;
	volatile uint8_t  RSVD3[8];
	volatile uint32_t MAC12;
	volatile uint32_t MAC13;
	volatile uint32_t MAC14;
	volatile uint32_t MAC15;
	volatile uint32_t MAC16;
	volatile uint32_t MAC17;
	volatile uint32_t MAC18;
	volatile uint32_t MAC19;
	volatile uint32_t MAC20;
	volatile uint32_t MAC21;
	volatile uint8_t  RSVD4[128];
	volatile uint32_t MAC54;
}MACRegs;


extern void Gmac_Open_Clk();
extern void Gmac_Close_Clk();
extern void Gmac_SystemClk();
extern void Gmac_DMA_DescList( GMAC_Desc * DESC, uint8_t *BufMem);
extern void Gmac_DMA_RxDescList( uint32_t DescListAddr);
extern void Gmac_DMA_TxDescList( uint32_t DescListAddr);
extern void Gmac_DMA_SoftReset();
extern void Gmac_DMA_BusOptMode();
extern void Gmac_DMA_RxPollDemand();
extern void Gmac_DMA_TxPollDemand();
extern void Gmac_DMA_OptMode_SF();
extern void Gmac_DMA_OptMode_TF();
extern void Gmac_DMA_InterruptEna();
extern void Gmac_DMA_InterruptDisa();
extern void Gmac_DMA_CheckAXIStatu();
extern void Gmac_DMA_AXIOptMode();
extern uint32_t Gmac_DMA_GetStaus();
extern void Gmac_DMA_ClrStaus(uint32_t val);
extern uint32_t Gmac_DMA_GetCurTxDesc();
extern uint32_t Gmac_DMA_GetCurRxDesc();
extern uint32_t Gmac_DMA_GetCurTxBuf();
extern uint32_t Gmac_DMA_GetCurRxBuf();
extern void Gmac_DMA_RxEna();
extern void Gmac_DMA_RxDisa();
extern void Gmac_DMA_TxEna();
extern void Gmac_DMA_TxDisa();

extern void Gmac_MAC_SetHashRegs(uint32_t Hash1,uint32_t Hash2);
extern void Gmac_MAC_GetHashRegs(uint32_t *Hash1,uint32_t *Hash2);

extern int Gmac_MAC_GetLinkChange();
extern void Gmac_MAC_SetOptMode(SpeedMode Speed,DuplexMode  Duplex);
extern void Gmac_MAC_SetLoopBack();
extern void Gmac_MAC_RGMII_WaitPHYLink();
extern void Gmac_MAC_SetFlowControl();
extern uint32_t Gmac_MAC_GetFlowControl();
extern void Gmac_MAC_InterruptMask();
extern uint32_t Gmac_MAC_GetDebugStatus();
extern void Gmac_MAC_SetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum );
extern void Gmac_MAC_GetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum );

extern void Gmac_MAC_SetFraALLPass();
extern void Gmac_MAC_SetFilterBroadCastFra();
extern int32_t Gmac_MAC_Get_RxEnaStauts();
extern void Gmac_MAC_RxEna();
extern void Gmac_MAC_RxDisa();
extern void Gmac_MAC_TxEna();
extern void Gmac_MAC_TxDisa();

extern uint32_t Gmac_MdioRead( volatile uint32_t PhyAddr,volatile uint32_t phyReg );
extern void   	Gmac_MdioWrite(volatile uint32_t PhyAddr,volatile uint32_t phyReg ,volatile uint32_t value);

extern void PrintfSpeedDuplex( SpeedMode speed, DuplexMode duplex);

//λ
#define RDES0_OWN		(0x1u<<31)

#define TDES0_OWN		(0x1u<<31)

#define TDES1_IC		(0x1u<<31)
#define TDES1_LS		(0x1u<<30)
#define TDES1_FS		(0x1u<<29)
#define TDES1_CIC		(0x1u<<27)
#define TDES1_DC		(0x1u<<26)
#define TDES1_TER		(0x1u<<25)
#define TDES1_TCH		(0x1u<<24)
#define TDES1_DP		(0x1u<<23)


/************************************************************
 *  l2_global_address
 *      ܣֲַӳȫֵַת
 *      addr ---  δת֮ǰľֲַ
 *  ע    ⣺ַѾȫֵַ򷵻ԭֵǾֲַ򷵻תַ
 ************************************************************/
static uint32_t l2_global_address (uint32_t addr)
{
	uint32_t coreNum;

	coreNum = DNUM;				/* ȡ˺ Core0/core1*/
	if(addr<0x0c000000)			/* תȫֵַ */
		return (addr + (0x10000000 + (coreNum * 0x1000000)));
	else
		return addr;
}

/*
 * ˽ṹһΪûܹƵİ忨һЩӲصýѡ
 *
 * */
struct _User_Plarform_Net_Configure
{

	/*	ûGMAC-RGMIIǷֱSwitchоƬ
	 * 	Ϊ1ʾGMACSwitchоƬΪ0ĬPHYоƬ88E1512 	*/
	volatile uint32_t 	gmac_link_switch;

	/*	ûǷҪֶ޸MACַ,ڵMACַ޸ûṩķ		*/
	volatile uint32_t 	user_modify_mac;

	/*	ǷֶڵʡΪ0ʱͨMDIOõPHYʺóӦʣ
	 *	ҪͨMDIOӿڹPHY88E1512ӲƣĿǰDSKõĴƣ
	 *	Ϊ1ʱҪⲿPHYʣֱֶڵʣǴʱGMACֱPHY
	 *	оƬӣԴʱֶ޸PHYоƬʣPHY_speed_manul=1PHYʹ
	 *	GMACһ		*/
	volatile uint32_t  	manul_speed;

	/*	ǷֶõPHYоƬʣһֶMACʹãGMACPHYоƬ֮
	 *	һSwitchоƬо6678EVڵMACPHYоƬʲƥ⣬
	 *	ΪѡããPHYоƬԶԶЭʣ˽ǿԶ˵
	 *	Ϊֶõʣ   ҪȷMDIOӿܹPHYƬļĴMIDOĿ
	 *	ҪȷPHYоƬͺţԼPHYַ ϸMDIOĽӿں		*/
	volatile uint32_t  	PHY_speed_manul;

	/*	ֶõGMAC		*/
	Ethernet_Speed_Mode mac_speed;

};

#endif /* GMAC_H_ */
