/** 
********************************************************************************
* @file       M6678E_GPIO.h
* @brief      M6678E_GPIOֽӿںͼĴ궨
* @version    V1.0
* @date       2018.01.29
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/

#ifndef    _GPIO_TEST_H
#define    _GPIO_TEST_H

#include <stdint.h>
#include <stdio.h>

#define   	__I     volatile const       /*!< Defines 'read only' permissions */
#define     __O     volatile             /*!< Defines 'write only' permissions */
#define     __IO    volatile             /*!< Defines 'read / write' permissions */

/**********************GPIOĴ**************************************************/
typedef struct
{
	__I uint32_t RESERVE1[2];	//00~04
	__IO uint32_t BINTEN;		//08
	__I uint32_t RESERVE2;		//0C
	__IO uint32_t DIR;			//10
	__IO uint32_t OUT_DATA;		//14
	__IO uint32_t SET_DATA;		//18
	__IO uint32_t CLR_DATA;		//1C
	__IO uint32_t IN_DATA;		//20
	__IO uint32_t SET_RIS_TRIG;	//24
	__IO uint32_t CLR_RIS_TRIG;	//28
	__IO uint32_t SET_FAL_TRIG;	//2C
	__IO uint32_t CLR_FAL_TRIG;	//30
}GPIO_TypeDef;

#define GPIO_BASE	(0x08010000)

#define DEV_GPIO	((GPIO_TypeDef *) GPIO_BASE)

extern void GPIO_BINTEN(unsigned int Enable);
extern void GPIO_RISTRIG(unsigned int mode ,unsigned int  ris);
extern void GPIO_FALTRIG(unsigned int mode ,unsigned int  fal);
extern void GPIO_DirectionSet(unsigned int direction);
extern void GPIO_DataOutWrite(unsigned int DataOut);
extern void GPIO_DataOutReverse(unsigned int Numb);
extern unsigned int GPIO_DataInputGet();
extern void GPIO_DateOutnWriteX(unsigned int Numb,unsigned int polarity);

#endif
