#ifndef __M6678E_I2C_H__
#define	__M6678E_I2C_H__
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include "M6678E_PSC.h"

#define   	__I     volatile const       /*!< Defines 'read only' permissions */
#define     __O     volatile             /*!< Defines 'write only' permissions */
#define     __IO    volatile             /*!< Defines 'read / write' permissions */

typedef struct
{
	__IO uint32_t I2COAR;	//00
	__IO uint32_t I2CIER;	//04
	__IO uint32_t I2CSTR;	//08
	__IO uint32_t I2CCLKL;	//0C
	__IO uint32_t I2CCLKH;	//10
	__IO uint32_t I2CCNT;	//14
	__IO uint32_t I2CDRR;	//18
	__IO uint32_t I2CSAR;	//1C
	__IO uint32_t I2CDXR;	//20
	__IO uint32_t I2CMDR;	//24
	__IO uint32_t I2CISRC;	//28
	__IO uint32_t RESERVE;	//2C
	__IO uint32_t I2CPSC;	//30
	__IO uint32_t I2CPID1;	//34
	__IO uint32_t I2CPID2;	//38
}I2C_TypeDef;

#define I2C0_BASE	(0x08030000)
#define I2C1_BASE	(0x08038000)
#define I2C2_BASE	(0x08040000)

#define DEV_I2C0	((I2C_TypeDef *) I2C0_BASE)
#define DEV_I2C1	((I2C_TypeDef *) I2C1_BASE)
#define DEV_I2C2	((I2C_TypeDef *) I2C2_BASE)

void I2C_CLK_Init(I2C_TypeDef *I2C_Dev, uint16_t code_frq, uint16_t i2c_out_frq);
void I2C_Write(I2C_TypeDef *I2C_Dev, uint8_t I2C_address, uint32_t ByteCount, uint8_t *pBuffer);
void I2C_Read(I2C_TypeDef *I2C_Dev, uint8_t I2C_address, uint32_t ByteCount, uint8_t *pBuffer);
void loop_test(I2C_TypeDef *I2C_Dev);
#endif
