/** 
********************************************************************************
* @file       M6678E_Interrupt.h
* @brief      жõĸֽӿںͼĴ궨塣
* @version    V1.0
* @date       2021.03.12
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef _M6678E_INTERRUPT_H_
#define _M6678E_INTERRUPT_H_

#include <stdio.h>
#include <stdlib.h>
#include <c6x.h>

/**********************INTC INIT ADDRESS***************************************/
#define EVTFLAG0     0x01800000
#define EVTFLAG1     0x01800004
#define EVTFLAG2     0x01800008
#define EVTFLAG3     0x0180000C
#define EVTSET0      0x01800020
#define EVTSET1      0x01800024
#define EVTSET2      0x01800028
#define EVTSET3      0x0180002c

#define EVTCLR0      0x01800040
#define EVTCLR1      0x01800044
#define EVTCLR2      0x01800048
#define EVTCLR3      0x0180004c
#define INTMUX_ADDR  0x01800100

#define EVTMASK0 	*(volatile int *)0x01800080   	//Event mask register 0
#define EVTMASK1 	*(volatile int *)0x01800084     //Event mask register 1
#define EVTMASK2 	*(volatile int *)0x01800088 	//Event mask register 2
#define EVTMASK3 	*(volatile int *)0x0180008C 	//Event mask register 3
#define MEVTFLAG0 	*(volatile int *)0x018000A0 	//Masked event flag register 0
#define MEVTFLAG1 	*(volatile int *)0x018000A4 	//Masked event flag register 1
#define MEVTFLAG2 	*(volatile int *)0x018000A8 	//Masked event flag register 2
#define MEVTFLAG3 	*(volatile int *)0x018000AC 	//Masked event flag register 3
#define INTXSTAT    *(volatile int *)0x01800180     //ж쳣״̬Ĵ

#define MEVTFLAG0    *(volatile int *)0x018000A0
#define MEVTFLAG1    *(volatile int *)0x018000A4
#define MEVTFLAG2    *(volatile int *)0x018000A8
#define MEVTFLAG3    *(volatile int *)0x018000AC

#define EXPMASK0     *(volatile int *)0x018000C0
#define EXPMASK1     *(volatile int *)0x018000C4
#define EXPMASK2     *(volatile int *)0x018000C8
#define EXPMASK3     *(volatile int *)0x018000CC

/**********************CIC INIT ADDRESS***************************************/
#define CIC_BASE    					   	0x090C0000
#define INT_SET_INDEX_REG_offset        	0x20       //״ָ̬üĴ,дӦŲӦж
#define INT_CLR_INDEX_REG_offset        	0x24       //жָĴ
#define CH_MAP_REG0                        	0x400
#define INT_FLAG_REG                        0x200
/********************** ARM CIC AINIT ADDRESS***************************************/
#define EINT0_REG0_offset             	  	0xE018
#define EINT1_REG1_offset             	   	0xE01C



extern void M6678E_Int_GlobalEnable(unsigned int IntVector);
extern void M6678E_CoreInt_Init();
extern void M6678E_CoreInt_Set(int Evt_Num, int Int_Num);
extern void M6678E_ChipInt_Set(int Sys_Evt, int Host_Int);
extern void M6678E_ChipInt_Clear(int Sys_Evt_Numb );
extern void Interrupt_Service_Table(unsigned int ISR_Addr);
extern int M6678E_CoreIntc_Set(int Evt_Num);
extern int M6678E_CoreIntcFlag_READ(int Evt_Num);
extern void Soft_CIC_Set(int Sys_Evt_Numb);

#endif /* _M6678E_INTERRUPT_H_ */
