/** 
********************************************************************************
* @file       M6678E_MEMPROT.h
* @brief      M6678E MEMPROTӿںͼĴ궨塣
* @version    V1.0
* @date       2022.07.26
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef   _M6678E_MEMPROT_H_
#define   _M6678E_MEMPROT_H_

/*L1P洢Ĵṹ*/
typedef struct  {
    volatile unsigned int L1PMPFAR;
    volatile unsigned int L1PMPFSR;
    volatile unsigned int L1PMPFCR;
    volatile unsigned char RSV[564];
    volatile unsigned int L1PMPPA[16];
} L1P_MEMPROTRegs;

/*L1D洢Ĵṹ*/
typedef struct  {
    volatile unsigned int L1DMPFAR;
    volatile unsigned int L1DMPFSR;
    volatile unsigned int L1DMPFCR;
    volatile unsigned char RSV[564];
    volatile unsigned int L1DMPPA[16];
} L1D_MEMPROTRegs;

/*L2洢Ĵṹ*/
typedef struct  {
    volatile unsigned int L2MPFAR;
    volatile unsigned int L2MPFSR;
    volatile unsigned int L2MPFCR;
    volatile unsigned char RSV[500];
    volatile unsigned int L2MPPA[32];
} L2_MEMPROTRegs;

typedef struct  {
	volatile unsigned int  MPLK[4];
	volatile unsigned int  MPLKCMD;
	volatile unsigned int  MPLKSTAT;
} MPLKRegs;

#define hL1pMemprotRegs       ((L1P_MEMPROTRegs *)0x0184A400)
#define hL1dMemprotRegs       ((L1D_MEMPROTRegs *)0x0184AC00)
#define hL2MemprotRegs        ((L2_MEMPROTRegs *)0x0184A000)
#define hMplkRegs             ((MPLKRegs *)0x0184AD00)


typedef struct {
	/*ID */
	unsigned int fid;

	/*local access */
	unsigned int local;

	/* Ȩ */
	unsigned int sr;

	/*дȨ */
	unsigned int sw;

	/*ûȨ */
	unsigned int ur;

	/*ûдȨ */
	unsigned int uw;

}MEMPROT_MPFSR;

typedef struct {
	/** Allow access from VBUS PrivID=5 */
	unsigned int aid5:1;

	/** Allow access from VBUS PrivID=4 */
	unsigned int aid4:1;

	/** Allow access from VBUS PrivID=3 */
	unsigned int aid3:1;

	/** Allow access from VBUS PrivID=2 */
	unsigned int aid2:1;

	/** Allow access from VBUS PrivID=1 */
	unsigned int aid1:1;

	/** Allow access from VBUS PrivID=0 */
	unsigned int aid0:1;

	/** Allow access from VBUS PrivID>=6 */
	unsigned int aidx:1;

	/** Allow access from CPU to its local memories (L1 only) */
	unsigned int local:1;

	/** Supervisor may read */
	unsigned int sr:1;

	/** Supervisor may write */
	unsigned int sw:1;

	/** Supervisor may execute */
	unsigned int sx:1;

	/** User may read */
	unsigned int ur:1;

	/** User may write */
	unsigned int uw:1;

	/** User may execute */
	unsigned int ux:1;
}MEMPROT_MPPA;

/***************MEMPROT ӿں***************************************************/
extern unsigned int MEMPROT_getL1PFaultAddress();
extern void MEMPROT_clearL1PFault();
extern void MEMPROT_getL1PFaultStatus(MEMPROT_MPFSR * mpfsr);
extern void MEMPROT_setL1PAttributes(unsigned int index,MEMPROT_MPPA * mppa);
extern void MEMPROT_getL1PAttributes(unsigned int index,MEMPROT_MPPA * mppa);

extern unsigned int MEMPROT_getL1DFaultAddress();
extern void MEMPROT_clearL1DFault();
extern void MEMPROT_getL1DFaultStatus(MEMPROT_MPFSR * mpfsr);
extern void MEMPROT_setL1DAttributes(unsigned int index,MEMPROT_MPPA * mppa);
extern void MEMPROT_getL1DAttributes(unsigned int index,MEMPROT_MPPA * mppa);

extern unsigned int MEMPROT_getL2FaultAddress();
extern void MEMPROT_clearL2Fault();
extern void MEMPROT_getL2FaultStatus(MEMPROT_MPFSR * mpfsr);
extern void MEMPROT_setL2Attributes(unsigned int index,MEMPROT_MPPA * mppa);
extern void MEMPROT_getL2Attributes(unsigned int index,MEMPROT_MPPA * mppa);
extern void lock_mem_prot_regs();
extern void unlock_mem_prot_regs();

#endif
