/**
********************************************************************************
* @file       M6678E_PLL.h
* @brief      ʵM6678E PLLõĸֽӿںͼĴ궨塣
* @version    V1.0
* @date       2024/1/15
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef __M6678E_PLL_H_
#define __M6678E_PLL_H_
#include <stdint.h>

#define	KICK0 			*(volatile	unsigned int *)0x09000038
#define	KICK1			*(volatile	unsigned int *)0x0900003C

#define	oscclk			25

/********************* DSP_PLL Ĵ ************************************************/
#define	DSP_PLLCTL		*(volatile	unsigned int *)0x09020100
#define	DSP_PLLCMD		*(volatile	unsigned int *)0x09020104
#define	DSP_PLLDIV		*(volatile	unsigned int *)0x09020108

/********************* NOC_PLL Ĵ ************************************************/
#define	NOC_PLLCTL		*(volatile	unsigned int *)0x09020110
#define	NOC_PLLCMD		*(volatile	unsigned int *)0x09020114

/********************* SYS_PLL Ĵ ************************************************/
#define	SYS_PLLCTL		*(volatile	unsigned int *)0x09020120
#define	SYS_PLLCMD		*(volatile	unsigned int *)0x09020124
#define	SYS_PLLDIV1		*(volatile	unsigned int *)0x09020128

/********************* PCIE_PLL Ĵ ************************************************/
#define	PCIE_PLLCTL		*(volatile	unsigned int *)0x09020130
#define	PCIE_PLLCMD		*(volatile	unsigned int *)0x09020134

/********************* DDR_PLL Ĵ ************************************************/
#define	DDR_PLLCTL		*(volatile	unsigned int *)0x09020140
#define	DDR_PLLCMD		*(volatile	unsigned int *)0x09020144

/********************* ACC_PLL Ĵ ************************************************/
#define	ACC_PLLCTL		*(volatile	unsigned int *)0x09020150
#define	ACC_PLLCMD		*(volatile	unsigned int *)0x09020154
#define	ACC_PLLDIV1		*(volatile	unsigned int *)0x09020158
#define	ACC_PLLDIV2		*(volatile	unsigned int *)0x0902015C


/********************* SRIO_PLL Ĵ ************************************************/
#define	SRIO_PLLCTL	*(volatile	unsigned int *)0x09020160
#define	SRIO_PLLCMD	*(volatile	unsigned int *)0x09020164

/********************* SRIO_PLL Ĵ ************************************************/
#define	ARM_PLLCTL		*(volatile	unsigned int *)0x09020170
#define	ARM_PLLCMD		*(volatile	unsigned int *)0x09020174
#define	ARM_PLLDIV		*(volatile	unsigned int *)0x09020178

/********************* SRIO2_PLL Ĵ ************************************************/
#define	SRIO2_PLLCTL	*(volatile	unsigned int *)0x09020180
#define	SRIO2_PLLCMD	*(volatile	unsigned int *)0x09020184

// 
void DSP_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void NOC_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void SYS_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void PCIE_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void DDR_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void ACC_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void SRIO_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void ARM_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void SRIO2_PLL_Init	(uint16_t FBDIV, uint8_t REFDIV,  uint8_t POSTDIV1, uint8_t POSTDIV2);
void DSPCLKV_PLL	(uint8_t RATIO);
void SYS_TP_PLL		(uint8_t RATIO2);
void ARMCLKV_PLL	(uint8_t RATIO_arm);
void ACC_FFT_PLL	(uint8_t RATIO1);
void ACC_PNNA_PLL	(uint8_t RATIO2);



#endif /* __M6678E_PLL_H_ */
