/**
********************************************************************************
* @file       M6678E_SPI.h
* @brief      ʵM6678E SPIõĸֽӿںͼĴ궨塣
* @version    V1.0
* @date       2020/3/17
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef __M6678E_SPI_H__
#define	__M6678E_SPI_H__
#include <stdint.h>

#define   	__I     volatile const       /*!< Defines 'read only' permissions */
#define     __O     volatile             /*!< Defines 'write only' permissions */
#define     __IO    volatile             /*!< Defines 'read / write' permissions */

typedef struct
{
	__IO uint32_t 	CPB;
	__I	 uint32_t	RESERVE1[7];
	__IO uint32_t 	MODE;
	__IO uint32_t 	EVT;
	__I	 uint32_t	RESERVE2;
	__IO uint32_t 	CMD;
	__IO uint32_t 	TX;
	__IO uint32_t 	RX;
	__IO uint32_t 	SS;
	__IO uint32_t 	ASS;
	__I	 uint32_t	RESERVE3[8];
	__IO uint32_t 	PTCS;			// M6678EЭѡĴ
	__IO uint32_t 	DCR;			// M6678E߿ƼĴ
	__I	 uint32_t	RESERVE4[358];
	__IO uint32_t 	SPIINT0;
	__IO uint32_t 	SPIIVL;
	__IO uint32_t 	CPR;			// M6678E add 18reg
	__IO uint32_t 	MSPR;
	__IO uint32_t 	MSER;
	__IO uint32_t 	MSSTR;
	__IO uint32_t 	MSCLR;
	__IO uint32_t 	RXM1BESTR;
	__IO uint32_t 	TXM1BESTR;
	__IO uint32_t 	DCM1BESTR;
	__IO uint32_t 	M1BCLR;
	__IO uint32_t 	M2BEIPR;
	__IO uint32_t 	M2BEIER;
	__IO uint32_t 	M2BEICR;
	__IO uint32_t 	RXMERCOLR;
	__IO uint32_t 	TXMERCOLR;
	__IO uint32_t 	DCMERCOLR;
	__IO uint32_t 	RXMCEMUR;
	__IO uint32_t 	TXMCEMUR;
	__IO uint32_t 	DCMCEMUR;

}SPI_TypeDef;
#define SPI0_BASE	(0x08050000)

#define DEV_SPI0	((SPI_TypeDef *) SPI0_BASE)
//#define DEV_SPI1	((SPI_TypeDef *) SPI1_BASE)
//#define DEV_SPI2	((SPI_TypeDef *) SPI2_BASE)

// MODE	CPOL CPHA
// 	0	 0	  0
// 	1	 0	  1
// 	2	 1	  0
// 	3	 1	  1
#define SPI_MODE_0	0
#define SPI_MODE_1	1
#define SPI_MODE_2	2
#define SPI_MODE_3	3

// protocol	0x0->˫ 0x1->ȫ˫ 0x2->˫ߣ0x3->
#define SPI_PTC_Half_Duplex		0x0
#define SPI_PTC_Full_Duplex		0x1
#define SPI_PTC_Dual			0x2
#define SPI_PTC_Qual			0x3

// ѡ
#define SPI_CS0			0xE
//#define SPI_CS1			0xD
//#define SPI_CS2			0xB
//#define SPI_CS3			0x7
#define SPI_CSDISABLE	0xF

int SPI_Init(SPI_TypeDef *SPIDEV, uint32_t main_frq_MHz, float spi_clk_out_MHz, uint8_t mode, uint8_t protocol);
void SPI_Set_Protocal(SPI_TypeDef *SPIDEV, uint8_t mode);
void SPI_Transmit_Byte(SPI_TypeDef *SPIDEV, uint8_t dat);
void SPI_Transmit_Byte_EDAC(SPI_TypeDef *SPIDEV, uint8_t dat);
void SPI_Receive_Byte(SPI_TypeDef *SPIDEV, uint8_t *dat);
void SPI_Receive_Byte_EDAC(SPI_TypeDef *SPIDEV, uint8_t *dat);
void SPI_Transmit(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data);
void SPI_Transmit_Dummy(SPI_TypeDef *SPIDEV);
void SPI_Receive(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data);
void spi_recvFIFO_clear(SPI_TypeDef *SPIDEV);
void SPI_loop_test(SPI_TypeDef *SPIDEV);
void SPI_EDAC_Test(SPI_TypeDef *SPIDEV);
void data_cmpare(uint8_t *Srcdata_addr, uint8_t *Dstdata_addr, uint32_t size);
#endif
