/**
********************************************************************************
* @file       M6678_UART.h
* @brief      M6678 UARTֽӿںͼĴ궨
* @version    V1.0
* @date       2020.12.3
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef __M6678_UART_H__
#define	__M6678_UART_H__

#include <stdint.h>
#include <stdio.h>
#include "M6678E_PSC.h"

#define   	__I     volatile const       /*!< Defines 'read only' permissions */
#define     __O     volatile             /*!< Defines 'write only' permissions */
#define     __IO    volatile             /*!< Defines 'read / write' permissions */

typedef struct
{
	__IO uint32_t 	UARTDR;			//00
	__IO uint32_t 	UARTRSR_CR;		//04
	__I  uint32_t 	RESERVE1[4];	//8~14
	__I  uint32_t 	UARTFR;			//18
	__I  uint32_t 	RESERVE2[2];	//1C~20
	__IO uint32_t 	UARTIBRD;		//24
	__IO uint32_t 	UARTFBRD;		//28
	__IO uint32_t 	UARTLCR_H;		//2c
	__IO uint32_t 	UARTCR;			//30
	__IO uint32_t 	UARTIFLS;		//34
	__IO uint32_t 	UARTIMSC;		//38
	__I  uint32_t 	UARTRIS;		//3C
	__I  uint32_t 	UARTMIS;		//40
	__O  uint32_t 	UARTICR;		//44
}UART_TypeDef;

#define UART0_BASE	(0x08070000)
#define UART1_BASE	(0x08078000)
#define UART2_BASE	(0x08080000)

#define DEV_UART0	((UART_TypeDef *) UART0_BASE)
#define DEV_UART1	((UART_TypeDef *) UART1_BASE)
#define DEV_UART2	((UART_TypeDef *) UART2_BASE)

// 
void UART_Init(UART_TypeDef *UARTDEV, uint32_t main_frq, uint32_t BaudRate);
void UART_Transmit_Byte(UART_TypeDef *UARTDEV, uint8_t dat);
void UART_Receive_Byte(UART_TypeDef *UARTDEV, uint8_t *dat);
void UART_Transmit(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data);
void UART_Receive(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data);
void UART_Print(UART_TypeDef *UARTDEV, char *src_dat);
int UART_Write_Read_Byte(UART_TypeDef *UARTDEV, unsigned char w_dat);
void loop_test(UART_TypeDef *UARTDEV);
void text_test(UART_TypeDef *UARTDEV);
void Uart_delay(void);

#endif
