/**
********************************************************************************
* @file       M6678E_CACHE.c
* @brief      M6678ECACHEؽӿں
* @version    V1.0
* @date       2021.07.20
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <string.h>

#include "M6678E_CACHE.h"

#define hCache      ((M6678E_CSL_CgemRegs *)M6678E_CGEM0_5_REG_BASE_ADDRESS_REGS)

/** @addtogroup CACHE_FUNCTION
 @{ */


/**
********************************************************************************
 *   @n@b void CACHE_setL1DSize (CACHE_L1Size newSize)
 *
 *   @b ܣ
 *   @n L1D cacheС
 *
 *   @b βΣ
 *   @verbatim
 *		newSize õCacheС
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_setL1DSize (CACHE_L1Size newSize)
{
    hCache->L1DCFG = newSize;
}


/**
********************************************************************************
 *   @n@b unsigned int CACHE_getL1DSize()
 *
 *   @b ܣ
 *   @n ȡL1D cacheС
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n cacheС
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
CACHE_L1Size CACHE_getL1DSize()
{
	return (CACHE_L1Size)(hCache->L1DCFG&0x7);;
}


/**
********************************************************************************
 *   @n@b CACHE_enableCaching(uint8_t mar)
 *
 *   @b ܣ
 *   @n ʹһ洢cache
 *
 *   @b βΣ
 *   @verbatim
 *      mar  ѡĸַοɽcache
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_enableCaching(uint8_t mar)
{
	hCache->MAR[mar] |= 1;
}

/**
********************************************************************************
 *   @n@b CACHE_disableCaching(uint8_t mar)
 *
 *   @b ܣ
 *   @n رһ洢cache
 *
 *   @b βΣ
 *   @verbatim
 *      mar  رĸַν Cache
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_disableCaching(uint8_t mar)
{
	hCache->MAR[mar] &= 0xfffffffe;
}

/**
********************************************************************************
 *   @n@b CACHE_freezeL1D()
 *
 *   @b ܣ
 *   @n ʹ L1D CACHEFreeze mode
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_freezeL1D(void)
{
	hCache->L1DCC |= (0x1<<0);
}
/**
********************************************************************************
 *   @n@b CACHE_unfreezeL1D()
 *
 *   @b ܣ
 *   @n ر CACHEFreeze mode
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_unfreezeL1D()
{
	hCache->L1DCC &= ~(0x1<<0);
}
/**
********************************************************************************
 *   @n@b void CACHE_getMemRegionInfo (uint8_t mar, uint8_t* pcx)
 *
 *   @b ܣ
 *   @n ȡ洢(Cache)Ϣ
 *
 *   @b βΣ
 *   @verbatim
 *      mar ѡĸַ
 *		pcx 
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_getMemRegionInfo (uint8_t mar, uint8_t* pcx)
{
    uint32_t value = hCache->MAR[mar];

    *pcx = hCache->MAR[mar] & 0x1;
}
/**
********************************************************************************
 *   @n@b void CACHE_setMemRegionInfo (uint8_t mar, uint8_t pcx)
 *
 *   @b ܣ
 *   @n ô洢(Cache)
 *
 *   @b βΣ
 *   @verbatim
 *      mar ѡĸַ
 *		pcx дPC(MARĴbit0)ֵ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_setMemRegionInfo (uint8_t mar, uint8_t pcx)
{
    uint32_t value = hCache->MAR[mar];

    hCache->MAR[mar] |= (pcx&0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_getPrevL1DMode(void)
 *
 *   @b ܣ
 *   @n ȡһ L1DFRZ(L1DCC) ޸ǰbit[0]ֵ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n L1DFRZ(L1DCC)Ĵbit[16]ֵ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t CACHE_getPrevL1DMode(void)
{
    return ((hCache->L1DCC>>16)&0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_invAllL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (ALL-Invalid)ȫϲ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL1dWait (void)
{
    while (hCache->L1DINV & 0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_invAllL1d (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n L1D-cache (ALL-Invalid)ȫЧ
 *
 *   @b βΣ
 *   @verbatim
 *      wait ǷӦȴȫЧ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL1d (CACHE_Wait wait)
{
    /* Чcache line. */
    hCache->L1DINV |= 0x1;
    
    /* ȷǷҪȴcacheЧ. */
    if (wait)
        CACHE_invAllL1dWait();
}
/**
********************************************************************************
 *   @n@b void CACHE_wbAllL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (ALL-writeback)ȫдز
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbAllL1dWait (void)
{
    while (hCache->L1DWB & 0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_invAllL1d (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n L1D-cache (ALL-invalid)ȫЧ
 *
 *   @b βΣ
 *   @verbatim
 *      wait ǷӦȴȫЧ(ALL-invalid)
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbAllL1d (CACHE_Wait wait)
{

    hCache->L1DWB |= 0x1;
    
    if (wait)
        CACHE_wbAllL1dWait();
}
/**
********************************************************************************
 *   @n@b void CACHE_wbInvAllL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (ALL-writeback and invalid)ȫдزЧ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvAllL1dWait (void)
{
    while (hCache->L1DWBINV & 0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_wbInvAllL1d (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n L1D-cache (ALL-writeback and invalid)ȫдزЧ
 *
 *   @b βΣ
 *   @verbatim
 *      wait ǷӦȴ(ALL-writeback and invalid)ȫдزЧ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  CACHE_wbInvAllL1d (CACHE_Wait wait)
{
    hCache->L1DWBINV |= 0x1;
    
    if (wait)
        CACHE_wbInvAllL1dWait();     
}
/**
********************************************************************************
 *   @n@b void CACHE_invL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (block invalid)Ч
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL1dWait (void)
{
    while (hCache->L1DIWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b void void CACHE_invL1d 
 *		(
 *    		void*       blockPtr,
 *    		uint32_t      byteCnt,
 *   		CACHE_Wait  wait
 *		)
 *
 *   @b ܣ
 *   @n L1D-cache (Block invalid)Ч
 *
 *   @b βΣ
 *   @verbatim
 *      blockPtr ЧĿַ
 *      byteCnt  ЧĿ鳤
 *      wait ǷӦȴ(Block invalid)Ч
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL1d 
(
    void*       blockPtr,
    uint32_t      byteCnt,
    CACHE_Wait  wait
)
{
    hCache->L1DIBAR = (uint32_t)blockPtr;
    hCache->L1DIWC  = (uint32_t)((byteCnt+3)>>2);

    if (wait == CACHE_WAIT)
        CACHE_invL1dWait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b void CACHE_wbL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (block writeback)дز
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbL1dWait (void)
{  
	while (hCache->L1DWWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b void CACHE_wbL1d 
 *		(
 *    		void*       blockPtr,
 *    		uint32_t      byteCnt,
 *   		CACHE_Wait  wait
 *		)
 *
 *   @b ܣ
 *   @n L1D-cache (block writeback)дز
 *
 *   @b βΣ
 *   @verbatim
 *      blockPtr дزĿַ
 *      byteCnt  дزĿ鳤
 *      wait ǷӦȴ(block writeback)дز
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbL1d 
(
    void*       blockPtr,
    uint32_t      byteCnt,
    CACHE_Wait  wait
)
{
    
    hCache->L1DWBAR = (uint32_t)blockPtr;
    hCache->L1DWWC  = (uint32_t)((byteCnt+3)>>2);

    if (wait == CACHE_WAIT)
        CACHE_wbL1dWait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b void CACHE_wbInvL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (block writeback and invalid)дزЧ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvL1dWait (void)
{
	while (hCache->L1DWIWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b void CACHE_wbInvL1d 
 *		(
 *    		void*       blockPtr,
 *    		uint32_t      byteCnt,
 *   		CACHE_Wait  wait
 *		)
 *
 *   @b ܣ
 *   @n L1D-cache (block writeback and invalid)дزЧ
 *
 *   @b βΣ
 *   @verbatim
 *      blockPtr дЧĿַ
 *      byteCnt  дЧĿ鳤
 *      wait ǷӦȴ(block writeback and invalid)дزЧ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvL1d 
(
    void*       blockPtr,
    uint32_t      byteCnt,
    CACHE_Wait  wait
)
{
    hCache->L1DWIBAR = (uint32_t)blockPtr;
    hCache->L1DWIWC  = (uint32_t)((byteCnt+3)>>2);
 
    if (wait == CACHE_WAIT)
        CACHE_wbInvL1dWait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b void CACHE_setL1PSize (CACHE_L1Size newSize)
 *
 *   @b ܣ
 *   @n L1P cacheС
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_setL1PSize (CACHE_L1Size newSize)
{
	hCache->L1PCFG = newSize;
}
/**
********************************************************************************
 *   @n@b unsigned int CACHE_getL1PSize()
 *
 *   @b ܣ
 *   @n ȡL1P cacheС
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n cacheС
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
CACHE_L1Size CACHE_getL1PSize (void)
{
	return (CACHE_L1Size)(hCache->L1PCFG & 0x7);
}
/**
********************************************************************************
 *   @n@b CACHE_freezeL1P()
 *
 *   @b ܣ
 *   @n ʹ L1P CACHEFreeze mode
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_freezeL1P(void)
{
    hCache->L1PCC |= 0x1; 
}
/**
********************************************************************************
 *   @n@b CACHE_unfreezeL1P()
 *
 *   @b ܣ
 *   @n ر L1P-CACHEFreeze mode
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_unfreezeL1P(void)
{
	hCache->L1PCC &= ~0x1; 
}
/**
********************************************************************************
 *   @n@b void CACHE_getPrevL1PMode(void)
 *
 *   @b ܣ
 *   @n ȡһ L1PFRZ(L1PCC) ޸ǰbit[0]ֵ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n L1PFRZ(L1PCC)Ĵbit[16]ֵ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t CACHE_getPrevL1PMode(void)
{
	return ((hCache->L1PCC>>16)&0x1);
}
/**
********************************************************************************
 *   @n@b void CACHE_invL1pWait (void)
 *
 *   @b ܣ
 *   @n ȴL1P-cache (block invalid)Ч
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL1pWait (void)
{    
    while (hCache->L1PIWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b void CACHE_invL1p 
 *		(
 *    		void*       blockPtr,
 *    		uint32_t      byteCnt,
 *   		CACHE_Wait  wait
 *		)
 *
 *   @b ܣ
 *   @n L1P-cache (Block invalid)Ч
 *
 *   @b βΣ
 *   @verbatim
 *      blockPtr ЧĿַ
 *      byteCnt  ЧĿ鳤
 *      wait ǷӦȴ(Block invalid)Ч
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL1p 
(
    void*       blockPtr,
    uint32_t      byteCnt,
    CACHE_Wait  wait
)
{
	hCache->L1PIBAR = (uint32_t)blockPtr;
    hCache->L1PIWC  = (uint32_t)((byteCnt+3)>>2);
	
    if (wait == CACHE_WAIT)
        CACHE_invL1pWait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b void CACHE_invAllL1dWait (void)
 *
 *   @b ܣ
 *   @n ȴL1D-cache (ALL-Invalid)ȫϲ
 *
 *   @b βΣ
 *   @verbatim
 *      
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL1pWait (void)
{
	while (hCache->L1PINV & 0x1); 
}
/**
********************************************************************************
 *   @n@b void CACHE_
 *   invAllL1d (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n L1D-cache (ALL-Invalid)ȫЧ
 *
 *   @b βΣ
 *   @verbatim
 *      wait ǷӦȴȫЧ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL1p (CACHE_Wait wait)
{    
	hCache->L1PINV |= 0x1;
	
    if (wait)
        CACHE_invAllL1pWait();
}
/**
********************************************************************************
 *   @n@b void CACHE_setL2Size (CACHE_L2Size newSize)
 *
 *   @b ܣ
 *   @n L2 cacheС
 *
 *   @b βΣ
 *   @verbatim
 *      newSize õCacheС
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_setL2Size (CACHE_L2Size newSize)
{
    /* Set the new L2 cache size. */
	 hCache->L2CFG = newSize;
}
/**
********************************************************************************
 *   @n@b void CACHE_getL2Size (void)
 *
 *   @b ܣ
 *   @n ȡL2 cacheС
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
CACHE_L2Size CACHE_getL2Size (void)
{
	return (CACHE_L2Size)(hCache->L2CFG&0x7);;
}
/**
********************************************************************************
 *   @n@b CACHE_freezeL2 (void)
 *
 *   @b ܣ
 *   @n úڶL2
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_freezeL2 (void)
{
	hCache->L1DCC |= (0x1<<3);
}

/**
********************************************************************************
 *   @n@b CACHE_unfreezeL2 (void)
 *
 *   @b ܣ
 *   @n úڽL2
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_unfreezeL2 (void)
{
	hCache->L1DCC &= ~(0x1<<3);
}

/**
********************************************************************************
 *   @n@b CACHE_wbL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cacheд(block writeback)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbL2Wait (void)
{
	 while (hCache->L2WWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b CACHE_wbL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait)
 *
 *   @b ܣ
 *   @n úдL2 CacheݡܿСָֽܹcacheĿȻcache line
 *
 *   @b βΣ
 *   @verbatim
 *		blockPtr      дزĿַ
 *		byteCnt       дزĿС
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait)
{
    /* ÿַʹС  */
    hCache->L2WBAR = (uint32_t)blockPtr;
    hCache->L2WWC  = (uint32_t)((byteCnt+3)>>2);

    if (wait == CACHE_WAIT)
        CACHE_wbL2Wait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b CACHE_invL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cache(block invalidate)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL2Wait (void)
{
	 while (hCache->L2IWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b CACHE_invL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait)
 *
 *   @b ܣ
 *   @n úL2 CacheݡܿСָֽܹcacheĿȻcache line
 *
 *   @b βΣ
 *   @verbatim
 *		blockPtr      ϲĿַ
 *		byteCnt       ϲĿС
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invL2
(
    void*       blockPtr,
    uint32_t    byteCnt,
    CACHE_Wait  wait
)
{
    /* ÿַʹС  */
    hCache->L2IBAR = (uint32_t)blockPtr;
    hCache->L2IWC  = (uint32_t)((byteCnt+3)>>2);

    /* ǷҪȴ. */
    if (wait == CACHE_WAIT)
        CACHE_invL2Wait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b CACHE_wbInvL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cacheд(block writeback & invalidate)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvL2Wait (void)
{
    while (hCache->L2WIWC & 0xffff);
}
/**
********************************************************************************
 *   @n@b CACHE_wbInvL2 (void* blockPtr, uint32_t byteCnt, CACHE_Wait  wait)
 *
 *   @b ܣ
 *   @n úдزL2 CacheݡܿСָֽܹcacheĿȻcache line
 *
 *   @b βΣ
 *   @verbatim
 *		blockPtr      дزϲĿַ
 *		byteCnt       дزϲĿС
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvL2 (
    void*       blockPtr,
    uint32_t      byteCnt,
    CACHE_Wait  wait
)
{
    /* ÿַʹС  */
    hCache->L2WIBAR = (uint32_t)blockPtr;
    hCache->L2WIWC  = (uint32_t)((byteCnt+3)>>2);

    /* ǷҪȴ. */
    if (wait == CACHE_WAIT)
        CACHE_wbInvL2Wait();
    else if (wait == CACHE_FENCE_WAIT)
        asm(" MFENCE ");    
	asm(" nop 1");
}
/**
********************************************************************************
 *   @n@b CACHE_wbAllL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cacheȫд(All writeback)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbAllL2Wait (void)
{
    while (hCache->L2WB & 0x1);
}

/**
********************************************************************************
 *   @n@b CACHE_wbInvL2 (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n úL2 CacheȫдأAll writebackݡ
 *
 *   @b βΣ
 *   @verbatim
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbAllL2 (CACHE_Wait wait)
{
    hCache->L2WB  = 0x1;

    /* ǷҪȴ. */
    if (wait)
        CACHE_wbAllL2Wait();
}
/**
********************************************************************************
 *   @n@b CACHE_invAllL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cacheȫ(All Invalidate)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL2Wait (void)
{
    while (hCache->L2INV & 0x1);
}
/**
********************************************************************************
 *   @n@b CACHE_invAllL2 (CACHE_Wait wait)
 *
 *   @b ܣ
 *   @n úL2 CacheȫϣAll invalidateݡ
 *
 *   @b βΣ
 *   @verbatim
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_invAllL2 (CACHE_Wait wait)
{

    hCache->L2INV  = 0x1;

    /* ǷҪȴ. */
    if (wait)
    	CACHE_invAllL2Wait();
}
/**
********************************************************************************
 *   @n@b CACHE_wbInvAllL2Wait (void)
 *
 *   @b ܣ
 *   @n úڵȴL2 Cacheȫдز(All Writeback & Invalidate)
 *
 *   @b βΣ
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvAllL2Wait (void)
{
	while (hCache->L2WBINV & 0x1);
}
/**
********************************************************************************
 *   @n@b CACHE_wbInvAllL2 (CACHE_Wait  wait)
 *
 *   @b ܣ
 *   @n úL2 Cacheȫдزϣwriteback and invalidateݡ
 *
 *   @b βΣ
 *   @verbatim
 *		wait          ʾǷ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CACHE_wbInvAllL2 (CACHE_Wait wait)
{

    hCache->L2WBINV  = 0x1;

    /* ǷҪȴ. */
    if (wait)
        CACHE_wbInvAllL2Wait();
}
