/**
********************************************************************************
* @file       M6678E_CrossNet.c
* @brief      M6678ECrossNet
* @version    V1.0
* @date       2020.12.01
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include <string.h>
#include "M6678E_CrossNet.h"

/** @addtogroup CrossNet_FUNCTION
 @{ */

CnRegs * CnHostRegs[48] = {
    (CnRegs*)CN_DMA2TC0_REGS,
    (CnRegs*)CN_DMA3TC0_REGS,
    (CnRegs*)CN_DMA4TC0_REGS,
    (CnRegs*)CN_PCIE_REGS,
    (CnRegs*)CN_H264E_REGS,
    (CnRegs*)CN_XGMAC0_REGS,
    (CnRegs*)CN_XGMAC4_REGS,
    (CnRegs*)CN_DMA2TC1_REGS,
    (CnRegs*)CN_DMA3TC1_REGS,
    (CnRegs*)CN_DMA4TC1_REGS,
    (CnRegs*)CN_H264D_REGS,
    (CnRegs*)CN_XGMAC1_REGS,
    (CnRegs*)CN_XGMAC5_REGS,
    (CnRegs*)CN_ET_REGS,
    (CnRegs*)CN_DMA2TC2_REGS,
    (CnRegs*)CN_DMA3TC2_REGS,
    (CnRegs*)CN_DMA4TC2_REGS,
    (CnRegs*)CN_TCP_REGS,
    (CnRegs*)CN_VPIF0_REGS,
    (CnRegs*)CN_XGMAC2_REGS,
    (CnRegs*)CN_RGMII_REGS,
    (CnRegs*)CN_HPI_REGS,
    (CnRegs*)CN_DMA2TC3_REGS,
    (CnRegs*)CN_DMA3TC3_REGS,
    (CnRegs*)CN_DMA4TC3_REGS,
    (CnRegs*)CN_VPIF1_REGS,
    (CnRegs*)CN_XGMAC3_REGS,
    (CnRegs*)CN_PCI_REGS,
    (CnRegs*)CN_ATA_REGS,
    (CnRegs*)CN_UPPI_REGS,
    (CnRegs*)CN_UPPQ_REGS,
    (CnRegs*)CN_ARM926_0_REGS,
    (CnRegs*)CN_ARM926_1_REGS,
    (CnRegs*)CN_PNNA_REGS,
	
	(CnRegs*)CN_DSP0_REGS,
	(CnRegs*)CN_DSP1_REGS,
	(CnRegs*)CN_DSP2_REGS,
	(CnRegs*)CN_DSP3_REGS,
	(CnRegs*)CN_DSP4_REGS,
	(CnRegs*)CN_DSP5_REGS,
	(CnRegs*)CN_DSP6_REGS,
	(CnRegs*)CN_DSP7_REGS,	
	(CnRegs*)CN_DMA0TC0_REGS,
	(CnRegs*)CN_DMA0TC1_REGS,
	(CnRegs*)CN_DMA1TC0_REGS,
	(CnRegs*)CN_DMA1TC1_REGS
};


/**
********************************************************************************
 *   @n@b void CN_SetXMPAXH(unsigned int host,unsigned int index,CN_XMPAXH* mpaxh)
 *
 *   @b ܣ
 *   @n XMPAXHĴ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *      index  ĴԣȡֵΪ0~7
 *      mpaxh  ṹ壬δСsegSizeλַbAddr
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CN_SetXMPAXH(unsigned int host,unsigned int index,CN_XMPAXH* mpaxh)
{
	CnHostRegs[host]->XMPAX[index].XMPAXH = mpaxh->segSize | (mpaxh->bAddr << 12);
}


/**
********************************************************************************
 *   @n@b void CN_SetXMPAXL(unsigned int host,unsigned int index,CN_XMPAXL* mpaxl)
 *
 *   @b ܣ
 *   @n XMPAXLĴ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *      index  ĴԣȡֵΪ0~7
 *      mpaxl  ṹ壬滻ĵַrAddr
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void CN_SetXMPAXL(unsigned int host,unsigned int index,CN_XMPAXL* mpaxl)
{
	CnHostRegs[host]->XMPAX[index].XMPAXL = mpaxl->rAddr << 4;
}

/**
********************************************************************************
 *   @n@b unsigned int CN_setPriority(unsigned int host,unsigned int priority)
 *
 *   @b ܣ
 *   @n ȼ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *      priority ȼȡֵ0~7ֵԽСȼԽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 0  ûжӦ
 *      1  ȷ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
unsigned int CN_setPriority(unsigned int host,unsigned int priority)
{
	volatile unsigned int *baseaddr;
	if(host < 36)
    	baseaddr = (volatile unsigned int*)(PRI_BASE + host * 0x4);		
	else if((host < 48)&(host >= 36))
    	baseaddr = (volatile unsigned int*)(PRI_BASE + 0x8000 + (host-36) * 0x4);
	else
		return 0;
    *baseaddr = priority;
	return 1;
}

/***********************************ַ***********************************/
/**
********************************************************************************
 *   @n@b void MEMPROT_CN_SetProgrammableAddressInfo(unsigned int host,unsigned int index,unsigned int startAddress,unsigned int endAddress,CN_MEMPROT_MPPA * mppa)
 *
 *   @b ܣ
 *   @n õַļĴ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *      index  ĴԣȡֵΪ0~7
 *      startAddress ܱʼַ
 *      endAddress   ܱĽַ
 *      mppa   ܱ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void MEMPROT_CN_SetProgrammableAddressInfo(unsigned int host,unsigned int index,unsigned int startAddress,unsigned int endAddress,CN_MEMPROT_MPPA * mppa)
{
	if(host < 36)
	{
		hCn0MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPSAR = startAddress/0x10000;//64KB
		hCn0MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPEAR = endAddress/0x10000;

		hCn0MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPPA = (mppa->ns << 7) | (mppa->emu << 6)
												   |(mppa->sr << 5) | (mppa->sw << 4) | (mppa->sx << 3)
												   |(mppa->ur << 2) | (mppa->uw << 1) | (mppa->ux);
	}
	else
	{
		host = host - 36;
		hCn1MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPSAR = startAddress/0x10000;//64KB
		hCn1MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPEAR = endAddress/0x10000;

		hCn1MemprotRegs->MPPARegs[host].MEMPROT_Host[index].MPPA = (mppa->ns << 7) | (mppa->emu << 6)
												   |(mppa->sr << 5) | (mppa->sw << 4) | (mppa->sx << 3)
												   |(mppa->ur << 2) | (mppa->uw << 1) | (mppa->ux);
	}
}

/**
********************************************************************************
 *   @n@b void MEMPROT_CN_getFaultType(unsigned int host,MEMPROT_EXTYPE * xmcextype)
 *
 *   @b ܣ
 *   @n ȡַ쳣
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *      xmcextype 쳣ͣĳһλΪ1ʾӦλ쳣
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void MEMPROT_CN_getFaultType(unsigned int host,MEMPROT_EXTYPE * xmcextype)
{
	volatile unsigned int value = 0;
	if(host < 36)
	{
		value = hCn0MemprotRegs->MPPARegs[host].EXTYPE;
	}
	else
	{
		host = host - 36;
		value = hCn1MemprotRegs->MPPARegs[host].EXTYPE;
	}
		
	xmcextype->ns  = (value & 0x80)>>7;
	xmcextype->emu = (value & 0x40)>>6;
	xmcextype->sr  = (value & 0x20)>>5;
	xmcextype->sw  = (value & 0x10)>>4;
	xmcextype->sx  = (value & 0x8)>>3;
	xmcextype->ur  = (value & 0x4)>>2;
	xmcextype->uw  = (value & 0x2)>>1;
	xmcextype->ux  =  value & 0x1;
}

/**
********************************************************************************
 *   @n@b unsigned int MEMPROT_CN_getFaultStatus(unsigned int host)
 *
 *   @b ܣ
 *   @n ȡַ쳣״̬
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 1:쳣
 *      0:쳣
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
unsigned int MEMPROT_CN_getFaultStatus(unsigned int host)
{
	volatile unsigned int value = 0;
	if(host < 36)
	{
		value = hCn0MemprotRegs->MPPARegs[host].EXTSTATUS;
	}
	else
	{
		host = host - 36;
		value = hCn1MemprotRegs->MPPARegs[host].EXTSTATUS;
	}
    return value;
}


/**
********************************************************************************
 *   @n@b void MEMPROT_CN_clearFault(unsigned int host)
 *
 *   @b ܣ
 *   @n ַ쳣״̬
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void MEMPROT_CN_clearFault(unsigned int host)
{
	if(host < 36)
	{
		hCn0MemprotRegs->MPPARegs[host].EXCLEAR = 1;
	}
	else
	{
		host = host - 36;
		hCn1MemprotRegs->MPPARegs[host].EXCLEAR = 1;
	}
}


/**
********************************************************************************
 *   @n@b unsigned int MEMPROT_CN_getFaultAddress(unsigned int host)
 *
 *   @b ܣ
 *   @n ȡַ쳣ַ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 쳣ַ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
unsigned int MEMPROT_CN_getFaultAddress(unsigned int host)
{
	volatile unsigned int value = 0;
	if(host < 36)
	{
		value = (hCn0MemprotRegs->MPPARegs[host].EXADDR)<<16;
	}
	else
	{
		host = host - 36;
		value = (hCn1MemprotRegs->MPPARegs[host].EXADDR)<<16;
	}
    return value;
}

/**
********************************************************************************
 *   @n@b void MEMPROT_CN_setExenable(unsigned int host)
 *
 *   @b ܣ
 *   @n ַ쳣ʹ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void MEMPROT_CN_setExenable(unsigned int host)
{
	if(host < 36)
	{
		hCn0MemprotRegs->MPPARegs[host].EXENABLE = 1;
	}
	else
	{
		host = host - 36;
		hCn1MemprotRegs->MPPARegs[host].EXENABLE = 1;
	}

}


/**
********************************************************************************
 *   @n@b void CN_UnLockCrossnet()
 *
 *   @b ܣ
 *   @n crossnetļĴд
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 256bitֻҪһΣhostֵѡΪ36~47
 *   	128bitֻҪһΣhostֵѡΪ0~35
 *******************************************************************************
 */
void CN_UnLockCrossnet(unsigned int host)
{
	if(host < 36)
		*(unsigned int*)CN_CONFIG_EN = 0x59484654;//дkeyֵCONFIG_ENΪ1
	else
		*(unsigned int*)(CN_CONFIG_EN + 0x8000) = 0x59484654;//дkeyֵCONFIG_ENΪ1		
}

/**
********************************************************************************
 *   @n@b void CN_LockCrossnet()
 *
 *   @b ܣ
 *   @n crossnetļĴ
 *
 *   @b βΣ
 *   @verbatim
 *      host   ȡֵ0~47M6678E_CrossNet.h
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 256bitֻҪһΣhostֵѡΪ36~47
 *   	128bitֻҪһΣhostֵѡΪ0~35
 *******************************************************************************
 */
void CN_LockCrossnet(unsigned int host)
{
	if(host < 36)
		*(unsigned int*)CN_CONFIG_EN = 0;//дkeyֵCONFIG_ENΪ0
	else
		*(unsigned int*)(CN_CONFIG_EN + 0x8000) = 0;//дkeyֵCONFIG_ENΪ0		
}

/**
********************************************************************************
 *   @n@b void CN_SetThreshold(unsigned int host,unsigned int Threshold)
 *
 *   @b ܣ
 *   @n crossnetĳʱֵ
 *
 *   @b βΣ
 *   @verbatim
 *   	host   ȡֵ0~47M6678E_CrossNet.h
 *      Threshold  ʱڣĬΪ128
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 256bitֻҪһΣhostֵѡΪ36~47
 *   	128bitֻҪһΣhostֵѡΪ0~35
 *******************************************************************************
 */
void CN_SetThreshold(unsigned int host,unsigned int Threshold)
{
	if(host < 36)
		*(unsigned int*)CN_THRESHOLD = Threshold;
	else
		*(unsigned int*)(CN_THRESHOLD + 0x8000) = Threshold;		
}

