/**
********************************************************************************
* @file       M6678E_DMA.c
* @brief      ʵM6678E DMAֹܵĽӿں
* @version    V1.0
* @date       2021.05.19
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <c6x.h>
#include "M6678E_DMA.h"

/** @addtogroup DMA_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b DMA_ParaConfig(volatile unsigned int DMA_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n DMAú
 *
 *   @b βΣ
 *   @verbatim
 *       DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       Numb  Ϊͨ
 *       QueueNUM Ϊк   Ϊֻ4УԸò0~3 ĸ
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void DMA_ParaConfig(volatile unsigned int DMA_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	volatile unsigned int DMA_BASE=0;
	volatile int  set_OPT_addr ;
	volatile int  DNUM_Temp=0;
	int  Numb_temp = 0 ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;
	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x4 ;
	int  OPT_aar   = Numb *0x20 ;
	int  Numb_TCC  = Numb <<12 ;
	int  OPT_worth = 0x00900004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;

	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	*(int*)(DMA_BASE+DCHMAP_offset + Numb_addr)= OPT_aar;
	/* ÿʼ */
	DNUM_Temp = *(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 ) = DNUM_Temp ;
	/*  ý     */

	/*       */
	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;

	if(Numb <32)
		*(int*)(DMA_BASE+IESR_offset)      =  IntEnable;
	else
		*(int*)(DMA_BASE+IESR_offset+0x4)  =  IntEnable;
}


/**
********************************************************************************
 *   @n@b DMA_Start(volatile unsigned int DMA_Numb ,volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n DMA亯
 *
 *   @b βΣ
 *   @verbatim
 *   	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void DMA_Start(volatile unsigned int DMA_Numb , volatile unsigned int Numb)
{
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;
	if(Numb <32)
	{
		int ESR_worth = 1 << Numb;
		*(int*)(DMA_BASE+EMCR_offset)     = ESR_worth;
		*(int*)(DMA_BASE+SECR_offset)     = ESR_worth;
		*(int*)(DMA_BASE+ESR_offset )     = ESR_worth;
	}
	else
	{
		Numb = Numb - 32 ;
		int  ESR_worth = 1 << Numb;
		*(int*)(DMA_BASE+EMCR_offset+0x4) = ESR_worth;
		*(int*)(DMA_BASE+SECR_offset+0x4) = ESR_worth;
		*(int*)(DMA_BASE+ESR_offset+0x4 ) = ESR_worth;
	}
}

/**
********************************************************************************
 *   @n@b DMA_TransState(volatile unsigned int DMA_Numb ,volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n DMA״̬ѯ
 *
 *   @b βΣ
 *   @verbatim
 *   	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n ɣֵ1
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int DMA_TransState(volatile unsigned int DMA_Numb , volatile unsigned int Numb)
{
	volatile int set_IPR_tmp = 0;
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	if(Numb <32)
	{
		int IPR_worth = 1 << Numb;
		while( set_IPR_tmp != IPR_worth )
		{
			set_IPR_tmp = *(int*)(DMA_BASE+IPR_offset);
			set_IPR_tmp = IPR_worth & set_IPR_tmp;
		}
		*(int*)(DMA_BASE+ICR_offset)  = IPR_worth;
	}
	else
	{
		Numb = Numb - 32 ;
		int IPR_worth = 1 << Numb;
		while( set_IPR_tmp != IPR_worth )
		{
			set_IPR_tmp = *(int*)(DMA_BASE+IPR_offset+0X4);
			set_IPR_tmp = IPR_worth & set_IPR_tmp;
		}
		*(int*)(DMA_BASE+ICR_offset+0X4) = IPR_worth;
	}

	return  1 ;
}

/**
********************************************************************************
 *   @n@b QDMA_ParaConfig_Start(volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n QDMAú
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ,QDMAֻ֧8
 *       QueueNUM Ϊк  Ϊֻ4УԸò0~3 4
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void QDMA_ParaConfig_Start(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	int  set_OPT_addr ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;

	volatile int  DNUM_Temp=0;
	int  Numb_temp = 0 ;

	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x00000004 ;
	int  OPT_aar   = Numb *0x00000020 ;
	int  Numb_TCC  = Numb <<12 ;
	int  OPT_worth = 0x00900004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;
	int  TRWORD = 0;   /*עTRWORDΪ07κһΪѡжӦĸΪ֡*/

	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	*(int*)(DMA_BASE+IESR_offset)      =  IntEnable;

	*(int*)(DMA_BASE+QCHMAP_offset + Numb_addr)= OPT_aar + TRWORD*0x4; /*ûԶ*/

	/*  ÿʼ     */
	DNUM_Temp = *(int*)(DMA_BASE+QDMAQNUM_offset );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+QDMAQNUM_offset  ) = DNUM_Temp ;
	/*  ý     */

	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;

	*(int*)(DMA_BASE+QEESR_offset )        = 0x1 << Numb;

	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;/*TRWORD8һ*/

}

/**
********************************************************************************
 *   @n@b QDMA_TransState(volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n QDMA״̬ѯ
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ,QDMAֻ֧8
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int QDMA_TransState(volatile unsigned int DMA_Numb , volatile unsigned int Numb)
{
	volatile int set_IPR_tmp = 0;
	int IPR_worth = 1 << Numb;
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	while( set_IPR_tmp != IPR_worth )
	{
		set_IPR_tmp = *(int*)(DMA_BASE+IPR_offset);
		set_IPR_tmp = IPR_worth & set_IPR_tmp;
	}
	*(int*)(DMA_BASE+ICR_offset)  = IPR_worth;

	return  1 ;
}

/**
********************************************************************************
 *   @n@b DMA_LINK_Config(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n DMAӹú
 *
 *   @b βΣ
 *   @verbatim
 *       DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ,QDMAֻ֧8
 *       QueueNUM Ϊк  Ϊֻ4УԸò0~3 4
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 1Ϊ˱βι࣬ýӿںеĲΪ    ãĲںڲãûж塣
 *      2Ӳûƣ˴ֻǲ
 *******************************************************************************
 */
void DMA_LINK_Config(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	int  set_OPT_addr ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;
	int  DNUM_Temp=0;
	int  Numb_temp = 0 ;
	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x00000004 ;
	int  OPT_aar   = Numb *0x00000020 ;
	int  Numb_TCC  = Numb <<12 ;
//	int  OPT_worth = 0x00500004  |  Numb_TCC ;
	int  OPT_worth = 0x00400004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;

	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	*(int*)(DMA_BASE+DCHMAP_offset + Numb_addr)= OPT_aar;
	/*  ÿʼ     */
	DNUM_Temp = *(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 ) = DNUM_Temp ;
	/*  ý     */

	/* һ */
	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;     //0x0C100000
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;//0x0C110000
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X00014020;/*һԵַĵ 16 λ*/
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;
	/* ӵĵڶ */
	*(int*)(DMA_BASE+set_OPT_addr+0x20)    = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x24)    = SourceAddr+0x20000;//0x0C120000
	*(int*)(DMA_BASE+set_OPT_addr+0x28)    = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0x2c)    = DestinationAddr+0x20000;//0x0C130000
	*(int*)(DMA_BASE+set_OPT_addr+0x30)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x34)    = 0X00014040;
	*(int*)(DMA_BASE+set_OPT_addr+0x38)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x3c)    = 0X00010001;
	/* ӵĵ */
	*(int*)(DMA_BASE+set_OPT_addr+0x40)    = OPT_worth&0xFFBFFFFF|0x00100000;
	*(int*)(DMA_BASE+set_OPT_addr+0x44)    = SourceAddr+0x40000;//0x0C140000
	*(int*)(DMA_BASE+set_OPT_addr+0x48)    = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0x4c)    = DestinationAddr+0x40000;//0x0C150000
	*(int*)(DMA_BASE+set_OPT_addr+0x50)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x54)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x58)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x5c)    = 0X00010001;

	*(int*)(DMA_BASE+IESR_offset)      =  IntEnable;

}

/**
********************************************************************************
 *   @n@b DMA_ShadowArea_Config(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n DMAӹú
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       ShadowArea_NumbΪӰţ07Ч
 *       NumbΪͨ,QDMAֻ֧8
 *       QueueNUM Ϊк  Ϊֻ4УԸò0~3 4
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void DMA_ShadowArea_Config(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	int  set_OPT_addr ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;
	int  DNUM_Temp=0;
	int  Numb_temp = 0 ;
	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x4 ;
	int  OPT_aar   = Numb *0x20 ;
	int  Numb_TCC  = Numb <<12 ;
	int  OPT_worth = 0x00900004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;

	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	//ûԶӰӦͨ
	*(int*)(DMA_BASE+DRAE0_offset+ShadowArea_Numb*8)       = 0xffffffff;
	*(int*)(DMA_BASE+DRAEH0_offset+ShadowArea_Numb*8)       = 0xffffffff;
	//ûԶͨӦĲ
	*(int*)(DMA_BASE+DCHMAP_offset + Numb_addr)= OPT_aar;

	/*  ÿʼ     */
	DNUM_Temp = *(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 ) = DNUM_Temp ;
	/*  ý     */

	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;

	if(Numb <32)
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200  +Shadow_IESR_offset)  =  IntEnable;
	else
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200 +Shadow_IESHR_offset)  =  IntEnable;
}

/**
********************************************************************************
 *   @n@b DMA_ShadowArea_Start(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n DMAӰ
 *
 *   @b βΣ
 *   @verbatim
 * 		 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       ShadowArea_NumbΪӰţ07Ч
 *       NumbΪͨ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void DMA_ShadowArea_Start(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb)
{
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	if(Numb <32)
	{
		int ESR_worth = 1 << Numb;
		*(int*)(DMA_BASE+EMCR_offset)     = ESR_worth;
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_SECR_offset)  = ESR_worth;
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_ESR_offset)  = ESR_worth;
	}
	else
	{
		Numb = Numb - 32 ;
		int  ESR_worth = 1 << Numb;
		*(int*)(DMA_BASE+EMCR_offset+0x4) = ESR_worth;
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_SECHR_offset)  = ESR_worth;
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_ESHR_offset)  = ESR_worth;
	}
}

/**
********************************************************************************
 *   @n@b DMA_ShadowArea_TransState(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n DMAӰ״̬ѯ
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       ShadowArea_NumbΪӰţ07Ч
 *       NumbΪͨ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n ɷ1
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int DMA_ShadowArea_TransState(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb , volatile unsigned int Numb)
{
	volatile int set_IPR_tmp = 0;
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	if(Numb <32)
	{
		int IPR_worth = 1 << Numb;
		while( set_IPR_tmp != IPR_worth )
		{
			set_IPR_tmp = *(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_IPR_offset);
			set_IPR_tmp = IPR_worth & set_IPR_tmp;
		}
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_ICR_offset)  = IPR_worth;
	}
	else
	{
		Numb = Numb - 32 ;
		int IPR_worth = 1 << Numb;
		while( set_IPR_tmp != IPR_worth )
		{
			set_IPR_tmp = *(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_IPHR_offset);
			set_IPR_tmp = IPR_worth & set_IPR_tmp;
		}
		*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_ICHR_offset) = IPR_worth;
	}

	return  1 ;
}

/**
********************************************************************************
 *   @n@b QDMA_ShadowArea_ParaConfig_Start(volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n QDMAӰú
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       ShadowArea_NumbΪӰţ07Ч
 *       NumbΪͨ,QDMAֻ֧8
 *       QueueNUM Ϊк  Ϊֻ4УԸò0~3 4
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void QDMA_ShadowArea_ParaConfig_Start(volatile unsigned int DMA_Numb,volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	int  set_OPT_addr ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;
	int  DNUM_Temp=0;
	int  Numb_temp = 0 ;
	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x00000004 ;
	int  OPT_aar   = Numb *0x00000020 ;
	int  Numb_TCC  = Numb <<12 ;
	int  OPT_worth = 0x00900004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;
	int  TRWORD = 1;   /*עTRWORDΪ07κһΪѡжӦĸΪ֡*/

	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	/*ûԶӰӦͨ*/
	*(int*)(DMA_BASE+QRAE0_offset+ShadowArea_Numb*4)       = 0xffffffff;

	*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*(0x200)+Shadow_IESR_offset)      =  IntEnable;
	*(int*)(DMA_BASE+IESR_offset)      =  IntEnable;

	*(int*)(DMA_BASE+QCHMAP_offset + Numb_addr)= OPT_aar + TRWORD*0x4; //ûԶ*/

	/*  ÿʼ     */
	DNUM_Temp = *(int*)(DMA_BASE+QDMAQNUM_offset );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+QDMAQNUM_offset  ) = DNUM_Temp ;
	/*  ý     */

	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;

	*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_QEESR_offset )        = 0x1 << Numb;

	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;/*TRWORD8һ*/
}

/**
********************************************************************************
 *   @n@b QDMA_ShadowArea_TransState(volatile unsigned int ShadowArea_Numb,volatile unsigned int Numb)
 *
 *   @b ܣ
 *   @n QDMAӰ״̬ѯ
 *
 *   @b βΣ
 *   @verbatim
 *    	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       ShadowArea_NumbΪӰţ07Ч
 *       NumbΪͨţQDMAֻ֧8
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n ɷ1
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int QDMA_ShadowArea_TransState(volatile unsigned int DMA_Numb ,volatile unsigned int ShadowArea_Numb, volatile unsigned int Numb)
{
	volatile int set_IPR_tmp = 0;
	volatile int IPR_worth = 1 << Numb;
	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	while( set_IPR_tmp != IPR_worth )
	{
		set_IPR_tmp = *(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_IPR_offset);
		set_IPR_tmp = IPR_worth & set_IPR_tmp;
	}
	*(int*)(DMA_BASE+ShadowArea0_offset+ ShadowArea_Numb*0x200+Shadow_ICR_offset)  = IPR_worth;

	return  1 ;
}

/**
********************************************************************************
 *   @n@b DMA_Syn_Event_ParaConfig(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
 *
 *   @b ܣ
 *   @n DMAͬ¼ú
 *
 *   @b βΣ
 *   @verbatim
 *  	 DMA_Numb ΪDMAѡΪDMA0DMA2еһ
 *       NumbΪͨ
 *       QueueNUM Ϊк  Ϊֻ4УԸò0~3 4
 *       SourceAddrΪԴַ
 *       AcountΪֽ
 *       BcountΪ֡
 *       DestinationAddrΪĿĵַ
 *       IntEnableΪжʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void DMA_Syn_Event_ParaConfig(volatile unsigned int DMA_Numb ,volatile unsigned int Numb ,volatile unsigned int QueueNUM,volatile unsigned int SourceAddr,volatile unsigned int Acount,volatile unsigned int Bcount,volatile unsigned int DestinationAddr,volatile unsigned int IntEnable)
{
	int  set_OPT_addr ;
	int  Bcount_tmp = Bcount << 16;
	int  Acount_tmp = Acount << 16;
	int  DNUM_Temp=0;
	int  Numb_temp = 0 ;
	int  ABcount = Bcount_tmp | Acount;
	int  Excursion =  Acount_tmp | Acount;
	int  Numb_addr = Numb *0x4 ;
	int  OPT_aar   = Numb *0x20 ;
	int  Numb_TCC  = Numb <<12 ;
	int  OPT_worth = 0x00900004  |  Numb_TCC ;
	set_OPT_addr = OPT_offset + OPT_aar ;

	volatile unsigned int DMA_BASE=0;
	DMA_BASE = DMA0_BASE + DMA_Numb * 0x40000;

	*(int*)(DMA_BASE+DCHMAP_offset + Numb_addr)= OPT_aar;

	/*  ÿʼ     */
	DNUM_Temp = *(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 );
	Numb_temp = Numb % 8 ;
	switch(Numb_temp)
	{
	case 0: DNUM_Temp = (DNUM_Temp & 0xFFFFFFF0) | QueueNUM; break;
	case 1: DNUM_Temp = (DNUM_Temp & 0xFFFFFF0F) | (QueueNUM << 4 ) ; break;
	case 2: DNUM_Temp = (DNUM_Temp & 0xFFFFF0FF) | (QueueNUM << 8 ) ; break;
	case 3: DNUM_Temp = (DNUM_Temp & 0xFFFF0FFF) | (QueueNUM << 12) ; break;
	case 4: DNUM_Temp = (DNUM_Temp & 0xFFF0FFFF) | (QueueNUM << 16) ; break;
	case 5: DNUM_Temp = (DNUM_Temp & 0xFF0FFFFF) | (QueueNUM << 20) ; break;
	case 6: DNUM_Temp = (DNUM_Temp & 0xF0FFFFFF) | (QueueNUM << 24) ; break;
	case 7: DNUM_Temp = (DNUM_Temp & 0x0FFFFFFF) | (QueueNUM << 28) ; break;
	default: break;
	}
	*(int*)(DMA_BASE+DMAQNUM_offset + (Numb/8)*0x4 ) = DNUM_Temp ;
	/*  ý     */

	*(int*)(DMA_BASE+set_OPT_addr)         = OPT_worth;
	*(int*)(DMA_BASE+set_OPT_addr+0x4)     = SourceAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x8)     = ABcount;
	*(int*)(DMA_BASE+set_OPT_addr+0xc)     = DestinationAddr;
	*(int*)(DMA_BASE+set_OPT_addr+0x10)    = Excursion;
	*(int*)(DMA_BASE+set_OPT_addr+0x14)    = 0X0001FFFF;
	*(int*)(DMA_BASE+set_OPT_addr+0x18)    = 0X00010001;
	*(int*)(DMA_BASE+set_OPT_addr+0x1c)    = 0X00010001;

	if(Numb <32)
	{
		*(int*)(DMA_BASE+EESR_offset)      =  1<<Numb;
		*(int*)(DMA_BASE+IESR_offset)      =  IntEnable;
	}
	else
	{
		*(int*)(DMA_BASE+EESHR_offset)      =  1<<(Numb - 32);
		*(int*)(DMA_BASE+IESR_offset+0x4)  =  IntEnable;
	}
}
