/**
********************************************************************************
* @file       M6678E_GMAC.c
* @brief      ʵM6678E GMACĸֽӿں
* @version    V1.0
* @date       2022.04.22
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/

#include "M6678E_PSC.h"
#include "M6678E_GMAC.h"

#include "string.h"
#include "stdio.h"
#include "stdint.h"

/** @addtogroup GMAC_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b void Gmac_Open_Clk()
 *
 *   @b ܣ
 *   @n ѡGMACģʱ
 *
 *   @b βΣ
 *   @verbatim
 *       gmac_num    ҪģʱӵGMAC
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_Open_Clk()
{

	PSC_Open_Clk("RGMII", 2);

	return;
}
/**
********************************************************************************
 *   @n@b void Gmac_Close_Clk()
 *
 *   @b ܣ
 *   @n رѡGMACģʱ
 *
 *   @b βΣ
 *   @verbatim
 *       gmac_num    ҪرģʱӵGMAC
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_Close_Clk()
{

	PSC_Close_Clk("RGMII",2);

	return;
}
/**
********************************************************************************
 *   @n@b void Gmac_SystemClk()
 *
 *   @b ܣ
 *   @n GMACϵͳʱӣGMACʱ(˴ΪգùM6678E_PLLʵ)
 *
 *   @b βΣ
 *   @verbatim
 *       
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_SystemClk()
{

}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_DescList(GMAC_Desc * DESC, uint8_t *BufMem)
 *
 *   @b ܣ
 *   @n ʼGMACббַĴDMA3DMA4
 *
 *   @b βΣ
 *   @verbatim
 *
 *		 DESC		   	бĻַ
 *		 BufMem		   	ݻbuffer
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_DescList(GMAC_Desc * DESC, uint8_t *BufMem)
{
	int32_t    i;
	uint8_t  *buf;
	GMAC_Desc *ptDesc;
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	/*ýб*/
	ptDesc = DESC;
	/*״*/
	for(i=0;i<RDESCount;i++)
	{
		buf = &BufMem[PKT_SIZE_FRAMEBUF*i];//ڴ˴ѾʹõBuffer˵
		ptDesc->DES0   =  RDES0_OWN;	   //ȫΪDMAӵ
		if(i==RDESCount-1)
			ptDesc->DES1   =  0x03000000|PKT_SIZE_FRAMEBUF;
		else
			ptDesc->DES1   =  0x01000000|PKT_SIZE_FRAMEBUF;

		ptDesc->DES2   = l2_global_address((uint32_t)buf);

		if(i==RDESCount-1)
			ptDesc->DES3  =  l2_global_address((uint32_t)(&ptDesc[-(RDESCount-1)]));
		else
			ptDesc->DES3  =  l2_global_address((uint32_t)(&ptDesc[1]));;
		ptDesc++;
	}
	/*״*/
	for(i=0;i<TDESCount;i++)
	{
	   ptDesc->DES0 = 0x00000000;

	   if(i != TDESCount-1)
		   ptDesc->DES1 = 0xE1000000;
	   else
		   ptDesc->DES1 = 0xE3000000;
	   if(i != TDESCount-1)
		   ptDesc->DES3 = l2_global_address((uint32_t)(&ptDesc[1]));
	   else
		   ptDesc->DES3 = l2_global_address((uint32_t)(&ptDesc[-(TDESCount-1)]));
	   ptDesc++;
	}

	DMA_Regs->DMA3 = l2_global_address((uint32_t)(&DESC[0]));			/*бַ */
	DMA_Regs->DMA4 = l2_global_address((uint32_t)(&DESC[RDESCount]));	/*бַ */

	return;
}
/**
********************************************************************************
 *   @n@b void Gmac_DMA_RxDescList(uint32_t DescListAddr)
 *
 *   @b ܣ
 *   @n ʼGMACббַĴDMA3DMA4
 *
 *   @b βΣ
 *   @verbatim
 *       gmac_num    		ѡʹõGMAC(GMAC0,GMAC1)
 *		 DescListAddr		бĻַ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_RxDescList(uint32_t DescListAddr)
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA3 = DescListAddr;			/*бַ */
}
/**
********************************************************************************
 *   @n@b void Gmac_DMA_TxDescList(uint32_t DescListAddr)
 *
 *   @b ܣ
 *   @n ʼGMACббַĴDMA3DMA4
 *
 *   @b βΣ
 *   @verbatim
 *       gmac_num    		ѡʹõGMAC(GMAC0,GMAC1)
 *		 DescListAddr		бĻַ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_TxDescList(uint32_t DescListAddr)
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA4 = DescListAddr;			/*бַ */
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_SoftReset()
 *
 *   @b ܣ
 *   @n ʼGMACλ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_SoftReset()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	//λGMAC
	DMA_Regs->DMA0 = 0x00000001;

	//ȴGMACλ
	while ((DMA_Regs->DMA0) & 0x1);

	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_BusOptMode()
 *
 *   @b ܣ
 *   @n  GMACDMAģʽĴ,GMAC-DMAߵĲģʽ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_BusOptMode()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA0 = (0x1 << 25)|		//AAL: Address-Aligned Beats
					 (0x0 << 24)|		//8xPBL Mode
					 (0x1 << 23)|		//USP: Use Separate PBL
					 (0x8 << 17)|		//RPBL: RxDMA PBL
					 (0x1 << 16)|		//FB: Fixed Burst
					 (0x0 << 14)|		//PR: Priority Ratio
					 (0x8 << 8)|		//PBL: Programmable Burst Length
					 (0x0 << 7)|		//ATDS: Alternate Descriptor Size
					 (0x0 << 2)|		//DSL[6:2]: Descriptor Skip Length
					 (0x0 << 1)|		//DA: DMA Arbitration Scheme
					 (0x0 << 0);		//SWR: Software Reset
//	DMA_Regs->DMA0 = 0x01821000;
	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_RxPollDemand()
 *
 *   @b ܣ
 *   @n  GMAC,RxѡRxDMAڹ״̬ʱѡܹRxDMA
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_RxPollDemand()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	//ýѡĴ
	DMA_Regs->DMA2 = 0x00000001;
	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_TxPollDemand()
 *
 *   @b ܣ
 *   @n   GMAC,TxѡTxDMAڹ״̬ʱѡܹTxDMA
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_TxPollDemand()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	//÷ѡĴ
	DMA_Regs->DMA1 = 0x00000001;

	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_OptMode_SF()
 *
 *   @b ܣ
 *   @n   GMACDMA6Ĵ,GMAC-DMAĲģʽ洢תģʽ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_OptMode_SF()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	//صҪע⣺FIFO full=4KB,FIFOݴﵽ(full-1KB)=3KBʱأ(full-2KB)=2KBʱأ
	//صãOSF bit[2]ģʽ    ֵģʽ(RTC+TTC)			--0x0101490C
	//                                     洢תģʽRSF+TSF	--0x0320090C
//	DMA_Regs->DMA6 = 0x0320090C;
	DMA_Regs->DMA6 = 	(0x1<<26)|			//Disable Dropping of TCP/IP Checksum Error Frames
						(0x1<<25)|			//RSF: Receive Store and Forward
						(0x0<<24)|			//DFF: Disable Flushing of Received Frames
						(0x0<<23)|			//RFA[2]: MSB of Threshold for Activating Flow Control
						(0x0<<22)|			//RFD[2]: MSB of Threshold for Deactivating Flow Control
						(0x1<<21)|			//TSF: Transmit Store and Forward
						(0x0<<20)|			//FTF: Flush Transmit FIFO
						(0x5<<14)|			//16:14 TTC: Transmit Threshold Control
						(0x0<<13)|			//ST: Start/Stop Transmission Command
						(0x1<<11)|			//12:11 Threshold for deactivating flow control
						(0x1<<9)|			//10:9  Threshold for activating flow control
						(0x1<<8)|			//EFC: Enable HW flow control
						(0x1<<7)|			//FEF: Forward Error Frames
						(0x1<<6)|			//FUF: Forward Undersized Good Frames
						(0x1<<3)|			// 4:3 RTC: Receive Threshold Control
						(0x1<<2)|			//OSF: Operate on Second Frame
						(0x0<<1);			//SR: Start/Stop Receive
}
/**
********************************************************************************
 *   @n@b void Gmac_DMA_OptMode_TF()
 *
 *   @b ܣ
 *   @n   GMACDMA6Ĵ,GMAC-DMAĲģʽ;ֵģʽ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_OptMode_TF()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	//صҪע⣺FIFO full=4KB,FIFOݴﵽ(full-1KB)=3KBʱأ(full-2KB)=2KBʱأ
	//صãOSF bit[2]ģʽ    ֵģʽ(RTC+TTC)			--0x0101490C
	//                                     洢תģʽRSF+TSF	--0x0320090C

//	DMA_Regs->DMA6 = 0x0101490C;
	DMA_Regs->DMA6 = 	(0x1<<26)|			//Disable Dropping of TCP/IP Checksum Error Frames
						(0x0<<25)|			//RSF: Receive Store and Forward
						(0x1<<24)|			//DFF: Disable Flushing of Received Frames
						(0x0<<23)|			//RFA[2]: MSB of Threshold for Activating Flow Control
						(0x0<<22)|			//RFD[2]: MSB of Threshold for Deactivating Flow Control
						(0x0<<21)|			//TSF: Transmit Store and Forward
						(0x0<<20)|			//FTF: Flush Transmit FIFO
						(0x5<<14)|			//16:14 TTC: Transmit Threshold Control
						(0x0<<13)|			//ST: Start/Stop Transmission Command
						(0x1<<11)|			//12:11 Threshold for deactivating flow control
						(0x1<<9)|			//10:9  Threshold for activating flow control
						(0x1<<8)|			//EFC: Enable HW flow control
						(0x1<<7)|			//FEF: Forward Error Frames
						(0x1<<6)|			//FUF: Forward Undersized Good Frames
						(0x1<<3)|			// 4:3 RTC: Receive Threshold Control
						(0x1<<2)|			//OSF: Operate on Second Frame
						(0x0<<1);			//SR: Start/Stop Receive
}
/**
********************************************************************************
 *   @n@b void Gmac_DMA_InterruptEna()
 *
 *   @b ܣ
 *   @n   GMACDMA7Ĵ,GMACҪʹܵж
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_InterruptEna()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA7  =  (0x1 << 16)|		//bit[16]: NIE жʹ
					   (0x1 << 15)|		//bit[15]: AIS жʹ
					   (0x1 <<  7)|		//bit[ 7]: RU  bufж
					   (0x1 <<  6)|		//bit[ 6]: RI  ж
					   (0x1 <<  4);		//bit[ 4]: RI  ж

	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_InterruptDisa()
 *
 *   @b ܣ
 *   @n   GMACDMA7Ĵ,رж
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_InterruptDisa()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA7=0;

	return;
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_CheckAXIStatu()
 *
 *   @b ܣ
 *   @n   GMACDMA11Ĵ,AXI߶/д ͨ״ֱ̬ڿ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_CheckAXIStatu()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	/*ȡ AXI Ķ/дͨ״̬*/
	while(((DMA_Regs->DMA11) & 0x3));//[1:0]Ϊ00ôͻῨڴ˴

	return;
}

/**
********************************************************************************
 *   @n@b void GMAC_DMA_AXIOptMode()
 *
 *   @b ܣ
 *   @n   GMACDMA10Ĵ,AXIߵĲģʽ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_AXIOptMode()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA10  =  0x0023000f;
	return;
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_DMA_GetStaus()
 *
 *   @b ܣ
 *   @n   GMACDMA5Ĵ,ȡDMA״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n ʱѡDMA5ĴֵDMA״̬״̬
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_DMA_GetStaus()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	return DMA_Regs->DMA5 ;	//DMA5Ĵֵ
}

/**
********************************************************************************
 *   @n@b void Gmac_DMA_ClrStaus()
 *
 *   @b ܣ
 *   @n   GMACDMA5Ĵ,DMA5Ĵж״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n ʱѡDMA5ĴֵDMA״̬״̬
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_ClrStaus(uint32_t val)
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA5 = val;	//DMA5Ĵдضֵж״̬

	return;
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_DMA_GetCurTxDesc()
 *
 *   @b ܣ
 *   @n   GMACDMA18Ĵ,ȡǰ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  ǰĵַ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_DMA_GetCurTxDesc()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	return DMA_Regs->DMA18 ;	//DMA18Ĵֵ
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_DMA_GetCurRxDesc()
 *
 *   @b ܣ
 *   @n   GMACDMA19Ĵ,ȡǰ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  ǰĵַ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_DMA_GetCurRxDesc()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	return DMA_Regs->DMA19 ;	//DMA19Ĵֵ
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_DMA_GetCurTxBuf()
 *
 *   @b ܣ
 *   @n   GMACDMA20Ĵ,ȡǰbuffer
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  ǰbufferĵַ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_DMA_GetCurTxBuf()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	return DMA_Regs->DMA20 ;	//DMA20Ĵֵ
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_DMA_GetCurRxBuf()
 *
 *   @b ܣ
 *   @n   GMACDMA21Ĵ,ȡǰbuffer
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  ǰbufferĵַ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_DMA_GetCurRxBuf()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	return DMA_Regs->DMA21 ;	//DMA21Ĵֵ
}

/**
********************************************************************************
 *   @n@b void  Gmac_DMA_RxEna()
 *
 *   @b ܣ
 *   @n   GMACDMA6Ĵ,ʹRxDMA
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_RxEna()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA6 |= (1<<1);	//bit[1]д1ʹRxDMA

	return;
}



/**
********************************************************************************
 *   @n@b void  Gmac_DMA_RxDisa()
 *
 *   @b ܣ
 *   @n   GMACDMA6Ĵ,رRxDMA
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_RxDisa()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA6 &= ~(1<<1);	//bit[1]д0رRxDMA

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_DMA_TxEna()
 *
 *   @b ܣ
 *   @n    GMACDMA6Ĵ,ʹTxDMA
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_TxEna()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA6 |= (1<<13);	//bit[13]д1ʹTxDMA

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_DMA_TxDisa()
 *
 *   @b ܣ
 *   @n    GMACDMA6Ĵ,رTxDMA״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_DMA_TxDisa()
{
	DMARegs   *DMA_Regs;

	DMA_Regs = (DMARegs*)GMAC_DMA_BASE;

	DMA_Regs->DMA6 &= ~(1<<13);	//bit[13]д0رTxDMA

	return;
}


/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetHashRegs(uint32_t Hash1,uint32_t Hash2)
 *
 *   @b ܣ
 *   @n    GMACMAC2,MAC3,HashĴHash1hash2
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetHashRegs(uint32_t Hash1,uint32_t Hash2)
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;

    MAC_Regs->MAC2 = Hash1;
    MAC_Regs->MAC3 = Hash2;

	return;
}
/**
********************************************************************************
 *   @n@b void  Gmac_MAC_GetHashRegs(uint32_t *Hash1,uint32_t *Hash2)
 *
 *   @b ܣ
 *   @n    GMACMAC2,MAC3,ȡHashĴHash1hash2
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_GetHashRegs(uint32_t *Hash1,uint32_t *Hash2)
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    *Hash1 = MAC_Regs->MAC2;
    *Hash2 = MAC_Regs->MAC3;

	return;
}

/**
********************************************************************************
 *   @n@b int Gmac_MAC_GetLinkChange()
 *
 *   @b ܣ
 *   @n    GMACMAC14,ȴLink״̬ı
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int Gmac_MAC_GetLinkChange()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	return ((MAC_Regs->MAC14)&0x1);
}


/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetOptMode(SpeedMode Speed,DuplexMode  Duplex)
 *
 *   @b ܣ
 *   @n    GMACMAC0,MACĲģʽʡ˫
 *
 *   @b βΣ
 *   @verbatim
 *
 *       Speed		 ģʽ(10Mbps/100Mbps/1000Mbps)
 *       Duplex		 ˫ģʽ(ȫ˫(FullDuplex)/˫(HalfDuplex))
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetOptMode(SpeedMode Speed, DuplexMode  Duplex)
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    MAC_Regs->MAC0 = (0x1 << 25)|		//ʹ̫֡typeֵ0x0600CRC
    				 (0x1 << 24)|		//ʹRGMII˫ģʽʡ ɹ/Ͽ ͸PHY
    				 (0x1 << 23)|		//νտŹGMACܹ16384ֽڵ֡
    				 (0x1 << 22)|		//ηjabberʱ,GMACܹ16384ֽڵ֡
    				 (0x1 << 21)| 	 	//֡ͻʹbit[21]=1
    				 (0x1 << 20)|		//jumbo֡ʹbit[20]=1
    				 (0x0 << 17)|		//bit[19:17]-IPG ֡= 3b00096 bit time
    				 (0x1 << 16)|		//bit[16]˫λΪʱMACزͲȫ˫ģʽ£λֻ
    				 (0x1 << 13)|		//bit[13]νգ˫PHY˷Чʱκ֡λΪPHYʱԽݰ
    				 (0x1 <<  9);		//bit[9]ԣ˫ͳͻʱGMACԵǰֻ֡һͻ֡״̬


	if(Duplex == FullDuplex)
	{
		if(Speed == Speed10Mbps)
			MAC_Regs->MAC0  |=  (0x2<<14)|(0x1<<11);
		else if(Speed == Speed100Mbps)
			MAC_Regs->MAC0	|=  (0x3<<14)|(0x1<<11);
		else if(Speed == Speed1000Mbps)
			MAC_Regs->MAC0	|=  (0x0<<14)|(0x1<<11);
	}
	else if(Duplex == HalfDuplex)
	{
		if(Speed == Speed10Mbps)
			MAC_Regs->MAC0  |=  (0x2<<14);
		else if(Speed == Speed100Mbps)
			MAC_Regs->MAC0	|=  (0x3<<14);
		else
			printf("has not 1000Mbps HalfDuplex!\n");
	}

	MAC_Regs->MAC0 |= (0x1<<8);		//Link up
	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetLoopBack()
 *
 *   @b ܣ
 *   @n    GMACMAC0,MACLOOPBACKģʽ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetLoopBack()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	MAC_Regs->MAC0 |= (0x1<<12);		//LoopBack

	asm(" MFENCE ");    
	asm(" nop 1");
	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_RGMII_WaitPHYLink()
 *
 *   @b ܣ
 *   @n  GMACMAC54,ȴLinkӳɹ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_RGMII_WaitPHYLink()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	while(((MAC_Regs->MAC54)&0x8)!=0x8);

	return;
}


/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetFlowControl()
 *
 *   @b ܣ
 *   @n  GMACMAC6,ع
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetFlowControl()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    										//1 ʱ϶slot-timesΪGMII/MIIӿڷ512-bitʱ
    MAC_Regs->MAC6 = (0x100<<16)| 			//bit[31:16]Ϳ֡ͣʱ=256ʱ϶ԶͣʱΪ256ʱ϶
    				 (0x0   <<4)|			//bit[5:4]PT-4ʱ϶ʱͿ֡ķͼΪ256-4=252ʱ϶
    				 (0x1   <<3)|			//bit[3]ĿĵַMAC0,MAC1Ϊַͣ֡
    				 (0x1   <<2)|			//bit[2]ʹ
    				 (0x1   <<1);			//bit[1]ʹ

	while(MAC_Regs->MAC6 & 0x01);	//ȴpause֡꣬bit[0]


	return;
}
/**
********************************************************************************
 *   @n@b void  Gmac_MAC_GetFlowControl()
 *
 *   @b ܣ
 *   @n  GMACMAC6,ȡ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_MAC_GetFlowControl()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	return MAC_Regs->MAC6;
}
/**
********************************************************************************
 *   @n@b void  Gmac_MAC_GetDebugStatus()
 *
 *   @b ܣ
 *   @n  ȡGMACMAC9 DebugԼĴ
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
uint32_t Gmac_MAC_GetDebugStatus()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	return MAC_Regs->MAC9;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_InterruptMask()
 *
 *   @b ܣ
 *   @n  GMACMAC15,RGMIIӿڵκ״̬ıж
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_InterruptMask()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    //MAC15bit0RGMIIӿڵκ״̬ĸıжλ
    MAC_Regs->MAC15 = 0x1;

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_GetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum );
 *
 *   @b ܣ
 *   @n  GMACMAC16MAC17,ȡǰ豸MACַ
 *
 *   @b βΣ
 *   @verbatim
 *
 *       MacAddr     õĵǰ豸MACַ
 *       MacAddrNum  MACַıţMACַĴ棨MAC16|MAC17MAC18|MAC19MAC20|MAC21MAC0,MAC1,MAC1ַ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_GetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum )
{
	uint32_t   highaddr, lowaddr;
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    if(MacAddrNum ==0 )  //MACַ16λӦMAC16Ĵ32λӦMAC17Ĵ
    {
    	highaddr = MAC_Regs->MAC16;
    	lowaddr  = MAC_Regs->MAC17;
    }
    else if(MacAddrNum == 1)  //MACַ16λӦMAC18Ĵ32λӦMAC19Ĵ
    {
        highaddr = MAC_Regs->MAC18;
        lowaddr  = MAC_Regs->MAC19;
    }
    else if(MacAddrNum == 2)  //MACַ16λӦMAC20Ĵ32λӦMAC21Ĵ
    {
		highaddr = MAC_Regs->MAC20;
	 	lowaddr  = MAC_Regs->MAC21;
    }

	//MACַݰڴ
    MacAddr[0] =  lowaddr     &0xff;
    MacAddr[1] = (lowaddr>> 8)&0xff;
    MacAddr[2] = (lowaddr>>16)&0xff;
    MacAddr[3] = (lowaddr>>24)&0xff;
    MacAddr[4] =  highaddr    &0xff;
    MacAddr[5] = (highaddr>>8)&0xff;

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum )
 *
 *   @b ܣ
 *   @n  GMACMAC16MAC17,õǰ豸MACַ
 *
 *   @b βΣ
 *   @verbatim
 *
 *       MacAddr     õĵǰ豸MACַ
 *       MacAddrNum  MACַıţMACַĴ棨MAC16|MAC17MAC18|MAC19MAC20|MAC21MAC0,MAC1,MAC1ַ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetMacAddr(uint8_t* MacAddr,uint8_t MacAddrNum )
{
	uint32_t   highaddr, lowaddr;
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;


    if(MacAddrNum ==0 )  		//MACַ16λӦMAC16Ĵ32λӦMAC17Ĵ
    {
        MAC_Regs->MAC16=((MacAddr[5]<<8)&0xff00)|(MacAddr[4]&0x00ff);
        MAC_Regs->MAC17=((MacAddr[3]<<24)&0xff000000)|((MacAddr[2]<<16)&0xff0000)|((MacAddr[1]<<8)&0xff00)|(MacAddr[0]&0x00ff);
    }
    else if(MacAddrNum == 1)  	//MACַ16λӦMAC18Ĵ32λӦMAC19Ĵ
    {
        MAC_Regs->MAC18=((MacAddr[5]<<8)&0xff00)|(MacAddr[4]&0x00ff);
        MAC_Regs->MAC19=((MacAddr[3]<<24)&0xff000000)|((MacAddr[2]<<16)&0xff0000)|((MacAddr[1]<<8)&0xff00)|(MacAddr[0]&0x00ff);
    }
    else if(MacAddrNum == 2)  	//MACַ16λӦMAC20Ĵ32λӦMAC21Ĵ
   {
        MAC_Regs->MAC20=((MacAddr[5]<<8)&0xff00)|(MacAddr[4]&0x00ff);
        MAC_Regs->MAC21=((MacAddr[3]<<24)&0xff000000)|((MacAddr[2]<<16)&0xff0000)|((MacAddr[1]<<8)&0xff00)|(MacAddr[0]&0x00ff);
   }

	return;
}
/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetFraALLPass()
 *
 *   @b ܣ
 *   @n  GMACMAC2,ý֡Ĺģʽ,ͨ֡
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetFraALLPass()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    //е֡жಥַ֡ģе֡ͨ
    MAC_Regs->MAC1 = 0x80000011;

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_SetFilterBroadCastFra()
 *
 *   @b ܣ
 *   @n   GMACMAC2,ý֡Ĺģʽ,˹㲥֡
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_SetFilterBroadCastFra()
{
	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    //˹㲥֡Ŀĵַƥ֡
    MAC_Regs->MAC1 = 0x00000420;

	return;
}

/**
********************************************************************************
 *   @n@b int Gmac_MAC_Get_RxEnaStauts()
 *
 *   @b ܣ
 *   @n  GMACMAC0Ĵ,ʹReceiver״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  1
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int Gmac_MAC_Get_RxEnaStauts()
{

	MACRegs   *MAC_Regs;

	uint32_t  status=0;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    status=((MAC_Regs->MAC0 & 0x4)>>2);	//ȡbit[2]ȡʱ״̬ʹ״̬

    return  status;

}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_RxEna()
 *
 *   @b ܣ
 *   @n  GMACMAC0Ĵ,ʹReceiver״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_RxEna()
{

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    MAC_Regs->MAC0 |= (1<<2);	//bit[2]д1ʹReceiver״̬

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_RxDisa()
 *
 *   @b ܣ
 *   @n  GMACMAC0Ĵ,رReceiver״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_RxDisa()
{

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    MAC_Regs->MAC0 &= ~(1<<2);	//bit[2]д0رReceiver״̬

	return;
}

/**
********************************************************************************
 *   @n@b void  Gmac_MAC_TxEna()
 *
 *   @b ܣ
 *   @n  GMACMAC0Ĵ,ʹTransmitter״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_TxEna()
{

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    MAC_Regs->MAC0 |= (1<<3);	//bit[3]д1ʹTransmitter״̬


	return;
}



/**
********************************************************************************
 *   @n@b void  Gmac_MAC_TxDisa()
 *
 *   @b ܣ
 *   @n  GMACDMA6Ĵ,رTransmitter״̬
 *
 *   @b βΣ
 *   @verbatim
 *
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Gmac_MAC_TxDisa()
{

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

    MAC_Regs->MAC0 &= ~(1<<3);	//bit[3]д0رTransmitter״̬

	return;
}

/**
********************************************************************************
 *   @n@b uint32_t Gmac_MdioRead(volatile uint32_t PhyAddr,volatile uint32_t phyReg )
 *
 *   @b ܣ
 *   @n  GMAC,ͨMDIOȡPHYѡĴеֵ
 *
 *   @b βΣ
 *   @verbatim
 *
 *		 PhyAddr    PHYַ
 *		 phyReg     ҪȡPHYĵphyRegĴ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  ӼĴMAC_reg5жȡĴʱҪȡPHYĴֵ
 *
 *   <b> ע </b>
 *   @n ͨMDIOӿڹⲿPHYоƬ
 *       1.Ҫ֪ӲPHYоƬãPHYַ--Ŀǰ6678EDSK忨88E1512оƬPHYоƬ
 *       2.PHYоƬPHYַΪGMAC0ӦPHYַΪ1, 	GMAC1ӦPHYַΪ0
 *******************************************************************************
 */
uint32_t Gmac_MdioRead(volatile uint32_t PhyAddr,volatile uint32_t phyReg )
{
	volatile uint32_t   value1 = 0, value2 = 0;

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	while(((MAC_Regs->MAC4)&0x1)==1);//bit0λǷΪ1MDIOǷΪæ

	value1 =(PhyAddr<<11)|(phyReg<<6)|(0x1<<2)|(0<<1)|0x1;	//ʹMDIOΪģʽ

	MAC_Regs->MAC4 = value1;

	while(((MAC_Regs->MAC4)&0x1)==1);//bit0λǷΪ1MDIOǷΪæ

	value2 = MAC_Regs->MAC5;

	return value2;
}

/**
********************************************************************************
 *   @n@b void Gmac_MdioWrite(volatile uint32_t PhyAddr,volatile uint32_t phyReg ,volatile uint32_t value)
 *
 *   @b ܣ
 *   @n  GMAC,ͨMDIOȡPHYѡĴеֵ
 *
 *   @b βΣ
 *   @verbatim
 *
 *		 PhyAddr    PHYַ
 *		 phyReg     ҪдPHYĵphyRegĴ
 *		 value		ҪдPHYĴֵ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n ͨMDIOӿڹⲿPHYоƬ
 *       1.Ҫ֪ӲPHYоƬãPHYַ
 *       2.PHYоƬPHYַΪGMAC0ӦPHYַΪ1, 	GMAC1ӦPHYַΪ0
 *******************************************************************************
 */
void Gmac_MdioWrite(volatile uint32_t PhyAddr,volatile uint32_t phyReg ,volatile uint32_t value)
{
	volatile uint32_t   value1 = 0;

	MACRegs   *MAC_Regs;

	MAC_Regs = (MACRegs*)GMAC_MAC_BASE;;

	while(((MAC_Regs->MAC4)&0x1)==1);//bit0λǷΪ1MDIOǷΪæ

	value1 =(PhyAddr<<11)|(phyReg<<6)|(0x1<<2)|(0x1<<1)|0x1; //ʹMDIOΪдģʽ

	MAC_Regs->MAC5 = value;//ҪͨMDIOдֵMAC5Ĵ

	MAC_Regs->MAC4 = value1;//ʹMDIO˿д
	while(((MAC_Regs->MAC4)&0x1)==1);//bit0λǷΪ1MDIOǷΪæ
}


/**
********************************************************************************
 *   @n@b void  PrintfSpeedDuplex(SpeedMode speed, DuplexMode duplex)
 *
 *   @b ܣ
 *   @n  ӡGMAC˫ģʽϢ
 *
 *   @b βΣ
 *   @verbatim
 *
 *       Speed		 ģʽ(10Mbps/100Mbps/1000Mbps)
 *       Duplex		 ˫ģʽ(ȫ˫(FullDuplex)/˫(HalfDuplex))
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void PrintfSpeedDuplex(SpeedMode speed, DuplexMode duplex)
{

//	printf("GMAC Port:... \n");

	if((speed==Speed1000Mbps)&& (duplex==FullDuplex))
		printf("1000Mbps FullDuplex \n");
	else if((speed==Speed100Mbps)&& (duplex==FullDuplex))
		printf("100Mbps FullDuplex \n");
	else if((speed==Speed100Mbps)&& (duplex==HalfDuplex))
		printf("100Mbps HalfDuplex \n");
	else if((speed==Speed10Mbps)&& (duplex==FullDuplex))
		printf("10Mbps  FullDuplex \n");
	else if((speed==Speed10Mbps)&& (duplex==HalfDuplex))
		printf("10Mbps  HalfDuplex \n");
	else
		printf("SpeedDuplex err\n ");

}
