/** 
********************************************************************************
* @file       M6678_GPIO.c
* @brief      ʵGPIOĻƵĸֽӿںá
* @version    V1.0
* @date       2018.01.29
* @attention  
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/

#include "M6678E_GPIO.h"

/** @addtogroup GPIO_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b void GPIO_BINTEN(unsigned int  enable)
 *
 *   @b ܣ
 *   @n ȫжʹ
 *
 *   @b βΣ
 *   @verbatim
 *       enable	 GPIOģжʹܣ1ʾʹܣ0ʾʹ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */ 
void GPIO_BINTEN(unsigned int  enable)
{
	//áжʹܼĴ 
	DEV_GPIO->BINTEN = (unsigned int)enable & 0x1;
	asm(" MFENCE ");    
	asm(" nop 1");
}

/**
********************************************************************************
 *   @n@b GPIO_RISTRIG(unsigned int  ris)
 *
 *   @b ܣ
 *   @n شжϷʽ
 *
 *   @b βΣ
 *   @verbatim
 *       ris	 չGPIOÿһλ1ʾؼʹܣ0ʾؼر
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */ 
void GPIO_RISTRIG(unsigned int mode ,unsigned int  ris)
{
	//áشжϼĴ ͡شжϼĴ
	if(mode == 1)
		DEV_GPIO->SET_RIS_TRIG = (unsigned int)ris;
	else if(mode == 0)
		DEV_GPIO->CLR_RIS_TRIG = (unsigned int)ris;
	asm(" MFENCE ");    
	asm(" nop 1");
}

/**
********************************************************************************
 *   @n@b void GPIO_FALTRIG(unsigned int  fal)
 *
 *   @b ܣ
 *   @n ½شжϷʽ
 *
 *   @b βΣ
 *   @verbatim
 *       fal	 չGPIOÿһλ1ʾ½ؼʹܣ0ʾ½ؼر
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */ 
void GPIO_FALTRIG(unsigned int mode ,unsigned int  fal)
{
	//á½شжϼĴ ͡½شжϼĴ
	if(mode == 1)
		DEV_GPIO->SET_FAL_TRIG = (unsigned int)fal;
	else if(mode == 0)
		DEV_GPIO->CLR_FAL_TRIG = (unsigned int)fal;
	asm(" MFENCE ");    
	asm(" nop 1");
}

/**
********************************************************************************
 *   @n@b GPIO_DirectionSet(unsigned int  direction)
 *
 *   @b ܣ
 *   @n ÷
 *
 *   @b βΣ
 *   @verbatim
 *       direction	 չGPIOÿһλ1ʾ룬0ʾ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 1.ô˼ĴʱѾе涨ˣҪǰ滮ŵ
 *   @n 2.øüĴȱʡ״̬£еGPIO PINΪ
 *******************************************************************************
 */ 
void GPIO_DirectionSet(unsigned int  direction)
{
	//áĴ 
	DEV_GPIO->DIR = (unsigned int)direction;
	asm(" MFENCE ");    
	asm(" nop 1");
}



/**
********************************************************************************
 *   @n@b GPIO_DateOutnWriteX(unsigned int Numb,unsigned int polarity)
 *
 *   @b ܣ
 *   @n ̶ĳһλ01Ӧŵĸߵ͵ƽ
 *
 *   @b βΣ
 *   @verbatim
 *   	Numb	 	ʾĳһλ
 *		polarity	Ϊ10
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void GPIO_DateOutnWriteX(unsigned int Numb,unsigned int polarity)
{
	unsigned int outdata;
//	unsigned int * outdata_addr;
	outdata = 1 << Numb;
//	outdata_addr = (unsigned int *)DEV_GPIO->OUT_DATA;
	//"ݼĴ"иֵ
	if(polarity)
		DEV_GPIO->OUT_DATA = DEV_GPIO->OUT_DATA | outdata;
	else
		DEV_GPIO->OUT_DATA = DEV_GPIO->OUT_DATA & ~outdata;
	asm(" MFENCE ");    
	asm(" nop 1");
}

/**
********************************************************************************
 *   @n@b GPIO_DataOutWrite(unsigned int DataOut)
 *
 *   @b ܣ
 *   @n дֵ
 *
 *   @b βΣ
 *   @verbatim
 *   	DataOut	 	ʾһνеֵ趨 1Ϊ 0 Ϊ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void GPIO_DataOutWrite(unsigned int DataOut)
{
	DEV_GPIO->OUT_DATA = (unsigned int)DataOut;
	asm(" MFENCE ");    
	asm(" nop 1");
}

/**
********************************************************************************
 *   @n@b unsigned int GPIO_DataInputGet()
 *
 *   @b ܣ
 *   @n ȡGPIOֵ
 *
 *   @b βΣ
 *   @verbatim
 *   	
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n GPIOPIN״̬۸λڷݼĴ״̬
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
unsigned int GPIO_DataInputGet()
{
	//áݼĴ
	unsigned int inputdata1;
	inputdata1 = DEV_GPIO->IN_DATA;
	return inputdata1;
}

/**
********************************************************************************
 *   @n@b void GPIO_DataOutReverse(unsigned int Numb)
 *
 *   @b ܣ
 *   @n GPIOת
 *
 *   @b βΣ
 *   @verbatim
 *   	 Numb	ӦĶУ1ʾҪתGPIOλ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n ע˺һβGPIOֵʹʱҪNumbֵٽ
 *******************************************************************************
 */
void GPIO_DataOutReverse(unsigned int Numb)
{
	unsigned int outdata,invoutp[3];
	invoutp[0] = (unsigned int)Numb;
	//1.ȡΪ1ķתλ
	invoutp[1] = invoutp[0] & DEV_GPIO->OUT_DATA;
	//2.ȡΪ0ķתλ
	invoutp[2] = invoutp[0] & ~invoutp[1];
	//3.1תΪ0
	outdata = DEV_GPIO->OUT_DATA & ~invoutp[1];
	//4.תλϲ
	outdata = outdata | invoutp[2];
	//5.ֵ
	DEV_GPIO->OUT_DATA = outdata;
	asm(" MFENCE ");    
	asm(" nop 1");
}
