/**
********************************************************************************
* @file       M6678E_IPC.c
* @brief      ʵM6678E IPCĸֽӿں
* @version    V1.0
* @date       2023.01.05
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_IPC.h"

/** @addtogroup IPC_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b IPC_Send(unsigned int IPC_Numb , unsigned int IPC_SouceID)
 *
 *   @b ܣ
 *   @n IPC
 *
 *   @b βΣ
 *   @verbatim
 *       IPC_NumbΪIPCжϵĶ
 *                IPC_Numb=0  ʾ0IPCж
 *                IPC_Numb=1  ʾ1IPCж
 *                ...
 *                IPC_Numb=7  ʾ7IPCж
 *                IPC_Numb=12 ʾⲿж
 *       IPC_SouceID  һԱʾ28¼
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  IPC_Send(unsigned int IPC_Numb , unsigned int IPC_SouceID)
{
#if 0
	if(IPC_Numb == 12)
		*(volatile unsigned int*)IPCGRH = ((IPC_SouceID <<4) | 0x1);
	else
		*(volatile unsigned int*)(IPCGR0 + IPC_Numb * 4) = ((IPC_SouceID <<4) | 0x1);
#else
    int x = 0x1 << IPC_SouceID;

    if(IPC_Numb == 12)
    {
        *(volatile unsigned int *)IPCGRH = ((x << 4) | 0x1);
    }
    else
    {
        *(volatile unsigned int *)(IPCGR0 + IPC_Numb * 4) = (x << 4);
        *(volatile unsigned int *)(IPCGR0 + IPC_Numb * 4) = 0x1;
    }
#endif
}

/**
********************************************************************************
 *   @n@b IPC_AR_Release(unsigned int IPC_Numb , unsigned int IPC_SouceID)
 *
 *   @b ܣ
 *   @n IPCȷ
 *
 *   @b βΣ
 *   @verbatim
 *      1IPC_NumbΪIPCҪĶ
 *                IPC_Numb=0  ʾ0IPCж
 *                IPC_Numb=1  ʾ1IPCж
 *                ...
 *                IPC_Numb=7  ʾ7IPCж
 *                IPC_Numb=12 ʾⲿж
 *      2IPC_SouceID  Ӧɵ28¼
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void IPC_AR_Release(unsigned int IPC_Numb , unsigned int IPC_SouceID)
{
#if 0
	if (IPC_Numb == 12)
		*(volatile unsigned int*)IPCARH = IPC_SouceID << 4;
	else
		*(volatile unsigned int*)(IPCAR0 + IPC_Numb * 4) = IPC_SouceID << 4;
#else
    int x = 0x1 << IPC_SouceID;

    if(IPC_Numb == 12)
    {
        *(volatile unsigned int *)IPCARH = (x << 4);
    }
    else
    {
        *(volatile unsigned int *)(IPCAR0 + IPC_Numb * 4) = (x << 4);
    }
#endif
}

/**
********************************************************************************
 *   @n@b unsigned int IPC_Src_Get(unsigned int IPC_Numb)
 *
 *   @b ܣ
 *   @n IPCȷ
 *
 *   @b βΣ
 *   @verbatim
 *      IPC_Numb ΪIPCҪȡĶ
 *                IPC_Numb=0  ʾȡ0IPCж
 *                IPC_Numb=1  ʾȡ1IPCж
 *                ...
 *                IPC_Numb=7  ʾȡ7IPCж
 *                IPC_Numb=12 ʾȡⲿж
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n IPC_SouceID  ɵ28¼е¼
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
unsigned int IPC_Src_Get(unsigned int IPC_Numb)
{
    int srcx = *(volatile unsigned int *)(IPCGR0 + IPC_Numb * 4);
    int i = 0;

    srcx = srcx >> 4;

    while(i < 28)
    {
        if(srcx & 0x1)
        {
            return i;
        }
        i++;
        srcx = srcx >> 1;
    }

    return i;
}

void IPC_Send_ARMCore(unsigned int CoreNumb , unsigned int IPC_SouceID)
{
    int x = 0x1 << IPC_SouceID;
    *(volatile unsigned int *)(IPCG_ARM + CoreNumb * 4) = (x << 4);
    *(volatile unsigned int *)(IPCG_ARM + CoreNumb * 4) = 0x1;
}

/*
 *   @n IPCGĴȡsrcid
 *   @n 31-4λΪжԴָʾλ
 *   @n Ӧλд0Ч
 *   @n Ӧλд1ͬʱ SRCSx  IPCAx ĴӦλ SRCCx
 *   @n ʶͬжԴṩ 28 жԴ,жԴλ뺬ȫ
 *   @n 3-1λΪλֻɶȫ
 *   @n 0λΪIPCжϲλ0д1һIPC¼Ӧˣд0Ч
*/
unsigned int IPC_Src_ARMCore(unsigned int CoreNumb)
{
    int srcx = *(volatile unsigned int *)(IPCG_ARM + CoreNumb * 4);
    int i = 0;

    srcx = srcx >> 4;

    while(i < 28)
    {
        if(srcx & 0x1)
        {
            return i;
        }
        i++;
        srcx = srcx >> 1;
    }

    return i;
}

/**
********************************************************************************
 *   @n@b IPC_AR_Release_ARMCore(unsigned int CoreNumb , unsigned int IPC_SouceID)
 *
 *   @b ܣ
 *   @n IPCȷ
 *   @n 31-4λΪжԴλ
 *   @n Ӧλд0Ч
 *   @n Ӧλд1ͬʱ SRCCx  IPCGx ĴӦλ SRCSx
 *   @n 3-0λΪλֻɶȫ
 *
 *   @b βΣ
 *   @verbatim
 *      1CoreNumbΪIPCҪĶ
 *                CoreNumb=0  ʾ0IPCж
 *                CoreNumb=1  ʾ1IPCж
 *                ...
 *                CoreNumb=7  ʾ7IPCж
 *                CoreNumb=12 ʾⲿж
 *      2IPC_SouceID  Ӧɵ28¼
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void IPC_AR_Release_ARMCore(unsigned int CoreNumb , unsigned int IPC_SouceID)
{
    int x = 0x1 << IPC_SouceID;

    if(CoreNumb == 12)
    {
        *(volatile unsigned int *)IPCARH = (x << 4);
    }
    else
    {
        *(volatile unsigned int *)(IPCA_ARM + CoreNumb * 4) = (x << 4);
    }
}

/*
 *   @n IPCAĴȡsrcid
 *   @n 31-4λΪжԴλ
 *   @n Ӧλд0Ч
 *   @n Ӧλд1ͬʱ SRCCx  IPCGx ĴӦλ SRCSx
 *   @n 3-0λΪλֻɶȫ
 */
unsigned int IPC_AR_Src_DSPCore(unsigned int CoreNumb)
{
    int srcx = *(volatile unsigned int *)(IPCAR0 + CoreNumb * 4);
    int i = 0;

    srcx = srcx >> 4;

    while(i < 28)
    {
        if(srcx & 0x1)
        {
            return i;
        }
        i++;
        srcx = srcx >> 1;
    }

    return i;
}

/*
 *   @n IPCAĴȡsrcid
 *   @n 31-4λΪжԴλ
 *   @n Ӧλд0Ч
 *   @n Ӧλд1ͬʱ SRCCx  IPCGx ĴӦλ SRCSx
 *   @n 3-0λΪλֻɶȫ
 */
unsigned int IPC_AR_Src_ARMCore(unsigned int CoreNumb)
{
    int srcx = *(volatile unsigned int *)(IPCA_ARM + CoreNumb * 4);
    int i = 0;

    srcx = srcx >> 4;

    while(i < 28)
    {
        if(srcx & 0x1)
        {
            return i;
        }
        i++;
        srcx = srcx >> 1;
    }

    return i;
}

