/**
********************************************************************************
* @file       M6678E_Interrupt.c
* @brief      ʵжõĸֽӿں
* @version    V1.0
* @date       2021.03.22
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_Interrupt.h"

/** @addtogroup Interrupt_FUNCTION
 @{ */

/**
********************************************************************************
*	@n@b Interrupt_Service_Table(void *ISR_Addr)
*
*	@b ܣ
*   @n жϷ
*
*   @b βΣ
*   @verbatim
*		ISR_Addr жϷַĻַ֣ɲ鿴CMDļ
*	@endverbatim
*
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
******************************************************************************
*/
void Interrupt_Service_Table(unsigned int ISR_Addr)
{
	ISTP = ISR_Addr;
}



/**
********************************************************************************
*   @n@b M6678E_Int_GlobalEnable(unsigned int IntVector)
*
*   @b ܣ
*   @n ȫжʹܺ
*
*   @b βΣ
*   @verbatim
*      IntVectorӦж¼ţ÷ΧΪ4~15
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void M6678E_Int_GlobalEnable(unsigned int IntVector)
{
	TSR = TSR | 1;//״̬ĴGIEλʹеж
	IER = IER | 2 | (1<<IntVector);//жʹܼĴIntVectorݱʾ򿪶Ӧжһλ

}


/**
********************************************************************************
*   @n@b M6678E_CoreIntc_Set(int Evt_Num)
*
*   @b ܣ
*   @n ֶж¼EFRλ
*
*   @b βΣ
*   @verbatim
*      Evt_NumӦINTCж¼
*   @endverbatim
*
*   <b> ֵ </b>
*   @n Evt_Num:INTCж¼¼
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
int M6678E_CoreIntc_Set(int Evt_Num)
{
	int Int_Mux_reg;
	int Int_Mux_bit;
	Int_Mux_reg = Evt_Num/32;       //ȡEVTSET0~4Ĵ
	Int_Mux_bit = Evt_Num%32;       //ȡEVTSETĴĳһλ
	*(int *)(EVTSET0 + (4*Int_Mux_reg)) =  (1<<Int_Mux_bit);
	return Evt_Num;
}


/**
********************************************************************************
*   @n@b M6678E_CoreIntcFlag_READ(int Evt_Num)
*
*   @b ܣ
*   @n ǶȡEFRλ
*
*   @b βΣ
*   @verbatim
*      Evt_NumӦINTCж¼
*   @endverbatim
*
*   <b> ֵ </b>
*   @n EFRFlag:ضӦEFR־λ
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
int M6678E_CoreIntcFlag_READ(int Evt_Num)
{
	int Int_Mux_reg;
	int Int_Mux_bit;
	int EFRFlag;
	Int_Mux_reg = Evt_Num/32;       //ȡEVTSET0~4Ĵ
	Int_Mux_bit = Evt_Num%32;       //ȡEVTSETĴĳһλ
	EFRFlag = (*(int *)(EVTFLAG0 + (4*Int_Mux_reg)))>>Int_Mux_bit;
	return EFRFlag;
}


/**
********************************************************************************
*   @n@b M6678E_CoreInt_Init()
*
*   @b ܣ
*   @n ú˼жϿʼͨECR¼־ĴEFR¼־
*
*   @b βΣ
*   @verbatim
*
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void M6678E_CoreInt_Init()
{
	*(int*)( EVTCLR0 )  =  0xFFFFFFFF;
	*(int*)( EVTCLR1 )  =  0xFFFFFFFF;
	*(int*)( EVTCLR2 )  =  0xFFFFFFFF;
	*(int*)( EVTCLR3 )  =  0xFFFFFFFF;
}


/**
********************************************************************************
*   @n@b M6678E_CoreInt_Set(int Evt_Num, int Int_Num)
*
*   @b ܣ
*   @n ںжϿ,ҪжѡĴINTMUX
*
*   @b βΣ
*   @verbatim
*		Evt_NumǶӦж¼
*		Int_Numʾ׼ɵļźжϣ÷ΧΪ4~15.
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void M6678E_CoreInt_Set(int Evt_Num, int Int_Num)
{

	int Int_Mux_Num;
	int Int_Mux_Value;
	int Int_Mux_Byte;
	int temp_value;
	Int_Mux_Num = Evt_Num / 32;
	temp_value = Evt_Num % 32;
	*(int*)(EVTCLR0 + 4*Int_Mux_Num) = (1<<temp_value);

	Int_Mux_Num = Int_Num / 4;
	Int_Mux_Byte = Int_Num % 4;
	Int_Mux_Value = *(int*)(INTMUX_ADDR + 4*Int_Mux_Num);
	temp_value = (Evt_Num<<(8*Int_Mux_Byte));
	switch(Int_Mux_Byte)
	{
	case 0: Int_Mux_Value = Int_Mux_Value & 0xFFFFFF00 | temp_value; break;
	case 1: Int_Mux_Value = Int_Mux_Value & 0xFFFF00FF | temp_value; break;
	case 2: Int_Mux_Value = Int_Mux_Value & 0xFF00FFFF | temp_value; break;
	case 3: Int_Mux_Value = Int_Mux_Value & 0x00FFFFFF | temp_value; break;
	default: break;
	}
	*(int*)(INTMUX_ADDR + 4*Int_Mux_Num) = Int_Mux_Value;

}


/**
********************************************************************************
*   @n@b M6678E_ChipInt_Set(int Sys_Evt, int Host_Int)
*
*   @b ܣ
*   @n ƬжϿʼҪжʹָüĴ ͨӳĴ
*
*   @b βΣ
*   @verbatim
*		Sys_EvtƬж¼
*		Host_Intʾ׼ɵļж.
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void M6678E_ChipInt_Set(int Sys_Evt, int Host_Int)
{
	int CH_Map_Value;
	int CH_Map_Num;
	int CH_Map_Byte;
	int temp_value;

		//״ָ̬ĴӦĵж¼
		*(int*)(CIC_BASE+INT_CLR_INDEX_REG_offset)  = Sys_Evt;
		//ʹж¼
		CH_Map_Num = Sys_Evt / 4;           //ҪõͨӳĴ
		CH_Map_Byte = Sys_Evt % 4;          //ҪõͨӳĴֽ
		CH_Map_Value =*(int*)(CIC_BASE+ CH_MAP_REG0 + 4*CH_Map_Num);      		//ȡҪõͨӳĴֵ
		temp_value = (Host_Int<<(8*CH_Map_Byte));
		switch(CH_Map_Byte)
		{
		case 0:   CH_Map_Value = CH_Map_Value & 0xffffff00 | temp_value;
		break;
		case 1:   CH_Map_Value = CH_Map_Value & 0xffff00ff | temp_value;
		break;
		case 2:   CH_Map_Value = CH_Map_Value & 0xff00ffff | temp_value;
		break;
		case 3:   CH_Map_Value = CH_Map_Value & 0x00ffffff | temp_value;
		break;
		default:  CH_Map_Value = CH_Map_Value ;
		}
		*(int*)(CIC_BASE+ CH_MAP_REG0 + 4*CH_Map_Num) = CH_Map_Value;     		//ֵд뵽ҪõͨӳĴ
}


/**
********************************************************************************
*   @n@b M6678E_ChipInt_Clear(int Sys_Evt_Numb)
*
*   @b ܣ
*   @n ضƬж¼
*
*   @b βΣ
*   @verbatim
*		Sys_Evt_NumbΪҪж¼
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void M6678E_ChipInt_Clear(int Sys_Evt_Numb )
{
	*(int*)(CIC_BASE+INT_CLR_INDEX_REG_offset)  = Sys_Evt_Numb;

}


/**
********************************************************************************
*   @n@b Soft_CIC_Set(int Sys_Evt_Numb )
*
*   @b ܣ
*   @n ضж¼
*
*   @b βΣ
*   @verbatim
*		Sys_Evt_NumbΪҪõж¼
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void Soft_CIC_Set(int Sys_Evt_Numb)
{
	*(int*)(CIC_BASE+INT_SET_INDEX_REG_offset)  = Sys_Evt_Numb;

}
