/**
********************************************************************************
* @file       6678E_PLL.c
* @brief      ʱӵĽӿں
* @version    V1.0
* @date       2024/1/15
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_PLL.h"
#include "M6678E_PSC.h"
#include "stdio.h"





#define 	GENMASK(h, l) \
    ((((uint32_t)~0U) << (l)) & (((uint32_t)~0U) >> (32 - 1 - (h))))

/** @addtogroup PLL_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b void //pll_wait(uint32_t i)
 *
 *   @b ܣ
 *   @n  ʱ
 *
 *   @b βΣ
 *   @verbatim
 *			i		--------	ѭִnop 5ĴעʱֻǴԵʱ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */


static void pll_wait(uint32_t i)
{
	volatile uint32_t c=0;
	for(c=0;c<i;c++)
	{
		asm(" nop 5 ");
	}
}

void DSPCLKV_PLL(uint8_t RATIO)
{

	//2.3.2.2	ɱƵ

	PSC_Close_Clk("EMIF",1);	//ıǰҪرEMIFʱӣ

	//	1) DSPִMFENCEָȷǰѴϣ
	asm(" MFENCE ");
	asm(" nop 5 ");

		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2) ͨ̽DSP_PLLDIVеRATIOıΪԤֵ
	DSP_PLLDIV = RATIO;
	pll_wait(1000);

	PSC_Open_Clk("EMIF",1);	//EMIFʱ

}

void SYS_TP_PLL(uint8_t RATIO_TP)
{

	//2.3.2.2	ɱƵ

	PSC_Close_Clk("TP",1);	//ıǰҪرTPʱӣ
	//	1) DSPִMFENCEָȷǰѴϣ
		asm(" MFENCE ");
		asm(" nop 5 ");

		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2) ͨ̽ARM_PLLDIVеRATIOıΪԤֵ
	ARM_PLLDIV = RATIO_TP;
	pll_wait(1000);

	PSC_Open_Clk("TP",1);	//TPʱ

}


void ARMCLKV_PLL(uint8_t RATIO_arm)
{

	//2.3.2.2	ɱƵ

	PSC_Close_Clk("ARMA15",3);	//ıǰҪرARMʱӣ
	//	1) DSPִMFENCEָȷǰѴϣ
		asm(" MFENCE ");
		asm(" nop 5 ");

		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2) ͨ̽ARM_PLLDIVеRATIOıΪԤֵ
	ARM_PLLDIV = RATIO_arm;
	pll_wait(1000);

	PSC_Open_Clk("ARMA15",3);	//ARMʱ

}

void ACC_FFT_PLL(uint8_t RATIO1)
{

	//2.3.2.2	ɱƵ

	PSC_Close_Clk("FFT",1);		//ıǰҪرFFTʱӣ
	PSC_Close_Clk("FFT1",1);	//ıǰҪرFFTʱӣ

	//	1) DSPִMFENCEָȷǰѴϣ
	asm(" MFENCE ");
	asm(" nop 5 ");

	KICK0=0x83e70b13;  		//KickerƼĴ KICK0
	KICK1=0x95a4f1e0; 	 	//KickerƼĴ KICK1

	//	2) ͨ̽ACC_PLLDIV1еRATIOıΪԤֵ
	ACC_PLLDIV1 = RATIO1;
	pll_wait(1000);

	PSC_Open_Clk("FFT",1);	//FFTʱӣ
	PSC_Open_Clk("FFT1",1);	//FFT1ʱӣ


}


void ACC_PNNA_PLL(uint8_t RATIO2)
{

	//2.3.2.2	ɱƵ

	PSC_Close_Clk("PNNA",1);		//ıǰҪرPNNAʱӣ
	//	1) DSPִMFENCEָȷǰѴϣ
	asm(" MFENCE ");
	asm(" nop 5 ");

		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2) ͨ̽ACC_PLLDIV2еRATIOıΪԤֵ
	ACC_PLLDIV2 = RATIO2;
	pll_wait(1000);

	PSC_Open_Clk("PNNA",1);		//PNNAʱ

}


/**
********************************************************************************
 *   @n@b void DSP_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  DSP_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- ǰƵϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1     | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 1250         | 25(DSK)       		| 100    | 1      |       1    |     0     |
 * | 1000         | 25(DSK)             | 80     | 1      |       1    |     0     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	DSP_PLL = FOUTVCO/DIV1/DIV2
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void DSP_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
		asm(" MFENCE ");
		asm(" nop 5 ");
		float DSP_PLL_FOUTVCO;
		//	1) DSPִMFENCEָȷǰѴϣ
		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

		//	2DSP_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
		DSP_PLLCTL |= 0x1;
		pll_wait(20);

		//	3) DSP_PLLCMDеENPLLдΪ0ضPLL
		DSP_PLLCMD &= 0xfffffffe;

		//	4) DSP_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
		DSP_PLLCTL = (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

		DSP_PLL_FOUTVCO= oscclk/PLLN*PLLM;


		if((1600 > DSP_PLL_FOUTVCO)|(DSP_PLL_FOUTVCO > 3200))
		{
			printf("Warning!!!DSP_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",DSP_PLL_FOUTVCO);

		}

		//	5) ٵȴ1usDSP_PLLCMDеENPLLдΪ1
		pll_wait(200);
		DSP_PLLCMD |= 0x1;

		//	6) ٵȴ250us ѯDSP_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
		while(!(DSP_PLLCMD & (1<<1)));

		//7) DSP_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
		DSP_PLLCTL &= 0xfffffffe;
		pll_wait(1000);
	}


/**
********************************************************************************
 *   @n@b void NOC_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  DSP_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- ǰƵϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 1500         | 25(DSK)       		| 120    | 1      |       1    |     0     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	NOC_PLL = FOUTVCO/DIV1/DIV2
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void NOC_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
		asm(" MFENCE ");
		asm(" nop 5 ");
		float NOC_PLL_FOUTVCO;
		//	1) DSPִMFENCEָȷǰѴϣ
		KICK0=0x83e70b13;  //KickerƼĴ KICK0
		KICK1=0x95a4f1e0;  //KickerƼĴKICK1

		//	2NOC_PLLCTLеBYPASSдΪ1ٵȴNOC_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
		NOC_PLLCTL |= 0x1;
		pll_wait(20);

		//	3) NOC_PLLCMDеENPLLдΪ0ضPLL
		NOC_PLLCMD &= 0xfffffffe;

		//	4) NOC_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
		NOC_PLLCTL = (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

		NOC_PLL_FOUTVCO= oscclk/PLLN*PLLM;
		if((1600 > NOC_PLL_FOUTVCO)|(NOC_PLL_FOUTVCO > 3200))
		{
			printf("Warning!!!NOC_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",NOC_PLL_FOUTVCO);

		}

		//	5) ٵȴ1usNOC_PLLCMDеENPLLдΪ1
		pll_wait(200);
		NOC_PLLCMD |= 0x1;

		//	6) ٵȴ500us ѯNOC_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
		while(!(NOC_PLLCMD & (1<<1)));

		//7) NOC_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
		NOC_PLLCTL &= 0xfffffffe;
		pll_wait(1000);
	}



/**
********************************************************************************
 *   @n@b void SYS_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  SYS_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- Ƶϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 1000         | 25(DSK)       		| 80     | 1      |       1    |     0     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	SYS_PLL = FFOUTVCO/DIV1/DIV2
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void SYS_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float SYS_PLL_FOUTVCO;

	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2SYS_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	SYS_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) SYS_PLLCMDеENPLLдΪ0ضPLL
	SYS_PLLCMD &= 0xfffffffe;

	//	4) SYS_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	SYS_PLLCTL =  (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	SYS_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > SYS_PLL_FOUTVCO)|(SYS_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!SYS_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",SYS_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usSYS_PLLCMDеENPLLдΪ1
	pll_wait(200);
	SYS_PLLCMD |= 0x1;

	//	6) ٵȴ500us ѯSYS_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(SYS_PLLCMD & (1<<1)));

	//7) SYS_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	SYS_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}




/**
********************************************************************************
 *   @n@b void PCIE_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  PCIE_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- Ƶϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 400          | 25(DSK)       		| 128    | 1      |       2    |     1     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	PCIE_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */

void PCIE_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float PCIE_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2PCIE_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	PCIE_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) PCIE_PLLCMDеENPLLдΪ0ضPLL
	PCIE_PLLCMD &= 0xfffffffe;

	//	4) PCIE_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	PCIE_PLLCTL =  (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	PCIE_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > PCIE_PLL_FOUTVCO)|(PCIE_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!PCIE_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",PCIE_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usPCIE_PLLCMDеENPLLдΪ1
	pll_wait(200);
	PCIE_PLLCMD |= 0x1;

	//	6) ٵȴ500us ѯPCIE_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(PCIE_PLLCMD & (1<<1)));

	//7) PCIE_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	PCIE_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}




/**
********************************************************************************
 *   @n@b void DDR_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  DDR_PLL_InitʼṩDDRʱ
 *
 *   @b βΣ
 *   @verbatim
 *	   PLLM ------- Ƶϵ
 *	   PLLN ------- Ƶϵ
 *	   POSTDIV2 --- Ƶϵ2
 *	   POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+---------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN    | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+---------+------------+-----------+
 * | 800          | 25(DSK)       		| 128    | 1       |      1     |     1     |
 * | 400          | 25(DSK)             | 128    | 1       |      2     |     1     |
 * +--------------+---------------------+--------+---------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	DDR_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */

void DDR_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float DDR_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2DDR_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	DDR_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) DDR_PLLCMDеENPLLдΪ0ضPLL
	DDR_PLLCMD &= 0xfffffffe;

	//	4) DDR_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	DDR_PLLCTL =  (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	DDR_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > DDR_PLL_FOUTVCO)|(DDR_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!DDR_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",DDR_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usDDR_PLLCMDеENPLLдΪ1
	pll_wait(200);
	DDR_PLLCMD |= 0x1;

	//	6) ٵȴ500us ٵȴ500us ٵȴ500usѯDDR_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(DDR_PLLCMD & (1<<1)));

	//7) DDR_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	DDR_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}




/**
********************************************************************************
 *   @n@b void ACC_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  ACC_PLL_InitʼṩACCʱ
 *
 *   @b βΣ
 *   @verbatim
 *	   PLLM ------- Ƶϵ
 *	   PLLN ------- Ƶϵ
 *	   POSTDIV2 --- Ƶϵ2
 *	   POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+---------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN    | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+---------+------------+-----------+
 * | 2000         | 25(DSK)       		| 80     | 1       |      0     |     0     |
 * | 1800         | 25(DSK)             | 72     | 1       |      0     |     0     |
 * +--------------+---------------------+--------+---------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	ACC_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */

void ACC_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float ACC_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2ACC_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	ACC_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) ACC_PLLCMDеENPLLдΪ0ضPLL
	ACC_PLLCMD &= 0xfffffffe;

	//	4) ACC_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	ACC_PLLCTL =  (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	ACC_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > ACC_PLL_FOUTVCO)|(ACC_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!ACC_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",ACC_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usACC_PLLCMDеENPLLдΪ1
	pll_wait(200);
	ACC_PLLCMD |= 0x1;

	//	6) ٵȴ500us ٵȴ500us ѯACC_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(ACC_PLLCMD & (1<<1)));

	//7) ACC_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	ACC_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}


/**
********************************************************************************
 *   @n@b void SRIO_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  SRIO_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- Ƶϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 500          | 25(DSK)       		| 80     | 1      |       1    |     1     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	SRIO_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void SRIO_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float SRIO_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2SRIO_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	SRIO_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) SRIO_PLLCMDеENPLLдΪ0ضPLL
	SRIO_PLLCMD &= 0xfffffffe;

	//	4) SRIO_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	SRIO_PLLCTL = (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	SRIO_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > SRIO_PLL_FOUTVCO)|(SRIO_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!SRIO_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",SRIO_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usSRIO_PLLCMDеENPLLдΪ1
	pll_wait(200);
	SRIO_PLLCMD |= 0x1;

	//	6) ٵȴ500us ٵȴ500us ѯSRIO_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(SRIO_PLLCMD & (1<<1)));

	//7) SRIO_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	SRIO_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}



/**
********************************************************************************
 *   @n@b void SRIO2_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  SRIO2_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- Ƶϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 500          | 25(DSK)       		| 80     | 1      |       1    |     1     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	SRIO2_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void SRIO2_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float SRIO2_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2SRIO2_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	SRIO2_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) SRIO2_PLLCMDеENPLLдΪ0ضPLL
	SRIO2_PLLCMD &= 0xfffffffe;

	//	4) SRIO2_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	SRIO2_PLLCTL = (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	SRIO2_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > SRIO2_PLL_FOUTVCO)|(SRIO2_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!SRIO2_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",SRIO2_PLL_FOUTVCO);
	}

	//	5) ٵȴ1usSRIO2_PLLCMDеENPLLдΪ1
	pll_wait(200);
	SRIO2_PLLCMD |= 0x1;

	//	6) ٵȴ500us ѯSRIO2_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(SRIO2_PLLCMD & (1<<1)));

	//7) SRIO2_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	SRIO2_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}


	/**
********************************************************************************
 *   @n@b void ARM_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
 *
 *   @b ܣ
 *   @n  ARM_PLL_Initʼ
 *
 *   @b βΣ
 *   @verbatim
 *			PLLM ------- Ƶϵ
 *	   		PLLN ------- Ƶϵ
 *	   		POSTDIV2 --- Ƶϵ2
 *	   		POSTDIV1 --- Ƶϵ1
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | Rate (MHz)   | Input Clock (MHz)   | PLLM   | PLLN   | POSTDIV1   | POSTDIV2  |
 * +--------------+---------------------+--------+--------+------------+-----------+
 * | 1600         | 25(DSK)       		| 128    | 1      |       1    |     0     |
 * | 1400         | 25(DSK)       		| 112    | 1      |       1    |     0     |
 * | 1000         | 25(DSK)       		| 96     | 1      |       1    |     0     |
 * +--------------+---------------------+--------+--------+------------+-----------+
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n FOUTVCO	= oscclk/PLLN * PLLM			oscclkΪʱ
 *   	1600MHz <= FOUTVCO <= 3200MHz
 *   	ARM_PLL = FOUTVCO/2^(POSTDIV1 + POSTDIV2)
 *   	DIV1 = 2^(2*POSTDIV1 bit[1]+POSTDIV1 bit[0])
 *   	DIV2 = 2^(2*POSTDIV2 bit[1]+POSTDIV2 bit[0])
 *    	1MHz<= oscclk/PLLN <= 40MHz
 *******************************************************************************
 */
void ARM_PLL_Init(uint16_t PLLM, uint8_t PLLN,  uint8_t POSTDIV1, uint8_t POSTDIV2)
{
	asm(" MFENCE ");
	asm(" nop 5 ");
	float ARM_PLL_FOUTVCO;
	//	1) DSPִMFENCEָȷǰѴϣ
	KICK0=0x83e70b13;  //KickerƼĴ KICK0
	KICK1=0x95a4f1e0;  //KickerƼĴKICK1

	//	2ARM_PLLCTLеBYPASSдΪ1ٵȴDSP_PLLʱoscclk˸ʱڣ֤ϵͳʱлBYPASSģʽ
	ARM_PLLCTL |= 0x1;
	pll_wait(20);

	//	3) ARM_PLLCMDеENPLLдΪ0ضPLL
	ARM_PLLCMD &= 0xfffffffe;

	//	4) ARM_PLLCTLźţPLLNPLLMPOSTDIV1,POSTDIV2
	ARM_PLLCTL =  (PLLN<<24)|(PLLM<<8)|(POSTDIV2<<4)|(POSTDIV1<<1)|(1<<0);

	ARM_PLL_FOUTVCO= oscclk/PLLN*PLLM;
	if((1600 > ARM_PLL_FOUTVCO)|(ARM_PLL_FOUTVCO > 3200))
	{
		printf("Warning!!!ARM_PLL_FOUTVCO freq is %.2fMHz!! Not in 1600MHz~3200MHz\n",ARM_PLL_FOUTVCO);

	}

	//	5) ٵȴ1usARM_PLLCMDеENPLLдΪ1
	pll_wait(200);
	ARM_PLLCMD |= 0x1;

	//	6) ٵȴ500us ѯARM_PLLCMDеLOCKǷΪ1Ϊ1ִ7ȴ
	while(!(ARM_PLLCMD & (1<<1)));

	//7) ARM_PLLCTLеBYPASSдΪ0ϵͳʱлPLLģʽ
	ARM_PLLCTL &= 0xfffffffe;
	pll_wait(1000);
}




