/**
********************************************************************************
* @file       M6678E_PSC.c
* @brief      ʵM6678EԴʱؽӿں
* @version    V1.0
* @date       2024/1/15
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include <string.h>
#include "M6678E_PSC.h"

/** @addtogroup PSC_FUNCTION
 @{ */

/*******************************************************************************
*PSC_Open_Clk(const char *string , unsigned int Power_Domain)
*    ܣ ʱӽӿں
*    stringʾ׼ʱӵ
*      Power_DomainָʾĲֵĵԴת
*ע    ⣺
*     Power_Domain = 0   ں˲
*     Power_Domain = 1   
*     Power_Domain = 2   IP
*     Power_Domain = 3   DSP
*******************************************************************************/
void PSC_Open_Clk(const char *string , unsigned int Power_Domain)
{
	volatile int *psc_unit;
	volatile int temp = 1 ;
	volatile int *psc_com  = (int*)PTCMD_REG;
	volatile int *psc_check= (int*)PTSTAT_REG;

	if ( Power_Domain == 0 )
	{
		if (strcmp(string ,"DSP0CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP0CORE_offset);
		}
		else if (strcmp(string ,"DSP1CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP1CORE_offset);
		}
		else if (strcmp(string ,"DSP2CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP2CORE_offset);
		}
		else if (strcmp(string ,"DSP3CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP3CORE_offset);
		}
		else if (strcmp(string ,"DSP4CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP4CORE_offset);
		}
		else if (strcmp(string ,"DSP5CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP5CORE_offset);
		}
		else if (strcmp(string ,"DSP6CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP6CORE_offset);
		}
		else if (strcmp(string ,"DSP7CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP7CORE_offset);
		}



		*psc_unit = 3;             // MDCTLy ģƼĴ
		*psc_com  = 1;             // PTCMD  ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

	else if ( Power_Domain == 1 )
	{
		if (strcmp(string ,"FFT") == 0)
		{
			psc_unit=(int*)(PSC_BASE + FFT_offset);
		}
		else if (strcmp(string ,"FFT1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + FFT1_offset);
		}
		else if (strcmp(string ,"PNNA") == 0)
		{
			psc_unit=(int*)(PSC_BASE + PNNA_offset);
		}
		else if (strcmp(string ,"TP") == 0)
		{
			psc_unit=(int*)(PSC_BASE + TP_offset);
		}
		else if (strcmp(string ,"SMC") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SMC_offset);
		}
		else if (strcmp(string ,"EMIF") == 0)
		{
			psc_unit=(int*)(PSC_BASE + EMIF_offset);
		}
		else if (strcmp(string ,"DDR") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DDR_offset);
		}
		else if (strcmp(string ,"DMA0") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA0_offset);
		}
		else if (strcmp(string ,"DMA1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA1_offset);
		}
		else if (strcmp(string ,"DMA2") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA2_offset);
		}
		else if (strcmp(string ,"DMA3") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA3_offset);
		}
		else if (strcmp(string ,"DMA4") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA4_offset);
		}
		else if (strcmp(string ,"GPIO") == 0)
		{
			psc_unit=(int*)(PSC_BASE + GPIO_offset);
		}
		else if (strcmp(string ,"I2C") == 0)
		{
			psc_unit=(int*)(PSC_BASE + I2C_offset);
		}
		else if (strcmp(string ,"SPI") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SPI_offset);
		}
		else if (strcmp(string ,"UART") == 0)
		{
			psc_unit=(int*)(PSC_BASE + UART_offset);
		}
		else if (strcmp(string ,"TIMER") == 0)
		{
			psc_unit=(int*)(PSC_BASE + TIMER_offset);
		}
		else if (strcmp(string ,"M1553B") == 0)
		{
			psc_unit=(int*)(PSC_BASE + M1553B_offset);
		}
		*psc_unit = 3;             // MDCTLy ģƼĴ
		*psc_com  = 2;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

	else if( Power_Domain == 2 )
	{

		if (strcmp(string ,"RGMII") == 0)
		{
			psc_unit=(int*)(PSC_BASE + RGMII_offset);
		}
		if (strcmp(string ,"SRIO0") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO0_offset);
		}
		if (strcmp(string ,"SRIO1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO1_offset);
		}
		if (strcmp(string ,"SRIO2") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO2_offset);
		}
		if (strcmp(string ,"PCIE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + PCIE_offset);
		}

		*psc_unit = 3;             // MDCTLy ģƼĴ
		*psc_com  = 4;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

	else if( Power_Domain == 3 )
	{
		if (strcmp(string ,"ARMA15") == 0)
		{
			psc_unit=(int*)(PSC_BASE + ARMA15_offset);
		}
		else if (strcmp(string ,"DSP0") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP0_offset);
		}
		else if (strcmp(string ,"DSP1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP1_offset);
		}
		else if (strcmp(string ,"DSP2") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP2_offset);
		}
		else if (strcmp(string ,"DSP3") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP3_offset);
		}
		else if (strcmp(string ,"DSP4") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP4_offset);
		}
		else if (strcmp(string ,"DSP5") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP5_offset);
		}
		else if (strcmp(string ,"DSP6") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP6_offset);
		}
		else if (strcmp(string ,"DSP7") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP7_offset);
		}
		*psc_unit = 3;             // MDCTLy ģƼĴ
		*psc_com  = 8;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

}

/*******************************************************************************
*PSC_Close_Clk(const char *string , unsigned int Power_Domain)
*    ܣʱӽӿں
*    stringʾ׼ʱӵ
*      Power_DomainָʾĲֵĵԴת
*ע    ⣺
*     Power_Domain = 0   ں˲
*     Power_Domain = 1   
*     Power_Domain = 2   IP
*     Power_Domain = 3   DSP
*******************************************************************************/
void PSC_Close_Clk(const char *string , unsigned int Power_Domain)
{
	volatile int *psc_unit;
	volatile int temp = 1 ;
	volatile int *psc_com  = (int*)PTCMD_REG;
	volatile int *psc_check= (int*)PTSTAT_REG;

	if ( Power_Domain == 0 )
	{
		if (strcmp(string ,"DSP0CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP0CORE_offset);
		}
		else if (strcmp(string ,"DSP1CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP1CORE_offset);
		}
		else if (strcmp(string ,"DSP2CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP2CORE_offset);
		}
		else if (strcmp(string ,"DSP3CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP3CORE_offset);
		}
		else if (strcmp(string ,"DSP4CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP4CORE_offset);
		}
		else if (strcmp(string ,"DSP5CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP5CORE_offset);
		}
		else if (strcmp(string ,"DSP6CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP6CORE_offset);
		}
		else if (strcmp(string ,"DSP7CORE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DSP7CORE_offset);
		}

		*psc_unit = 0;             // MDCTLy ģƼĴ
		*psc_com  = 1;             // PTCMD  ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}


	else if ( Power_Domain == 1 )
		{
		if (strcmp(string ,"FFT") == 0)
		{
			psc_unit=(int*)(PSC_BASE + FFT_offset);
		}
		else if (strcmp(string ,"FFT1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + FFT1_offset);
		}
		else if (strcmp(string ,"PNNA") == 0)
		{
			psc_unit=(int*)(PSC_BASE + PNNA_offset);
		}
		else if (strcmp(string ,"TP") == 0)
		{
			psc_unit=(int*)(PSC_BASE + TP_offset);
		}
		else if (strcmp(string ,"SMC") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SMC_offset);
		}
		else if (strcmp(string ,"EMIF") == 0)
		{
			psc_unit=(int*)(PSC_BASE + EMIF_offset);
		}
		else if (strcmp(string ,"DDR") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DDR_offset);
		}
		else if (strcmp(string ,"DMA0") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA0_offset);
		}
		else if (strcmp(string ,"DMA1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA1_offset);
		}
		else if (strcmp(string ,"DMA2") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA2_offset);
		}
		else if (strcmp(string ,"DMA3") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA3_offset);
		}
		else if (strcmp(string ,"DMA4") == 0)
		{
			psc_unit=(int*)(PSC_BASE + DMA4_offset);
		}
		else if (strcmp(string ,"GPIO") == 0)
		{
			psc_unit=(int*)(PSC_BASE + GPIO_offset);
		}
		else if (strcmp(string ,"I2C") == 0)
		{
			psc_unit=(int*)(PSC_BASE + I2C_offset);
		}
		else if (strcmp(string ,"SPI") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SPI_offset);
		}
		else if (strcmp(string ,"UART") == 0)
		{
			psc_unit=(int*)(PSC_BASE + UART_offset);
		}
		else if (strcmp(string ,"TIMER") == 0)
		{
			psc_unit=(int*)(PSC_BASE + TIMER_offset);
		}
		else if (strcmp(string ,"M1553B") == 0)
		{
			psc_unit=(int*)(PSC_BASE + M1553B_offset);
		}

		*psc_unit = 0;             // MDCTLy ģƼĴ
		*psc_com  = 2;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

	else if( Power_Domain == 2 )
		{
		if (strcmp(string ,"RGMII") == 0)
		{
			psc_unit=(int*)(PSC_BASE + RGMII_offset);
		}
		if (strcmp(string ,"SRIO0") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO0_offset);
		}
		if (strcmp(string ,"SRIO1") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO1_offset);
		}
		if (strcmp(string ,"SRIO2") == 0)
		{
			psc_unit=(int*)(PSC_BASE + SRIO2_offset);
		}
		if (strcmp(string ,"PCIE") == 0)
		{
			psc_unit=(int*)(PSC_BASE + PCIE_offset);
		}

		*psc_unit = 0;             // MDCTLy ģƼĴ
		*psc_com  = 4;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

	else if( Power_Domain == 3 )
		{
			if (strcmp(string ,"ARMA15") == 0)
			{
				psc_unit=(int*)(PSC_BASE + ARMA15_offset);
			}
			else if (strcmp(string ,"DSP0") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP0_offset);
			}
			else if (strcmp(string ,"DSP1") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP1_offset);
			}
			else if (strcmp(string ,"DSP2") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP2_offset);
			}
			else if (strcmp(string ,"DSP3") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP3_offset);
			}
			else if (strcmp(string ,"DSP4") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP4_offset);
			}
			else if (strcmp(string ,"DSP5") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP5_offset);
			}
			else if (strcmp(string ,"DSP6") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP6_offset);
			}
			else if (strcmp(string ,"DSP7") == 0)
			{
				psc_unit=(int*)(PSC_BASE + DSP7_offset);
			}
		*psc_unit = 0;             // MDCTLy ģƼĴ
		*psc_com  = 8;             // PTCMD ԴתĴ
		do
		{
			temp=*psc_check;       // PTSTAT Դת״̬Ĵ
		}
		while(temp!=0);
	}

}

