/** 
********************************************************************************
* @file       M6678E_RESET.c
* @brief      M6678E λؽӿںʵ֡
* @version    V1.0
* @date       2024.1.17
* @attention  
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include "M6678E_RESET.h"

/** @addtogroup RESET_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b WatchDog_Reset_Config(unsigned int WatchDog_Numb , unsigned int RSTEN )
 *
 *   @b ܣ
 *   @n 뿴ŹصĸλĴʹŹָܹλ
 *
 *   @b βΣ
 *   @verbatim
 *      1WatchDog_NumbΪŹţ0~1ѡ
 *      2RSTENĸλ
 *          RSTEN = 0x1000000 ʾŹоƬλ
 *          RSTEN = 0x2000000 ʾŹϵͳλ
 *          RSTEN = 0x0000001 ʾŹDSP0λ
 *          RSTEN = 0x0000002 ʾŹDSP1λ
 *          RSTEN = 0x0000004 ʾŹDSP2λ
 *          ...
 *          RSTEN = 0x0000080 ʾŹDSP7λ
 *          RSTEN = 0x0000003 ʾŹDSP0DSP1λ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  WatchDog_Reset_Config(unsigned int WatchDog_Numb , unsigned int RSTEN )
{
	KICK0 = 0x83e70b13;
	KICK1 = 0x95a4f1e0;
	*(volatile unsigned int*)(WDT0ISOLATION + WatchDog_Numb * 0x4) = RSTEN;
	KICK0 = 0;
	KICK1 = 0;
}

/**
********************************************************************************
 *   @n@b Reset_Trigger(unsigned int Trigger_Numb)
 *
 *   @b ܣ
 *   @n 뿴ŹصĸλĴʹŹָܹλ
 *
 *   @b βΣ
 *   @verbatim
 *      Trigger_NumbΪλ
 *          Trigger_Numb = 0x0400 ʾŹоƬλ
 *          Trigger_Numb = 0x0800 ʾŹϵͳλ
 *          Trigger_Numb = 0x0001 ʾŹDSP0λ
 *          Trigger_Numb = 0x0002 ʾŹDSP1λ
 *          ...
 *          Trigger_Numb = 0x0080 ʾŹDSP7λ
 *          Trigger_Numb = 0x0100 ʾŹARM-A15COREλ
 *          Trigger_Numb = 0x0003 ʾŹDSP0DSP1λ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  Reset_Trigger(unsigned int Trigger_Numb)
{
	KICK0 = 0x83e70b13;
	KICK1 = 0x95a4f1e0;
	RSTTRIGGER = 0x78CA0000 | Trigger_Numb;
	KICK0 = 0;
	KICK1 = 0;
}


/**
********************************************************************************
 *   @n@b Get_Reset_State()
 *
 *   @b ܣ
 *   @n RSTTYPE[13]Ϊ1ʱ,踴λɻȡһθλⲿ豸
 *
 *   @b βΣ
 *   @verbatim
 *		ӡĸλ״̬
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  Get_Reset_State()
{
	volatile unsigned char pertemp = 0;

	if(RSTTYPE & 0x2000 == 0x2000)//踴λ
	{
		pertemp = PERRSTTYPE & 0xff;
		switch(pertemp)
		{
		case 0x01: printf("The Last RESETTYPE is ARMa15 !\n") ;break ;
		case 0x03: printf("The Last RESETTYPE is DSP0 !\n") ;break ;
		case 0x04: printf("The Last RESETTYPE is DSP1 !\n") ;break ;
		case 0x05: printf("The Last RESETTYPE is DSP2 !\n") ;break ;
		case 0x06: printf("The Last RESETTYPE is DSP3 !\n") ;break ;
		case 0x07: printf("The Last RESETTYPE is DSP4 !\n") ;break ;
		case 0x08: printf("The Last RESETTYPE is DSP5 !\n") ;break ;
		case 0x09: printf("The Last RESETTYPE is DSP6 !\n") ;break ;
		case 0x0A: printf("The Last RESETTYPE is DSP7 !\n") ;break ;
		case 0x0B: printf("The Last RESETTYPE is DSP0CORE!\n") ; break ;
		case 0x0C: printf("The Last RESETTYPE is DSP1CORE!\n") ; break ;
		case 0x0D: printf("The Last RESETTYPE is DSP2CORE!\n") ; break ;
		case 0x0E: printf("The Last RESETTYPE is DSP3CORE!\n") ; break ;
		case 0x0F: printf("The Last RESETTYPE is DSP4CORE!\n") ; break ;
		case 0x10: printf("The Last RESETTYPE is DSP5CORE!\n") ; break ;
		case 0x11: printf("The Last RESETTYPE is DSP6CORE!\n") ; break ;
		case 0x12: printf("The Last RESETTYPE is DSP7CORE!\n") ; break ;
		case 0x13: printf("The Last RESETTYPE is XGMAC0 !\n") ;break ;
		case 0x14: printf("The Last RESETTYPE is XGMAC1 !\n") ;break ;
		case 0x15: printf("The Last RESETTYPE is XGMAC2 !\n") ;break ;
		case 0x16: printf("The Last RESETTYPE is XGMAC3 !\n") ;break ;
		case 0x17: printf("The Last RESETTYPE is XGMAC4 !\n") ;break ;
		case 0x18: printf("The Last RESETTYPE is XGMAC5 !\n") ;break ;
		case 0x19: printf("The Last RESETTYPE is RGMII0 !\n") ;break ;			
		case 0x1A: printf("The Last RESETTYPE is RGMII1 !\n") ;break ;	
		case 0x1B: printf("The Last RESETTYPE is SRIO0 !\n") ;break ;	
		case 0x1C: printf("The Last RESETTYPE is SRIO1 !\n") ;break ;	
		case 0x1D: printf("The Last RESETTYPE is SRIO2 !\n") ;break ;	
		case 0x1E: printf("The Last RESETTYPE is SRIO3 !\n") ;break ;	
		case 0x1F: printf("The Last RESETTYPE is PCIE !\n") ;break ;	
		case 0x20: printf("The Last RESETTYPE is USB3 !\n") ;break ;			
		case 0x21: printf("The Last RESETTYPE is GPIO!\n") ; break ;
		case 0x22: printf("The Last RESETTYPE is I2C0!\n") ; break ;
		case 0x23: printf("The Last RESETTYPE is I2C1!\n") ; break ;
		case 0x24: printf("The Last RESETTYPE is I2C2 !\n") ;break ;
		case 0x25: printf("The Last RESETTYPE is SPI0 !\n") ;break ;
		case 0x26: printf("The Last RESETTYPE is SPI1 !\n") ;break ;
		case 0x27: printf("The Last RESETTYPE is SPI2 !\n") ;break ;
		case 0x28: printf("The Last RESETTYPE is MCASP0 !\n") ;break ;
		case 0x29: printf("The Last RESETTYPE is MCASP1 !\n") ;break ;
		case 0x2A: printf("The Last RESETTYPE is MCBSP0 !\n") ;break ;	
		case 0x2B: printf("The Last RESETTYPE is PCI !\n") ;break ;	
		case 0x2C: printf("The Last RESETTYPE is ATA !\n") ;break ;	
		case 0x2D: printf("The Last RESETTYPE is HPI !\n") ;break ;	
		case 0x2E: printf("The Last RESETTYPE is PWM0 !\n") ;break ;	
		case 0x2F: printf("The Last RESETTYPE is PWM1 !\n") ;break ;	
		case 0x30: printf("The Last RESETTYPE is TIMER !\n") ;break ;				

		case 0x31: printf("The Last RESETTYPE is DMA0!\n") ; break ;
		case 0x32: printf("The Last RESETTYPE is DMA1!\n") ; break ;
		case 0x33: printf("The Last RESETTYPE is DMA2!\n") ; break ;
		case 0x34: printf("The Last RESETTYPE is DMA3!\n") ; break ;
		case 0x35: printf("The Last RESETTYPE is DMA4!\n") ; break ;
		case 0x36: printf("The Last RESETTYPE is H264E!\n") ; break ;
		case 0x37: printf("The Last RESETTYPE is H264D!\n") ; break ;
		case 0x38: printf("The Last RESETTYPE is VPIF0IN!\n") ; break ;
		case 0x39: printf("The Last RESETTYPE is VPIF0OUT!\n") ; break ;
		case 0x3A: printf("The Last RESETTYPE is VPIF1IN!\n") ; break ;
		case 0x3B: printf("The Last RESETTYPE is VPIF1OUT!\n") ; break ;		
		case 0x3C: printf("The Last RESETTYPE is PNNA!\n") ; break ;
		case 0x3D: printf("The Last RESETTYPE is UART0!\n") ; break ;
		case 0x3E: printf("The Last RESETTYPE is UART1!\n") ; break ;
		case 0x3F: printf("The Last RESETTYPE is UART2!\n") ; break ;
		case 0x40: printf("The Last RESETTYPE is TCPD!\n") ; break ;
		case 0x41: printf("The Last RESETTYPE is VCPD!\n") ; break ;
		case 0x42: printf("The Last RESETTYPE is TCPE!\n") ; break ;	
		case 0x43: printf("The Last RESETTYPE is VCPE!\n") ; break ;			
		case 0x44: printf("The Last RESETTYPE is SMC!\n") ; break ;
		case 0x45: printf("The Last RESETTYPE is EMIF!\n") ; break ;
		case 0x46: printf("The Last RESETTYPE is DDR0!\n") ; break ;
		case 0x47: printf("The Last RESETTYPE is DDR1!\n") ; break ;
		case 0x48: printf("The Last RESETTYPE is M1553B!\n") ; break ;
		case 0x49: printf("The Last RESETTYPE is UPP!\n") ; break ;	
		case 0x4A: printf("The Last RESETTYPE is ARMA15CORE!\n") ; break ;
		default: printf("The Last RESETTYPE is not Perpheral!\n"); break ;
		}
	}
	else //踴λ
	{
		switch(RSTTYPE & 0x1FFF)
		{
		case 0x0000001 : printf("The Last RESETTYPE is POR !\n") ;break ; 
		case 0x0000002 : printf("The Last RESETTYPE is SYSRESET !\n") ;break ; 
		case 0x0000004 : printf("The Last RESETTYPE is RESET !\n") ;break ; 
		case 0x0000008 : printf("The Last RESETTYPE is DSP0 !\n") ;break ; 
		case 0x0000010 : printf("The Last RESETTYPE is DSP1 !\n") ;break ; 
		case 0x0000020 : printf("The Last RESETTYPE is DSP2 !\n") ;break ; 
		case 0x0000040 : printf("The Last RESETTYPE is DSP3 !\n") ;break ; 
		case 0x0000080 : printf("The Last RESETTYPE is DSP4 !\n") ;break ; 
		case 0x0000100 : printf("The Last RESETTYPE is DSP5 !\n") ;break ; 
		case 0x0000200 : printf("The Last RESETTYPE is DSP6 !\n") ;break ; 
		case 0x0000400 : printf("The Last RESETTYPE is DSP7 !\n") ;break ; 
		case 0x0000800 : printf("The Last RESETTYPE is ARMA15CORE !\n") ;break ;
		default: printf("The Last RESETTYPE is Perpheral!\n"); break ;
		}
	}
}

/**
********************************************************************************
 *   @n@b Get_Reset_Source()
 *
 *   @b ܣ
 *   @n ȡλԴ
 *
 *   @b βΣ
 *   @verbatim
 *		ӡĸλ״̬
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  Get_Reset_Source()
{
	unsigned int pertemp;
	pertemp = RSTTYPE_SRC & 0x3f;
	switch(pertemp)
	{
	case 0x01: printf("The RSTTYPE_SRC is WDT0 !\n") ;break ;
	case 0x02: printf("The RSTTYPE_SRC is WDT1 !\n") ;break ;
	case 0x03: printf("The RSTTYPE_SRC is WDT2 !\n") ;break ;	
	case 0x04: printf("The RSTTYPE_SRC is WDT3 !\n") ;break ;
	case 0x05: printf("The RSTTYPE_SRC is WDT4 !\n") ;break ;
	case 0x06: printf("The RSTTYPE_SRC is WDT5 !\n") ;break ;
	case 0x07: printf("The RSTTYPE_SRC is WDT6 !\n") ;break ;
	case 0x08: printf("The RSTTYPE_SRC is WDT7 !\n") ;break ;
	case 0x09: printf("The RSTTYPE_SRC is WDT8 !\n") ;break ;	
	case 0x0A: printf("The RSTTYPE_SRC is ET !\n") ;break ;
	case 0x0B: printf("The RSTTYPE_SRC is RSTTRIGGER !\n") ;break ;
	case 0x0C: printf("The RSTTYPE_SRC is PSC !\n") ;break ;
	case 0x0D: printf("The RSTTYPE_SRC is PIN !\n") ;break ;
	default: printf("No RESETTYPE!\n"); break ;
	}
}
