/**
********************************************************************************
* @file       M6678E_SPI.c
* @brief      ʵM6678E SPIõĸֽӿں
* @version    V1.0
* @date       2020/3/17
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include "M6678E_SPI.h"

//ģʽѡ
//#define TX_EN     //ͻУ
//#define RX_EN     //ջУ
#define DC_EN     //߿ƻУ

//עһλλ
#define OneBit_ERR
//#define TwoBit_ERR


/** @addtogroup SPI_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b void SPI_Init(SPI_TypeDef *SPIDEV, uint32_t main_frq_MHz,
 *   			float spi_clk_out_MHz, uint8_t mode, uint8_t protocol)
 *
 *   @b ܣ
 *   @n  SPIʼ
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV  		--------- SPI豸DEV_SPI0DEV_SPI1
 *	   	main_frq  		--------- ϵͳƵ λMHz
 *	  	spi_clk_out_MHz --------- Ҫʱ λMHz
 *	   	mode 			--------- ģʽ SPI_MODE_0SPI_MODE_1SPI_MODE_2SPI_MODE_3
 *	   	protocol		--------- Эѡ SPI_PTC_Full_DuplexSPI_PTC_DualSPI_PTC_Qual
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 0:ɹ
 *   	:ʧ
 *
 *   <b> ע </b>
 *   @n SPIʱӣϵͳʱӵ 2 Ƶ
 *******************************************************************************
 */
int SPI_Init(SPI_TypeDef *SPIDEV, uint32_t main_frq_MHz,
		float spi_clk_out_MHz, uint8_t mode, uint8_t protocol)
{
	uint32_t spi_clk_in = 0;
	uint32_t spi_clk_out_Hz = 0;
	float pm_temp = 0.0;
	uint8_t pm = 0;
	uint8_t fact = 0;
	uint8_t div16 = 0;
	uint32_t clk_out_actual = 0;
	uint32_t temp1 = 0;
	uint32_t temp2 = 0;

	spi_clk_out_Hz = spi_clk_out_MHz * 1000000;
	spi_clk_in = main_frq_MHz * 1000000;	//MHz -> Hz
	if((spi_clk_out_Hz > (spi_clk_in/8)) || (spi_clk_out_Hz < (spi_clk_in/4096))){
		printf("spi_clk_out_MHz range out!! range:%.4f MHz - %.4f MHz\r\n",
			(float)spi_clk_in/4096/1000000, (float)spi_clk_in/8/1000000);
		return -1;
	}

	if(spi_clk_out_Hz <= (spi_clk_in/2048)) {
		fact = 0;
		div16 = 1;
		pm_temp = (float)spi_clk_in/(256*spi_clk_out_Hz);
		pm_temp -= 1;
	}	else if(spi_clk_out_Hz <= (spi_clk_in/128)) {
		fact = 1;
		div16 = 1;
		pm_temp = (float)spi_clk_in/(128*spi_clk_out_Hz);
		pm_temp -= 1;
	}	else if(spi_clk_out_Hz <= (spi_clk_in/4))	{
		fact = 1;
		div16 = 0;
		pm_temp = (float)spi_clk_in/(8*spi_clk_out_Hz);
		pm_temp -= 1;
	}

	if(pm_temp > (uint8_t)pm_temp)	pm_temp +=1;
	pm = (uint8_t)pm_temp;
	if(pm > 15){
		printf("pm_max:15!!! pm:%d\r\n",pm);
		pm = 15;
	}
	printf("main_frq_MHz:%d MHz spi_clk_out_MHz:%0.4f MHz\r\n",main_frq_MHz, spi_clk_out_MHz);
	printf("pm:%d fact:%d div16:%d\r\n", pm, fact, div16);

	temp1 = 4-2*fact;
	temp2 = pm+1;
	if(div16)		clk_out_actual = (spi_clk_in/4)/(temp1*temp2*16);
	else			clk_out_actual = (spi_clk_in/4)/(temp1*temp2);

	printf("spi_clk_out_actual:%0.4f MHZ\r\n", (float)clk_out_actual/1000000);

	SPIDEV->SS = 0xF;	// CS
	SPIDEV->PTCS = protocol;	// Э

	SPIDEV->MODE = 0;
	SPIDEV->MODE |= (div16<<27)|(pm<<16)|(fact<<13);
	SPIDEV->MODE |= (mode<<28)|(1<<26)|(1<<25)|(1<<2);	// ģʽ MSB 
	SPIDEV->MODE |= (7<<20);	// 4λ~16λֳ
	SPIDEV->MODE |= (1<<24);	// ʹ

	return 0;
}

/**
********************************************************************************
 *   @n@b void SPI_Transmit_Byte(SPI_TypeDef *SPIDEV, uint8_t dat)
 *
 *   @b ܣ
 *   @n  SPIһֽ
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV	--------	SPI豸DEV_SPI0DEV_SPI1
 *		dat		--------	͵
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void SPI_Transmit_Byte(SPI_TypeDef *SPIDEV, uint8_t dat)
{
	SPIDEV->DCR = 0xff000000;
	SPIDEV->TX  = dat<<24;
	SPIDEV->CMD |= (1<<22);
	while(((SPIDEV->EVT >> 14) & 0X1) == 0); 	// ȴ
	SPIDEV->EVT |= (1<<14);					// ־λLT д1
}


void SPI_Transmit_Byte_EDAC(SPI_TypeDef *SPIDEV, uint8_t dat)
{
	//SPIDEV->TXMCEMUR = (0<<1)|(1<<0);	// TXעһλ
	SPIDEV->DCR = 0xff000000;
	SPIDEV->TX  = dat<<24;
	SPIDEV->CMD |= (1<<22);
	while(((SPIDEV->EVT >> 14) & 0X1) == 0); 	// ȴ
	SPIDEV->EVT |= (1<<14);					// ־λLT д1
	//SPIDEV->TXMCEMUR = 0;	// رմע
}


/**
********************************************************************************
 *   @n@b void SPI_Transmit_Dummy(SPI_TypeDef *SPIDEV)
 *
 *   @b ܣ
 *   @n  SPIһʱӣʱź
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV	--------	SPI豸DEV_SPI0DEV_SPI1
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void SPI_Transmit_Dummy(SPI_TypeDef *SPIDEV)
{
	SPIDEV->DCR = 0x00000000;
	SPIDEV->TX  = 0x00000000;
	SPIDEV->CMD |= (1<<22);
	while(((SPIDEV->EVT >> 14) & 0X1) == 0); 	// ȴ
	SPIDEV->EVT |= (1<<14);						// ־λLT д1
}

/**
********************************************************************************
 *   @n@b void spi_recvFIFO_clear(SPI_TypeDef *SPIDEV)
 *
 *   @b ܣ
 *   @n  FIFO
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV	--------	SPI豸DEV_SPI0DEV_SPI1
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void spi_recvFIFO_clear(SPI_TypeDef *SPIDEV)
{
	volatile unsigned int invalid =0;
	while(((SPIDEV->EVT >> 9) & 0X1) == 1)
	{
		invalid = SPIDEV->RX;
	}
}

/**
********************************************************************************
 *   @n@b void SPI_Receive_Byte(SPI_TypeDef *SPIDEV, uint8_t *dat)
 *
 *   @b ܣ
 *   @n  SPIһֽ
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV	--------	SPI豸DEV_SPI0DEV_SPI1
 *		dat		--------	ȡ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void SPI_Receive_Byte(SPI_TypeDef *SPIDEV, uint8_t *dat)
{
	uint32_t dat_temp = 0;

	spi_recvFIFO_clear(SPIDEV);				// ȡǰһFIFO
	SPI_Transmit_Dummy(SPIDEV);				// һڲʱ
	while(((SPIDEV->EVT >> 9) & 0X1) == 0);
	dat_temp = SPIDEV->RX;
	dat_temp >>= 16;
	*dat = dat_temp;
}


void SPI_Receive_Byte_EDAC(SPI_TypeDef *SPIDEV, uint8_t *dat)
{
	uint32_t dat_temp = 0;
	SPIDEV->RXMCEMUR = (0<<1)|(1<<0);		//  һλݴ
	spi_recvFIFO_clear(SPIDEV);				// ȡǰһFIFO
	SPI_Transmit_Dummy(SPIDEV);				// һڲʱ
	while(((SPIDEV->EVT >> 9) & 0X1) == 0);
	dat_temp = SPIDEV->RX;
	dat_temp >>= 16;
	*dat = dat_temp;
	SPIDEV->RXMCEMUR = 0;		//  һλݴ
}/**
********************************************************************************
 *   @n@b void SPI_Transmit(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data)
 *
 *   @b ܣ
 *   @n  SPI
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV			--------	SPI豸DEV_SPI0DEV_SPI1
 *		ss				--------	ѡ SPI_CS0SPI_CS1SPI_CSDISABLE
 *		dat_buf			--------	͵
 *		Count_Data		--------	ֽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void SPI_Transmit(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data)
{
	unsigned int i = 0;
	// ʹƬѡ
	SPIDEV->SS = ss;
	// ݴ
	for(i=0;i<Count_Data;i++)
	{
		SPI_Transmit_Byte(SPIDEV, dat_buf[i]);
	}
	SPIDEV->SS = SPI_CSDISABLE;	// Ƭѡ
}

/**
********************************************************************************
 *   @n@b void SPI_Receive(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data)
 *
 *   @b ܣ
 *   @n  SPI
 *
 *   @b βΣ
 *   @verbatim
 *		SPIDEV			--------	SPI豸DEV_SPI0DEV_SPI1
 *		ss				--------	ѡ SPI_CS0SPI_CS1SPI_CSDISABLE
 *		dat_buf			--------	յ
 *		Count_Data		--------	ֽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void SPI_Receive(SPI_TypeDef *SPIDEV, uint8_t ss, uint8_t *dat_buf, uint32_t Count_Data)
{
	unsigned int i = 0;
	// ʹƬѡ
	SPIDEV->SS = ss;
	// ***********************Receive*****************************************
	for(i=0;i<Count_Data;i++)
	{
		SPI_Receive_Byte(SPIDEV, &dat_buf[i]);
	}
	SPIDEV->SS = SPI_CSDISABLE;
}


void SPI_EDAC_Test(SPI_TypeDef *SPIDEV)
{
	uint8_t i = 0;
	uint32_t rx_buf[9]={0};

	if(SPIDEV == DEV_SPI0)			PSC_Open_Clk("SPI0", 0);

	SPIDEV->MODE = 0x42000004;  //loopbackģʽ
	SPIDEV->PTCS = 0x00000001;  //ȫ˫
	SPIDEV->MODE |= 0x01000000;	//ʹMODE.enλ

	/**/
	for(i=0; i<129; i++)
	{
		SPIDEV->DCR = 0x0;
		SPIDEV->TX = 0x0;
	}

	/*ж*/
	SPIDEV->M2BEICR = 0xf;

	SPIDEV->MODE = 0x0;
	SPIDEV->MODE = 0x42000004;
	SPIDEV->MODE |= 0x01000000;	//;ʹMODE.enλ

#ifdef TX_EN
	printf("ʼ SPIע뷢ͻУ!\n");
#ifdef OneBit_ERR
	SPIDEV->TXMCEMUR = 0x00000001;	// ע1λ
#endif
#ifdef TwoBit_ERR
	SPIDEV->TXMCEMUR = 0x00000003;	// ע2λ
#endif
	SPIDEV->M2BEIER = 0x00000004;	// жʹ
#endif

#ifdef RX_EN
	printf("ʼ SPIעջУ!\n");
#ifdef OneBit_ERR
	SPIDEV->RXMCEMUR = 0x00000001;	// ע1λ
#endif
#ifdef TwoBit_ERR
	SPIDEV->RXMCEMUR = 0x00000003;	// ע2λ
#endif
	SPIDEV->M2BEIER = 0x00000003;	// жʹ

#endif

#ifdef DC_EN
	printf("ʼ SPIע߿ƻУ!\n");
#ifdef OneBit_ERR
	SPIDEV->DCMCEMUR = 0x00000001;	// ע1λ
#endif
#ifdef TwoBit_ERR
	SPIDEV->DCMCEMUR = 0x00000003;	// ע2λ
#endif
	SPIDEV->M2BEIER = 0x00000008;	// жʹ
#endif

	// 
	for(i=0; i<9; i++)
	{
		SPIDEV->DCR = 0xffffffff;
		SPIDEV->TX = 0x12345678;
	}

	// 
	for(i=0; i<9; i++)
	{
		rx_buf[i] = SPIDEV->RX;
	}

#ifdef OneBit_ERR
#ifdef TX_EN
	printf("The status of the one-bit error count is 0x%x\n",SPIDEV->TXM1BESTR);
#endif
#ifdef RX_EN
	printf("The status of the one-bit error count is 0x%x\n",SPIDEV->RXM1BESTR);
#endif
#ifdef DC_EN
	printf("The status of the one-bit error count is 0x%x\n",SPIDEV->DCM1BESTR);
#endif
#endif

#ifdef TwoBit_ERR
	if(SPIDEV->M2BEIPR == 0)
		printf("No reeor occurred!\n");
	else
	{
		if(SPIDEV->M2BEIPR & 0x1)
			printf("An error occurred in receiving buffer read 2-bit data!\n");
		if(SPIDEV->M2BEIPR & 0x2)
			printf("An error occurred in refresh buffer read 2-bit data!\n");
		if(SPIDEV->M2BEIPR & 0x4)
			printf("An error occurred in refresh buffer transmit 2-bit data!\n");
		if(SPIDEV->M2BEIPR & 0x8)
			printf("A 2-bit data refresh error occurred in the data line control buffer!\n");
	}
#endif

	SPIDEV->TXMCEMUR = 0x00000000;	// ע
	/*ж*/
	SPIDEV->M2BEICR = 0xf;
	SPIDEV->M1BCLR = 0x7;

}
/**
@}
*/
/*--------------------------------------------------------------------------------
*****************************SPI flash дݱȽϺ,8λ*****************************
 * -----------------------------------------------------------------------------*/
void data_cmpare(uint8_t *Srcdata_addr, uint8_t *Dstdata_addr, uint32_t size)
{
	volatile unsigned int i=0, flag=0;
	volatile unsigned int src_data=0,dst_data=0;
	volatile unsigned char *src_addr, *dst_addr;
	volatile unsigned int  temp_size=0;
	src_addr = Srcdata_addr;
	dst_addr = Dstdata_addr;
	temp_size = size;
	for(i=0;i<temp_size;i++)				//ѭȽϽ
	{
		src_data = *src_addr++;
		dst_data = *dst_addr++;
		if(src_data != dst_data)
		{
			flag = 1;
			printf("error addr:%p\n",dst_addr);
		}
	}

	if(flag==1)
	{
		printf("SPI flash read and write data comparison result is incorrect!!!\n");
	}
	else
	{
		printf("SPI flash read and write data comparison result is correct!!!\n");
	}
}
