/**
********************************************************************************
* @file       M6678E_Semaphore.c
* @brief      ʵM6678E SemaphoreֹܵĽӿں
* @version    V1.0
* @date       2021.05.19
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_Semaphore.h"

/** @addtogroup Semaphor_FUNCTION
 @{ */

/**
********************************************************************************
*   @n@b SEM_RST()
*
*   @b ܣ
*   @n źŵλ
*
*   @b βΣ
*   @verbatim
*
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEM_RST()
{
	*(int *)SEM_RST_RUN =  0X1;
	asm(" MFENCE ");    
	asm(" nop 1");
}


/**
********************************************************************************
*   @n@b SEM_Direct(unsigned int sem_m)
*
*   @b ܣ
*   @n semaphoreֱӷʷʽ
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n request  Ϊ1ʱźŵƿвռ
			            Ϊ0ʱźŵƷǿвռ
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
int SEM_Direct(unsigned int sem_m)
{
	volatile int* direct;
	volatile int request;
	direct = ( int *)SEM_DIRECT;
	request = direct[sem_m] & 0x1;
	asm(" MFENCE ");    
	asm(" nop 1");
	return request;
}


/**
********************************************************************************
*   @n@b SEM_InDirect(unsigned int sem_m)
*
*   @b ܣ
*   @n semaphoreӷʷʽӷʻSEMINTжźţжʹá
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEM_InDirect(unsigned int sem_m)
{
	volatile int* indirect;
	indirect = ( int *)SEM_INDIRECT;
	indirect[sem_m] = 0;
	asm(" MFENCE ");    
	asm(" nop 1");
}


/**
********************************************************************************
*   @n@b SEM_ReadID(unsigned int sem_m)
*
*   @b ܣ
*   @n ӷģʽȡռsemaphore ID
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n CoreID  غID
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
int SEM_ReadID(unsigned int sem_m)
{
	volatile int* query;
	volatile int  CoreID;
	query = ( int *)SEM_QUERY;
	CoreID = (query[sem_m]) >> 8;
	asm(" MFENCE ");    
	asm(" nop 1");
	return CoreID;
}


/**
********************************************************************************
*   @n@b SEM_Combination(unsigned int sem_m)
*
*   @b ܣ
*   @n semaphoreźŵơ
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n request	Ϊ1ʱźŵƿвռãΪ0ʱźŵƷǿвռ
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
//int SEM_Combination(unsigned int sem_m)
//{
//	volatile int* query;
//	volatile int free;
//	query = ( int *)SEM_QUERY;
//	query[sem_m] = 0;
//}
int SEM_Combination(unsigned int sem_m)
{
	volatile int* indirect;
	volatile int request;
	indirect = (int *)SEM_INDIRECT;
	request = indirect[sem_m] & 0x1;
	asm(" MFENCE ");    
	asm(" nop 1");
	return request;
}

/**
********************************************************************************
*   @n@b SEM_Free(unsigned int sem_m)
*
*   @b ܣ
*   @n semaphoreвѯ
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n free		Ϊ1ʱźŵƿ
				Ϊ0ʱźŵƷǿ
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
int SEM_Free(unsigned int sem_m)
{
	volatile int* query;
	volatile int free;
	query = ( int *)SEM_QUERY;
	free = query[sem_m] & 0x1;
	asm(" MFENCE ");    
	asm(" nop 1");
	return free;
}

/**
********************************************************************************
*   @n@b SEM_EOI(unsigned int coren)
*
*   @b ܣ
*   @n semaphoreвѯ
*
*   @b βΣ
*   @verbatim
*		coren	źŵжϺţ0~11ΪӦSEMINT0~SEMINT110x20ӦSEMERR
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEM_EOI(unsigned int coren)
{
	*( int *)SEM_EOI_REG = coren;
	asm(" MFENCE ");    
	asm(" nop 1");
}



/**
********************************************************************************
*   @n@b SEM_EOI(unsigned int coren)
*
*   @b ܣ
*   @n  semaphoreͷ
*
*   @b βΣ
*   @verbatim
*		sem_m	źŵƱ0-63
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEM_Release(unsigned int sem_m)
{
	volatile int* direct;
	direct = ( int *)SEM_DIRECT;
	direct[sem_m] = 0x1;
	asm(" MFENCE ");    
	asm(" nop 1");
}


/**
********************************************************************************
*   @n@b SEMERR_CLEAR()
*
*   @b ܣ
*   @n  semaphore
*
*   @b βΣ
*   @verbatim
*
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEMERR_CLEAR()
{
   *(int*)SEMERR_CLEARREG = 1;
   asm(" MFENCE ");    
	asm(" nop 1");
}


/**
********************************************************************************
*   @n@b SEMERR_SET(unsigned int err)
*
*   @b ܣ
*   @n  semaphore,ԺͲ
*
*   @b βΣ
*   @verbatim
*       err		00h		޴
*				01h		ظͷŴ
*				02h		ǷͷŴ
*				03h		ӵظ
*				04h		δӵظ
*   @endverbatim
*
*   <b> ֵ </b>
*   @n 
*
*   <b> ע </b>
*   @n 
*******************************************************************************
**/
void SEMERR_SET(unsigned int err)
{
	int *direct;
	direct = (int*)SEMERR_SETREG;
	*direct = 0x7 & err;
   asm(" MFENCE ");    
	asm(" nop 1");
}
