/** 
********************************************************************************
* @file       M6678E_Timer.c
* @brief      M6678E TimerصĽӿں
* @version    V1.0
* @date       2024.1.18
* @attention  ѡͬģʽڼ㷽ʽǲһġ
*			      ƵʱƵʼʾ
*  			      ʱģʽģʽʱжϲƵΪDSPƵ/12/( ڼĴֵ + 1)
*  			  TOUTƵʣ
* 						ʱģʽDSPƵ/24/( ڼĴֵ + 1)
* 						ģʽDSPƵ/12/( ڼĴֵ + 1)
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
**/
#include "M6678E_TIMER.h"

/** @addtogroup TIMER_FUNCTION
 @{ */


typedef struct  _Timer_Regs{
		unsigned int RSVD0;
		unsigned int EMUMGT;
		unsigned int RSVD1[2];
		unsigned int CNTLO;
		unsigned int CNTHI;
		unsigned int PRDLO;
		unsigned int PRDHI;
		unsigned int TCRreg;     /*ƼĴ*/
		unsigned int TGCR;       /*ȫֿƼĴ*/
}Timer_Regs;
Timer_Regs * timerx;

/**
********************************************************************************
 *   @n@b Timer64_Config(unsigned int Numb,long long Period,unsigned int Mode)
 *
 *   @b ܣ
 *   @n 64λʱ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *       Period ʱ
 *       Mode   ʱģʽ1Ϊѭ0Ϊμ2Ϊصѭ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n  Period = ʱʱ()/12 -1
 *******************************************************************************
 */
void Timer64_Config(unsigned int Numb,long long Period,unsigned int Mode)
{

	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/
	/*Ĵ*/
	timerx->PRDLO = (unsigned int)Period;
	timerx->PRDHI = (unsigned int)(Period>>32);
	timerx->CNTLO = 0;
	timerx->CNTHI = 0;
	/*ѭһμ*/
	if(Mode == 1)
		timerx->TCRreg = 0x80;
	else if(Mode == 0)
		timerx->TCRreg = 0x40;
	else if(Mode == 2)
		timerx->TCRreg = 0xC0;

	/*64λʱ*/
	timerx->TGCR = 0x0;
}

/**
********************************************************************************
 *   @n@b Timer32_Link_Config(unsigned int Numb,unsigned int PRDHI_Value,unsigned int PRDLO_Value,unsigned int Mode)
 *
 *   @b ܣ
 *   @n ˫32λʱģʽ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *       PRDHI_Value  32λƵڼĴ
 *       PRDLO_Value  32λʱڼĴ
 *       Mode   ʱģʽ1Ϊѭ0Ϊμ2Ϊصѭ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n (PRDHI_Value+1)*(PRDLO_Value+1) = ʱʱ()/12
 *******************************************************************************
 */
void Timer32_Link_Config(unsigned int Numb,unsigned int PRDHI_Value,unsigned int PRDLO_Value,unsigned int Mode)
{

	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/
	/*Ĵ*/
	timerx->PRDLO = PRDHI_Value ;
	timerx->PRDHI = PRDLO_Value ;
	timerx->CNTLO = 0;
	timerx->CNTHI = 0;
	/*ѭһμ*/
	if(Mode == 1)
		timerx->TCRreg = 0x80;
	else if(Mode == 0)
		timerx->TCRreg = 0x40;
	else if(Mode == 2)
		timerx->TCRreg = 0xC0;

	/*32λʱ*/
	timerx->TGCR = 0xC;
}

/**
********************************************************************************
 *   @n@bTimer32_NOLink_TIMLO_Config(unsigned int Numb,unsigned int PRDLO_Value,unsigned int Mode)
 *
 *   @b ܣ
 *   @n ˫32λʱģʽ  Ƶλ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *         PSCHI_Value  Ƶλ(4λ)
 *         PRDHI_Value  ʱڼĴ
 *         Mode   ʱģʽ1Ϊѭ0Ϊμ2Ϊصѭ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n (PSCHI_Value+1)*(PRDHI_Value+1) = ʱʱ()/12
 *******************************************************************************
 */
void Timer32_NOLink_TIMHI_Config(unsigned int Numb,unsigned int PSCHI_Value,unsigned int PRDHI_Value,unsigned int Mode)
{
	volatile int TCRreg = 0;
	volatile int TGCR_Temp = 0 ;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/

	/*Ĵ*/
	timerx->PRDHI = PRDHI_Value ;
	timerx->CNTHI = 0;
	/*ѭһμ*/
	if(Mode == 1)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg |  (0x80<<16);
	}
	else if(Mode == 0)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg | (0x40<<16);
	}
	else if(Mode == 2)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg | (0xC0<<16);
	}
	/*TDDRHIPSCHIͬʱΪ32λģʽʱ*/
	TGCR_Temp = timerx->TGCR ;
	timerx->TGCR = TGCR_Temp |(PSCHI_Value << 8) | 0x4;
}

/**
********************************************************************************
 *   @n@b Timer32_NOLink_TIMLO_Config(unsigned int Numb,unsigned int PRDLO_Value,unsigned int Mode)
 *
 *   @b ܣ
 *   @n ˫32λʱģʽ
 *
 *   @b βΣ
 *   @verbatim
 *      Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *      PRDLO_Value  ʱڼĴ
 *      Mode   ʱģʽ1Ϊѭ0Ϊμ2Ϊصѭ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n (PRDLO_Value+1) = ʱʱ()/12
 *******************************************************************************
 */
void Timer32_NOLink_TIMLO_Config(unsigned int Numb,unsigned int PRDLO_Value,unsigned int Mode)
{
	int TCRreg = 0;
	int TGCR_Temp = 0 ;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/

	/*Ĵ*/
	timerx->PRDLO = PRDLO_Value ;
	timerx->CNTLO = 0;
	/*ѭһμ*/
	if(Mode == 1)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg| 0x80;
	}
	else if(Mode == 0)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg|0x40;
	}
	else if(Mode == 2)	{
		TCRreg = timerx->TCRreg ;
		timerx->TCRreg = TCRreg|0xC0;
	}		
	/*Ϊ32λģʽʱ*/
	TGCR_Temp = timerx->TGCR ;
	timerx->TGCR = TGCR_Temp | 0x4;
}

/**
********************************************************************************
 *   @n@b Timer_End(unsigned int Numb)
 *
 *   @b ܣ
 *   @n ʱֹͣ
 *   @b βΣ
 *   @verbatim
 *   Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Timer_End(unsigned int Numb)
{
	unsigned int Timer_TGCR;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/

	Timer_TGCR = timerx->TGCR;
	timerx->TGCR = Timer_TGCR & 0XFFFFFFFC;  /*浱ǰֵ*/
}

/**
********************************************************************************
 *   @n@b Timer_Out_Config(unsigned int Numb,unsigned int OutPutMode,unsigned int Polar)
 *
 *   @b ܣ
 *   @n ʱģʽ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *       OutPutMode  1Ϊʱģʽ0Ϊģʽ
 *       Polar       1Ϊ˫32λģʽ,0Ϊģʽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Timer_Out_Config(unsigned int Numb,unsigned int OutPutMode,unsigned int Polar)
{
	unsigned int Timer_TCRreg;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/

	Timer_TCRreg = timerx->TCRreg;
	if(Polar ==0 )
	{
		if(OutPutMode)
			timerx->TCRreg = Timer_TCRreg | 0x8;
		else
			timerx->TCRreg = Timer_TCRreg & 0xFFFFFFF7;
	}
	else
	{
		if(OutPutMode)
			timerx->TCRreg = Timer_TCRreg | 0x80008;
		else
			timerx->TCRreg = Timer_TCRreg & 0xFFF7FFF7;
	}
}

/**
********************************************************************************
 *   @n@b Timer_Start(unsigned int Numb)
 *
 *   @b ܣ
 *   @n ʱʼ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n Numb ʱ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int Timer_Start(unsigned int Numb)
{
	volatile unsigned int Timer_TGCR;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/
	Timer_TGCR = timerx ->TGCR;
	timerx ->TGCR = Timer_TGCR | 0x3;

	return Numb;
}

/**
********************************************************************************
 *   @n@b Timer_TimoSel(unsigned int Numb,unsigned int timo)
 *
 *   @b ܣ
 *   @n ʱ˿ѡ
 *
 *   @b βΣ
 *   @verbatim
 *      Numb   ʱ0~19
 *	    timo   ʱ˿ڣ0ΪTIMO0˿ڣ1ΪTIMO1˿   ֻʹ˵λ˿ڼĴ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 1.ʱΪ20˿ֻ2
 *      2.ֻͨTOUTLοͨ˺
 *******************************************************************************
 */
void Timer_TimoSel(unsigned int Numb,unsigned int timo)
{

	unsigned int ToutSel_Numb;
	unsigned int TOUTPSEL_Temp = 0;
	ToutSel_Numb = Numb << 1;
	if(timo == 0)
	{
		TOUTPSEL_Temp = *(unsigned int *)TOUTPSEL & 0xFFE0;
		*(unsigned int *)TOUTPSEL = TOUTPSEL_Temp + ToutSel_Numb;
	}
	else
	{
		TOUTPSEL_Temp = *(unsigned int *)TOUTPSEL & 0xFC1F;
		*(unsigned int *)TOUTPSEL = TOUTPSEL_Temp + (ToutSel_Numb<<6);   //*64
	}
}

/**
********************************************************************************
 *   @n@b Timer_EMUMGT_config(unsigned int Numb ,unsigned int EMUMGT_Numb)
 *
 *   @b ܣ
 *   @n  ʱģʽ
 *
 *   @b βΣ
 *   @verbatim
 *       Numb   TIMER 0-19   timer0~19λDSP core0~7˽,timer8~11ΪARM0~3,timer12~19Ϊ
 *	    EMUMGT_Numb	 ģʽѡλ
 *	                 0ʾʱֹͣ 
 *	                 1ʾʱֵﵽʱʱֹͣ
 *	                 2ʾʱУSOFTλ״̬
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Timer_EMUMGT_config(unsigned int Numb ,unsigned int EMUMGT_Numb)
{
	unsigned int EMUMGT_Temp = 0;
	timerx = (Timer_Regs *)(TIMER_BASE + ((Numb*8)<<12));   /*ѡTimer*/
	EMUMGT_Temp = (timerx->EMUMGT) & 0xFFFFFFFC;
	timerx->EMUMGT = ( EMUMGT_Temp | EMUMGT_Numb);
}
