/**
********************************************************************************
* @file       M6678E_UART.c
* @brief      ʵM6678E UARTõĸֽӿں
* @version    V1.0
* @date       2023.12.26
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_UART.h"

/** @addtogroup UART_FUNCTION
 @{ */
/**
********************************************************************************
 *   @n@b void UART_Init(UART_TypeDef *UARTDEV, uint32_t main_frq, uint32_t BaudRate)
 *
 *   @b ܣ
 *   @n UARTʼ
 *   @b βΣ
 *   @verbatim
 *      UARTDEV 	UART豸
 *	   	main_frq 	ϵͳƵ λMHz
 *	   	BaudRate 	
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Init(UART_TypeDef *UARTDEV, uint32_t main_frq, uint32_t BaudRate)
{
	uint32_t uart_in_clk = 0;
	float scaler = 0;
	uint32_t temp_t = 0;
	uint32_t temp_f = 0;

	printf("UARTʼ......\r\n");
	if(UARTDEV == DEV_UART0)
	{
		PSC_Open_Clk("UART", 1);
	}

	// 
	uart_in_clk = main_frq * 1000000;		// MHz to Hz
	uart_in_clk /= 4;						// Ƶϵ
	scaler = (float)uart_in_clk / (BaudRate*16);
	temp_t = (unsigned int)(scaler);
	temp_f = (unsigned int)((scaler - temp_t)*64 + 0.5);
	UARTDEV->UARTIBRD = temp_t;
	UARTDEV->UARTFBRD = temp_f;

	printf("UARTʼ, Ƶ:%dMHz, Ƶϵ:%f, :%d. \r\n",
			main_frq, scaler, BaudRate);

	UARTDEV->UARTLCR_H = (3<<5);	// 8λַλ
	UARTDEV->UARTCR = 0;
	UARTDEV->UARTCR |= (1<<0);	// UARTʹ
	UARTDEV->UARTCR |= (1<<8);	// ʹ
	UARTDEV->UARTCR |= (1<<9);	// ʹ
}
/**
********************************************************************************
 *   @n@b void UART_Transmit_Byte(UART_TypeDef *UARTDEV, uint8_t dat)
 *
 *   @b ܣ
 *   @n ڷһֽ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		dat			͵
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Transmit_Byte(UART_TypeDef *UARTDEV, uint8_t dat)
{
	while(!(UARTDEV->UARTFR & (1<<7)));		// ȴ
	UARTDEV->UARTDR = dat;     			// ݼĴдҪ͵
}
/**
********************************************************************************
 *   @n@b void UART_Receive_Byte(UART_TypeDef *UARTDEV, uint8_t *dat)
 *
 *   @b ܣ
 *   @n ڶȡһֽ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		dat			Ŷȡ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Receive_Byte(UART_TypeDef *UARTDEV, uint8_t *dat)
{
	while(!(UARTDEV->UARTFR & (1<<6)));	// ȴ
	*dat = UARTDEV->UARTDR;
}
/**
********************************************************************************
 *   @n@b void UART_Transmit(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data)
 *
 *   @b ܣ
 *   @n  ڷ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		dat_buf		͵
 *		Count_Data	ֽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Transmit(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data)
{
	unsigned int i = 0;
	// ***********************transmit*****************************************
	for(i=0;i<Count_Data;i++)
	{
		UART_Transmit_Byte(UARTDEV, dat_buf[i]);
	}
}
/**
********************************************************************************
 *   @n@b void UART_Receive(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data)
 *
 *   @b ܣ
 *   @n  ڷ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		dat_buf		յ
 *		Count_Data	ֽ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Receive(UART_TypeDef *UARTDEV, uint8_t *dat_buf, uint32_t Count_Data)
{
	unsigned int i = 0;

	// ***********************Receive*****************************************
	for(i=0;i<Count_Data;i++)
	{
		UART_Receive_Byte(UARTDEV, &dat_buf[i]);
	}
}

/**
********************************************************************************
 *   @n@b void UART_Print(UART_TypeDef *UARTDEV, char *src_dat)
 *
 *   @b ܣ
 *   @n  ڴӡַ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		src_dat		ַ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void UART_Print(UART_TypeDef *UARTDEV, char *src_dat)
{
	while((*src_dat) != '\0')
	{
		UART_Transmit_Byte(UARTDEV, *src_dat);
		src_dat++;
	}
 }


 /**
********************************************************************************
 *   @n@b int UART_Write_Read_Byte(UART_TypeDef *UARTDEV, unsigned char w_dat)
 *
 *   @b ܣ
 *   @n ڷͲȡһֽ
 *
 *   @b βΣ
 *   @verbatim
 *		UARTDEV		UART豸
 *		w_dat		Ͳȡһֽݵ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n  int 		-1ʾʧܣ 0ʾԳɹ
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
int UART_Write_Read_Byte(UART_TypeDef *UARTDEV, unsigned char w_dat)
{
	unsigned char temp = 0;
	UART_Transmit_Byte(UARTDEV, w_dat);
	UART_Receive_Byte(UARTDEV, &temp);

	printf("%x\r\n",temp);

	if(temp != w_dat)
		return -1;			// ʧ
	return 0;				// Գɹ
}

/**
********************************************************************************
 *   @n@b void Uart_delay(void)
 *
 *   @b ܣ
 *   @n ʱӺ
 *
 *   @b βΣ</b>
 *   @verbatim
 *		
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void Uart_delay(void)
{
	int x,y;
	for(x=0;x<1000;x++)
		for(y=0;y<1000;y++)
			asm(" nop 3 ");
}

/**
@}
*/
